reksidebar.ns(function() {

    reksidebar.data = {
        templates: {
        },

        init: function() {
            reksidebar.Rek.log('data init');
        },
        bmarkImport: function(browser,file,fname,cb) {
            var bmarks,reader,content,lines,idx;

            var _getLine = function() {
                if (lines.length > idx) {
                    result = $.trim(lines[idx]);
                    idx++
                } else {
                    result = null;
                }

                return result;
            }

            var _iterator = function(folder) {
                var line,o,arr;
                while ((line = _getLine()) !== null) {
                    if (line.match(/<\/dl>/i)) {
                        return;
                    }
                    if (line.match(/<dt>/i) && !line.match(/href/i)) {
                        o = {
                            title: reksidebar.Rek.xmlDecode($.trim(line.replace(/<\/?[^>]+(>|$)/g,''))),
                            items: []
                        }
                        folder.items.push(o);
                        _iterator(folder.items[folder.items.length-1]);
                    }
                    if (line.match(/href/i)) {
                        arr = line.match(/href="([^"]+)"/i);
                        o = {
                            title: reksidebar.Rek.xmlDecode($.trim(line.replace(/<\/?[^>]+(>|$)/g,''))),
                            uri: arr[1]
                        }
                        folder.items.push(o);
                    }
                }
                //return;
            }
            
            reader = new FileReader();
            reader.onload = function(e) {
                content = e.target.result;
                lines = content.split("\n");
                idx = 0;
            
                bmarks = {
                    title:fname,
                    items:[]
                };
            
                _iterator(bmarks);
                
                cb(bmarks);
            };
            reader.readAsText(file);
        },
        ffBmarkImport: function(fname) {
            var history = Components.classes["@mozilla.org/browser/nav-history-service;1"].getService(Components.interfaces.nsINavHistoryService),
            hOptions = history.getNewQueryOptions(),
            hQuery = history.getNewQuery(),
            bmark = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService),
            folders = [bmark.bookmarksMenuFolder,bmark.unfiledBookmarksFolder,bmark.toolbarFolder],
            folderNames = ['Bookmark Menu','Unsorted','Toolbar'],
            count = 0;

            var bmarks = {
                title:fname,
                uri:null,
                items:[]
            }

            var _func = function(parent,fid) {
                var result,rootNode,node,i;
                hQuery.setFolders([fid],1);
                result = history.executeQuery(hQuery,hOptions);
                rootNode = result.root;
                rootNode.containerOpen = true;
                // iterate over the immediate children of this folder and dump to console
                for (i=0; i < rootNode.childCount; i ++) {
                    count++;
                    node = rootNode.getChild(i);
                    switch (node.type) {
                        case node.RESULT_TYPE_URI:
                            parent.items.push({
                                title:reksidebar.Rek.xmlDecode(node.title),
                                uri:node.uri
                            });
                            break;
                        case node.RESULT_TYPE_FOLDER:
                            parent.items.push({
                                title:reksidebar.Rek.xmlDecode(node.title),
                                uri:null,
                                items:[]
                            })
                            _func(parent.items[parent.items.length-1],node.itemId);
                            break;
                        default:
                    //ignore
                    }
                }
                // close a container after using it!
                rootNode.containerOpen = false;
            }

            $.each(folders,function(i,v){
                bmarks.items.push({
                    title:folderNames[i],
                    uri:null,
                    items:[]
                });
                _func(bmarks.items[bmarks.items.length-1],v);
            });
            
            return {
                count: count,
                bmarks: bmarks
            };
        },

        uploadBmarks: function(userid,sessionid,bmarks,cb) {
            reksidebar.Rek.log(bmarks);
            $.ajax({
                type: 'POST',
                async: true,
                url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/importBmarks.php',
                data: {
                    id: userid,
                    session: sessionid,
                    bmarks: JSON.stringify(bmarks)
                },
                dataType: 'text',
                success: function(json){
                    reksidebar.Rek.log(json);
                    // update folders, then bookmarks
                    if (cb) cb.call();
                },
                error: function(req,status,error){
                    //$('.account-import-submit').attr('selectedIndex','0');
                    reksidebar.Rek.log('import firefox bookmarks failed');
                    reksidebar.Rek.validateStatus(status);
                }
            });
        }
    }
});
reksidebar.ns(function() {

    reksidebar.modal = {
        templates: {
            simple:['<description class="rekdialog-content-inner">{0}</description>'],
            insert:['{0}']
        },
        isopen: false,
        defaults: {
            id:'dialog1',
            template:'simple',
            title:'',
            icon:'comment.png',
            text:'',
            skip:'',
            beforeOpen: null,
            buttons:[{
                label:'OK',
                callback: function() {
                    reksidebar.modal.close(this);
                }
            }],
            canceled:false
        },
        init: function() {
            reksidebar.Rek.log('modal init');
        },
        layout: function(o) {
            var dlg = $('#'+o.id);
            var el,tag,str,domStr;
            if (dlg) {
                $(dlg).find('.rekdialog-title-value').val(o.title);
                $(dlg).find('.rekdialog-icon').attr('src','chrome://rekommend/skin/images/'+o.icon);
                $(dlg).find('.rekdialog-content').empty();
                if (!(o.text instanceof Array)) {
                    str = o.text;
                    o.text = [];
                    o.text.push(str);
                }
                domStr = this.templates[o.template].join().format(o.text.join(''));
                reksidebar.Rek.appendDOMfromString($(dlg).find('.rekdialog-content'),domStr);
                // empty button xul
                $(dlg).find('.rekdialog-buttons').empty();
                el = document.getElementById(o.id).getElementsByClassName('rekdialog-buttons')[0];
                if (o.skip) {
                    document.getElementById('modal-skip').setAttribute('hidden','false');
                } else {
                    document.getElementById('modal-skip').setAttribute('hidden','true');
                }
                $.each(o.buttons,function(i,v){
                    tag = document.createElement("button");
                    tag.setAttribute('label',v.label);
                    tag.addEventListener("command",function(){
                        o.canceled = (v.label == reksidebar.Rek.getProperty('cancel.label'));
                        v.callback.call(o);
                    },false);
                    el.appendChild(tag);
                });
                // add row binding
                reksidebar.Rek.log($('.addrow',dlg));
                $('.addrow',dlg).click(function(el){
                    var $row = $(this).parents('.inputrow');
                    $row.removeClass('last');
                    $row.clone(true).insertAfter($row).addClass('last');
                });

                return true;
            } else {
                //do nothing
                reksidebar.Rek.log('modal dialog error');
                return false;
            }
        },
        open: function(obj) {
            var doSkip,
            o = $.extend({},this.defaults,obj);
            if (o.skip) {
                doSkip = reksidebar.Rek.user.data.preferences[o.skip];
                document.getElementById('modal-skip').setAttribute('checked',doSkip?'true':'false');
            } else {
                document.getElementById('modal-skip').setAttribute('checked','false');
            }
            if (doSkip) {
                obj.buttons[0].callback.call(obj);
            }
            else if (this.layout(o)) {
                // call beforeOpen
                if (obj.beforeOpen) obj.beforeOpen.call(obj);
                // show the dialog
                $('.rekdialog').attr('hidden','true');
                $('#mask').attr('hidden','false');
                $('#'+o.id).attr('hidden','false');
                $('#dialog-wrapper').attr('hidden','false');
                this.isopen = true;
            } else {
        // do nothing
        }
        },
        openTimed: function(obj) {
            this.open(obj);
            setTimeout(function(){
                reksidebar.modal.close(obj);
            },10000);
        },
        close: function(o) {
            if (o.skip && !o.canceled) {
                var doSkip = (document.getElementById('modal-skip').getAttribute('checked') == 'true'?1:0);
                reksidebar.Rek.user.data.preferences[o.skip] = doSkip;
            }
            if ($('#dialog-wrapper').attr('hidden') == 'false') {
                $('#dialog-wrapper').attr('hidden','true');
                $('#'+o.id).attr('hidden','true');
                $('#mask').attr('hidden','true');
                this.isopen = false;
            }
        },
        isOpen: function() {
            return this.isopen;
        }
    }
});
reksidebar.ns(function() {

    reksidebar.treeMgr = {
        rekView: null,
        rekPopupView: null,
        friendView: null,
        view: {
            rowCount: 0,
            data: null,
            treeBox: null,
            selection: null,
            indexMap: null,
            lazyTimer: null,
            atom: Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService),
            DROP_BEFORE:-1,
            DROP_ON:0,
            DROP_AFTER:1,

            buildIndexMap: function() {
                var view = this;
                var idx = -1;
                view.indexMap = [];
                var iterate = function(node,arr,parent,level) {
                    for (var i=0;i<arr.length;i++) {
                        idx++;
                        var obj = {};
                        obj.node = arr[i];
                        if (obj.node.children.length == 0) obj.node.open = false;
                        obj.node.open = !!obj.node.open;
                        obj.level = level;
                        obj.node.parentNode = node;
                        obj.node.parentIndex = i;
                        obj.parent = parent;
                        obj.sibling = (arr.length > 1 && i != arr.length-1);
                        view.indexMap.push(obj);
                        if (obj.node.children.length && obj.node.open) {
                            iterate(obj.node,obj.node.children,idx,level+1);
                        }
                    }
                }
                iterate(null,this.data,-1,0);
            },
            getIdxById: function(id) {
                var idx = -1;
                for (var i=0;i<this.indexMap.length;i++) {
                    if (this.indexMap[i].node.id == id) {
                        idx = i;
                        break;
                    }
                }
                return idx;
            },
            getNode: function(id) {
                var node = null;
                var iterate = function(arr,parent) {
                    for (var i=0;i<arr.length;i++) {
                        arr[i].parentNode = parent;
                        if (arr[i].id == id) node = arr[i];
                        if (!node && arr[i].children.length) {
                            iterate(arr[i].children,arr[i]);
                        }
                    }
                }
                iterate(this.data,null);
                return node;
            },
            getRowChildrenCount: function(idx) {
                // returns the number of rows of indexed row and all visible children
                var count = 1; // include the row
                var level = this.indexMap[idx].level;
                for (var i=idx+1;i<this.indexMap.length;i++) {
                    if (this.indexMap[i].level <= level) break;
                    count++;
                }
                return count;
            },
            getRowCount: function() {
                return this.indexMap.length;
            },
            setTree: function(treeBox)         {
                this.treeBox = treeBox;
            },
            getCellText: function(idx,column)  {
                //return this.getNode(idx).name;
                return this.indexMap[idx].node.name;
            },
            sort: function(node,invalidate) {
                var i,start,idx;
                // get current selected node id
                var sel = this.indexMap[this.selection.currentIndex].node.id;
                var sortFunc = function(arr,startIndex) {
                    var i,j,o,done;
                    for (i=startIndex+1;i<arr.length;i++) {
                        o = arr[i];
                        j = i - 1;
                        done = false;
                        do {
                            switch (reksidebar.Rek.user.data.preferences['tree_sort']) {
                                case 'date':
                                    if (arr[j].date < o.date) {
                                        arr[j+1] = arr[j];
                                        j = j - 1;
                                        if (j < startIndex) done = true;
                                    } else
                                        done = true;
                                    break;
                                case 'name':
                                    if (arr[j].name.toLowerCase() > o.name.toLowerCase()) {
                                        arr[j+1] = arr[j];
                                        j = j - 1;
                                        if (j < startIndex) done = true;
                                    } else
                                        done = true;
                                    break;
                                case 'named':
                                    if (arr[j].name.toLowerCase() < o.name.toLowerCase()) {
                                        arr[j+1] = arr[j];
                                        j = j - 1;
                                        if (j < startIndex) done = true;
                                    } else
                                        done = true;
                                    break;
                                default:
                                    if (arr[j].sequence > o.sequence) {
                                        arr[j+1] = arr[j];
                                        j = j - 1;
                                        if (j < startIndex) done = true;
                                    } else
                                        done = true;
                                    break;
                            }
                            
                        } while (!done);
                        arr[j+1] = o;
                    }
                };
                var iterator = function(arr,start) {
                    for (var i=0;i<arr.length;i++) {
                        sortFunc(arr,start);
                        if (arr[i].children.length > 0) iterator(arr[i].children,0);
                    }
                };
                if (node == null) {
                    // sort the entire tree
                    reksidebar.Rek.log('sorting...');
                    iterator(this.data,1);
                    //reksidebar.Rek.log(this.data);
                } else {
                    // sort the node array (do not iterate)
                    if (node.parentNode == null || node.id == this.indexMap[0].node.id) {
                        arr = this.data;
                        start = 1;
                    } else {
                        arr = node.parentNode.children;
                        start = 0;
                    }
                    sortFunc(arr,start);
                }
                this.lazyUpdate();
                if (invalidate && this.treeBox) {
                    this.buildIndexMap();
                    if (this.treeBox) this.treeBox.invalidate();
                    idx = this.getIdxById(sel);
                    this.selection.select(idx);
                    this.treeBox.ensureRowIsVisible(idx);
                }
            },
            setCellText: function(idx,col,text) {
                var node;
                var view = this;
                if (text.length) {
                    node = this.indexMap[idx].node;
                    node.name = text;
                    this.indexMap[idx].node.name = text;
                    this.treeBox.invalidateRow(idx);
                    this.lazyUpdate();
                    //if (reksidebar.Rek.user.data.preferences.tree_sort == 'name') {
                    // do a sort by name - workaround to let the function exit - do a timed delay sort
                    // can't get it to work inside this function for some reason
                    setTimeout(function(){
                        view.sort(node,true);
                    },100);
                //}
                }
            },
            setCellTextById: function(id,text) {
                var node;
                var idx = this.getIdxById(id);
                if (idx != -1) {
                    // currently visible
                    this.setCellText(this.getIdxById(id),0,text);
                } else {
                    reksidebar.Rek.log('not visible');
                    // not visible - update source tree
                    node = this.getNode(id);
                    node.name = text;
                    //this.sort(node,false);
                    this.lazyUpdate();
                }
            },
            isContainer: function(idx)         {
                return idx!=0;
            },
            isContainerOpen: function(idx)     {
                //return this.getNode(idx).open;
                //if (this.indexMap[idx].node.children.length == 0) this.indexMap[idx].node.open = false;
                return this.indexMap[idx].node.open;
            },
            isContainerEmpty: function(idx)    {
                //return this.getNode(idx).children.length == 0;
                return this.indexMap[idx].node.children.length == 0;
            },
            isSeparator: function(idx)         {
                return false;
            },
            isSorted: function()               {
                return false;
            },
            isEditable: function(idx, column)  {
                return idx!=0;
            },
            getParentIndex: function(idx)      {
                //return this.getNode(idx).parent;
                return this.indexMap[idx].parent;
            },
            getLevel: function(idx)            {
                return this.indexMap[idx].level;
            },
            hasNextSibling: function(idx, after) {
                return this.indexMap[idx].sibling;
            },
            isChild: function(id,node) {
                var result = false;
                var iterate = function(arr) {
                    for (var i=0;i<arr.length;i++) {
                        if (arr[i].id == id) {
                            result = true;
                            break;
                        }
                        if (!result && arr[i].children.length) iterate(arr[i].children);
                    }
                }
                if (node.children.length) iterate(node.children);
                return result;
            },
            toggleOpenState: function(idx) {
                var oldRowCount = this.indexMap.length;
                var item = this.indexMap[idx].node;
                item.open = !item.open;
                this.buildIndexMap();
                this.rowCount = this.indexMap.length;
                this.treeBox.rowCountChanged(idx + 1,this.rowCount-oldRowCount);
                if (this.rowCount > oldRowCount) this.treeBox.invalidateRange(idx,idx+this.rowCount-oldRowCount);
                else this.treeBox.invalidateRow(idx);
                this.treeBox.invalidate();
            },
            getImageSrc: function(idx, column) {},
            getProgressMode : function(idx,column) {},
            getCellValue: function(idx, column) {},
            cycleHeader: function(col, elem) {},
            selectionChanged: function() {},
            cycleCell: function(idx, column) {},
            performAction: function(action) {},
            performActionOnCell: function(action, index, column) {},
            getRowProperties: function(idx, column, prop) {},
            getCellProperties: function(idx, column, prop) {
                var property;
                if (idx == 0) {
                    property = this.atom.getAtom("default");
                    prop.AppendElement(property);
                }
            },
            getColumnProperties: function(column, element, prop) {},

            // drag and drop
            dragStart: function(event) {
                var sel = this.selection.currentIndex;
                var data = {
                    id:this.indexMap[sel].node.id,
                    parent:this.indexMap[sel].parent
                };
                if (sel > 0) event.dataTransfer.setData('application/x-node',JSON.stringify(data));
            },
            canDrop: function(idx,orient,data) {
                var node = JSON.parse(data.getData('application/x-node'));
                var tgtId = this.indexMap[idx].node.id;
                var result = true;
                if (tgtId == node.id) result = false;
                else if (reksidebar.Rek.user.data.preferences.tree_sort != 'sequence' && this.getParentIndex(idx)==this.getParentIndex(this.getIdxById(node.id)) && (orient == this.DROP_BEFORE || orient == this.DROP_AFTER)) result = false; // don't allow reordering if sort != sequence
                else if (idx == 0 && orient != this.DROP_AFTER) result = false; // cannot drop on
                else if (idx == node.parent && orient == this.DROP_ON) result=false; // cannot drop onto parent - does nothing
                else if (this.isChild(tgtId,this.getNode(node.id))) result=false; // do not alllow drag to own children - only to siblings or above
                return result;
            },
            drop: function(idx,orient,data) {
                var node = this.getNode(JSON.parse(data.getData('application/x-node')).id);
                var dest = this.getNode(this.indexMap[idx].node.id);
                // move the node
                this.moveNode(node,dest,orient);
            },

            // update db functions
            lazyUpdate: function() {
                reksidebar.Rek.log('lazy update tree');
                var view = this;
                if (view.lazyTimer) clearTimeout(view.lazyTimer);
                this.lazyTimer = setTimeout(function(){
                    view.update();
                },30000);
                // brodcast the change
                // needed a timer because inline editing posts multiple updates
                if (view.brodcastTimer) clearTimeout(view.brodcastTimer);
                this.brodcastTimer = setTimeout(function(){
                    view.broadcastUpdate(view.id);
                },300);
            },
            update: function() {
                reksidebar.Rek.log('update tree data');
                var view = this;
                if (view.lazyTimer) {
                    clearTimeout(view.lazyTimer);
                    view.lazyTimer = null;
                }
                // reconstruct the data object to remove linked objects - which cause a recursion problem for JSON
                var data = [];
                var iterate = function(data,arr) {
                    for (var i=0;i<arr.length;i++) {
                        var obj={};
                        obj.id = arr[i].id;
                        obj.name = arr[i].name;
                        obj.children = [];
                        data.push(obj);
                        if (arr[i].children.length) iterate(obj.children,arr[i].children)
                    }
                }
                iterate(data,view.data);
                // make the ajax call
                reksidebar.Rek.log('update tree');
                $.ajax({
                    type: 'POST',
                    async: true,
                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/updateTree.php',
                    data: {
                        id: reksidebar.Rek.user.id,
                        session: reksidebar.Rek.user.session,
                        tree: JSON.stringify(data)
                    },
                    dataType: 'text',
                    success: function(text){
                        // do nothing?
                        reksidebar.Rek.log(text);
                    },
                    error: function(req,status,error){
                        reksidebar.Rek.log('update tree failed');
                        reksidebar.Rek.validateStatus(status);
                    }
                });
            },
            reload: function(viewId,cb) {
                var view = this;
                $.ajax({
                    type: 'POST',
                    async: true,
                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/reloadTree.php',
                    data: {
                        id: reksidebar.Rek.user.id,
                        session: reksidebar.Rek.user.session,
                        tree: 'rek'
                    },
                    dataType: 'json',
                    success: function(json){
                        //reksidebar.Rek.log(json);
                        var oldCount = view.indexMap.length;
                        view.data = json.tree;
                        reksidebar.Rek.user.data.rekTree = json.tree;
                        view.buildIndexMap();
                        view.rowCount = view.getRowCount();
                        view.treeBox.rowCountChanged(view.rowCount,view.rowCount-oldCount);
                        view.treeBox.invalidate();
                        view.broadcastUpdate(viewId);
                        if (cb) cb.call();
                    },
                    error: function(req,status,error){
                        reksidebar.Rek.log('reload tree failed');
                        reksidebar.Rek.validateStatus(status);
                    }
                });
            },
            broadcastUpdate: function(viewId) {
                reksidebar.Rek.log('treeMgr boadcast update - '+viewId);
                var v,view,oldCount;
                reksidebar.Rek.log(viewId);
                switch (viewId) {
                    case 'rekView':
                        v = parseInt($('#broadcastTreeUpdate').attr('rek'))+1;
                        $('#broadcastTreeUpdate').attr('rek',v.toString());
                        break;
                    case 'rekPopupView':
                        reksidebar.bmark.invalidateTrees();
                        // update the master tree
                        view = reksidebar.treeMgr.rekView;
                        oldCount = view.getRowCount();
                        view.buildIndexMap();
                        view.rowCount = view.getRowCount();
                        view.treeBox.rowCountChanged(0,view.rowCount-oldCount);
                        view.treeBox.invalidate();
                        v = parseInt($('#broadcastTreeUpdate').attr('rek'))+1;
                        $('#broadcastTreeUpdate').attr('rek',v.toString());
                        break;
                    case 'friendView':
                        v = parseInt($('#broadcastTreeUpdate').attr('friend'))+1;
                        $('#broadcastTreeUpdate').attr('friend',v.toString());
                        break;
                }
            },
            // add new directory
            addRow: function(inRoot,edit,callback) {
                var sel,parent,parentId,newIdx;
                var view = this;
                var tree = $(view.treeBox.treeBody).parent()[0];
                // get current selected index
                if (typeof(view.selection.currentIndex) == 'undefined' || inRoot) sel = 0;
                else sel = view.selection.currentIndex;
                if (sel == -1) sel = 0;
                reksidebar.Rek.log(view.isContainerOpen(sel));
                //parent = this.indexMap[sel].node.parentNode;
                //if (parent) parentId = parent.id;
                //else parentId = this.indexMap[0].node.id;
                this.addNode(reksidebar.Rek.getProperty('rek.newTreeNodeName'),view.indexMap[sel].node.id,function(id){
                    if (!view.isContainerOpen(sel)) view.toggleOpenState(sel);
                    newIdx = view.getIdxById(id);
                    if (edit) {
                        view.treeBox.ensureRowIsVisible(newIdx);
                        tree.focus();
                        view.selection.select(newIdx);
                        tree.startEditing(newIdx,view.treeBox.columns.getFirstColumn());
                    }
                    if (callback) callback(id);
                });
            },
            removeRows: function(arr) {
                reksidebar.Rek.log('treeMgr remove');
                var node,data,oldCount,view = this;
                oldCount = view.getRowCount();
                if (arr.length) {
                    $.ajax({
                        type: 'POST',
                        async: true,
                        url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/dbRemoveRecords.php',
                        data: {
                            id: reksidebar.Rek.user.id,
                            session: reksidebar.Rek.user.session,
                            table: 'tree_node',
                            arr: JSON.stringify(arr)
                        },
                        dataType: 'json',
                        success: function(json){
                            //json = JSON.parse(text);
                            $.each(arr,function(i,v) {
                                node = view.getNode(v);
                                if (node) {
                                    data = node.parentNode?node.parentNode.children:view.data;
                                    $.each(data,function(j,u){
                                        // splice the node out of tree
                                        if (u.id == node.id) {
                                            data = data.splice(j,1);
                                            return false;
                                        }
                                    });
                                }
                            });
                            view.buildIndexMap();
                            view.rowCount = view.getRowCount();
                            view.treeBox.rowCountChanged(0,view.rowCount-oldCount);
                            view.treeBox.invalidate();
                            view.broadcastUpdate(view.id);
                        },
                        error: function(req,status,error){
                            reksidebar.Rek.log('remove tree rows failed');
                            reksidebar.Rek.validateStatus(status);
                        }
                    });
                }
            },
            addNode: function(name,parentId,callback) {
                var view = this;
                var oldCount = view.getRowCount();
                $.ajax({
                    type: 'POST',
                    async: true,
                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/addTreeNode.php',
                    data: {
                        id: reksidebar.Rek.user.id,
                        session: reksidebar.Rek.user.session,
                        //parentId: this.indexMap[0].node.id,
                        parentId: parentId,
                        name: name
                    },
                    dataType: 'text',
                    success: function(text){
                        reksidebar.Rek.log(text);
                        var json = JSON.parse(text);
                        //reksidebar.Rek.log(json);
                        var i,done;
                        var rec = {
                            id: json.id,
                            name: name,
                            sequence: json.sequence,
                            date: json.date,
                            open: false,
                            browseOpen: false,
                            count: 0,
                            children: []
                        };

                        // sort the new folder into the source user data object (preference: tree_sort)
                        done = false;
                        if (parentId == view.indexMap[0].node.id) {
                            switch (reksidebar.Rek.user.data.preferences['tree_sort']) {
                                case 'date':
                                    for (i=1;i<=view.data.length-1;i++) {
                                        if (json.date > view.data[i].date) {
                                            view.data.splice(i,0,rec);
                                            done = true;
                                            break;
                                        }
                                    }
                                    break;
                                case 'name':
                                    for (i=1;i<=view.data.length-1;i++) {
                                        if (name.toLowerCase() < view.data[i].name.toLowerCase()) {
                                            view.data.splice(i,0,rec);
                                            done = true;
                                            break;
                                        }
                                    }
                                    break;
                                case 'named':
                                    for (i=1;i<=view.data.length-1;i++) {
                                        if (name.toLowerCase() > view.data[i].name.toLowerCase()) {
                                            view.data.splice(i,0,rec);
                                            done = true;
                                            break;
                                        }
                                    }
                                    break;
                                default:
                                // no sort (sequence)
                            }
                            if (!done) view.data.splice(view.data.length,0,rec);
                        } else {
                            var children = view.getNode(parentId).children;
                            switch (reksidebar.Rek.user.data.preferences['tree_sort']) {
                                case 'date':
                                    for (i=0;i<=children.length-1;i++) {
                                        if (json.date > children[i].date) {
                                            children.splice(i,0,rec);
                                            done = true;
                                            break;
                                        }
                                    }
                                    break;
                                case 'name':
                                    for (i=0;i<=children.length-1;i++) {
                                        if (name.toLowerCase() <= children[i].name.toLowerCase()) {
                                            children.splice(i,0,rec);
                                            done = true;
                                            break;
                                        }
                                    }
                                    break;
                                case 'named':
                                    for (i=0;i<=children.length-1;i++) {
                                        if (name.toLowerCase() > children[i].name.toLowerCase()) {
                                            children.splice(i,0,rec);
                                            done = true;
                                            break;
                                        }
                                    }
                                    break;
                                default:
                                // no sort (sequence)
                            }
                            if (!done) children.splice(children.length,0,rec);
                        }
                        view.buildIndexMap();
                        view.rowCount = view.getRowCount();
                        view.treeBox.rowCountChanged(view.rowCount,view.rowCount-oldCount);
                        view.treeBox.invalidate();
                        view.lazyUpdate();
                        callback(json.id);
                    },
                    error: function(req,status,error){
                        reksidebar.Rek.log('insert tree node failed');
                        reksidebar.Rek.validateStatus(status);
                    }
                });
            },
            moveNode: function(node,dest,orient) {
                var i = 0,arr,done;
                var oldRowCount = this.indexMap.length;
                var idx = this.getIdxById(node.id);
                switch (orient) {
                    case this.DROP_BEFORE:
                    case this.DROP_AFTER:
                        var additive = 0;
                        if (orient == this.DROP_AFTER) additive = 1;
                        if (node.parentNode == null) {
                            this.data.splice(node.parentIndex,1);
                            if (dest.parentNode == null && (node.parentIndex < dest.parentIndex)) dest.parentIndex -= 1;
                        } else {
                            node.parentNode.children.splice(node.parentIndex,1);
                            if (dest.parentNode != null)
                                if ((node.parentNode.id == dest.parentNode.id) && (node.parentIndex < dest.parentIndex)) dest.parentIndex -= 1;
                        }
                        switch (reksidebar.Rek.user.data.preferences.tree_sort) {
                            case 'name':
                                if (dest.parentNode == null) {
                                    i = 1;
                                    arr = this.data;
                                } else {
                                    i = 0;
                                    arr = dest.parentNode.children;
                                }
                                done = false;
                                for (i;i<=arr.length-1;i++) {
                                    if (node.name.toLowerCase() <= arr[i].name.toLowerCase()) {
                                        arr.splice(i,0,node);
                                        done = true;
                                        break;
                                    }
                                }
                                if (!done) arr.splice(arr.length,0,node);
                                break;
                            case 'named':
                                if (dest.parentNode == null) {
                                    i = 1;
                                    arr = this.data;
                                } else {
                                    i = 0;
                                    arr = dest.parentNode.children;
                                }
                                done = false;
                                for (i;i<=arr.length-1;i++) {
                                    if (node.name.toLowerCase() > arr[i].name.toLowerCase()) {
                                        arr.splice(i,0,node);
                                        done = true;
                                        break;
                                    }
                                }
                                if (!done) arr.splice(arr.length,0,node);
                                break;
                            case 'date':
                                if (dest.parentNode == null) {
                                    i = 1;
                                    arr = this.data;
                                } else {
                                    i = 0;
                                    arr = dest.parentNode.children;
                                }
                                done = false;
                                for (i;i<=arr.length-1;i++) {
                                    if (node.date > arr[i].date) {
                                        arr.splice(i,0,node);
                                        done = true;
                                        break;
                                    }
                                }
                                if (!done) arr.splice(arr.length,0,node);
                                break;
                            default:
                                if (dest.parentNode == null) {
                                    this.data.splice(dest.parentIndex+additive,0,node);
                                } else {
                                    dest.parentNode.children.splice(dest.parentIndex+additive,0,node);
                                }
                        }
                        this.buildIndexMap();
                        this.rowCount = this.indexMap.length;
                        this.treeBox.rowCountChanged(idx + 1,this.rowCount-oldRowCount);
                        this.treeBox.invalidate();
                        if (idx != -1) this.selection.select(this.getIdxById(node.id));
                        break;
                    case this.DROP_ON:
                        switch (reksidebar.Rek.user.data.preferences.tree_sort) {
                            case 'name':
                                done = false;
                                for (i=0;i<=dest.children.length-1;i++) {
                                    if (node.name.toLowerCase() <= dest.children[i].name.toLowerCase()) {
                                        dest.children.splice(i,0,node);
                                        done = true;
                                        break;
                                    }
                                }
                                if (!done) dest.children.splice(dest.children.length,0,node);
                                break;
                            case 'named':
                                done = false;
                                for (i=0;i<=dest.children.length-1;i++) {
                                    if (node.name.toLowerCase() >= dest.children[i].name.toLowerCase()) {
                                        dest.children.splice(i,0,node);
                                        done = true;
                                        break;
                                    }
                                }
                                if (!done) dest.children.splice(dest.children.length,0,node);
                                break;
                            case 'date':
                                done = false;
                                for (i=0;i<=dest.children.length-1;i++) {
                                    if (node.date >= dest.children[i].date) {
                                        dest.children.splice(i,0,node);
                                        done = true;
                                        break;
                                    }
                                }
                                if (!done) dest.children.splice(dest.children.length,0,node);
                                break;
                           default:
                                dest.children.splice(0,0,node);
                        }
                        if (node.parentNode === null) {
                            this.data.splice(node.parentIndex,1);
                        } else {
                            node.parentNode.children.splice(node.parentIndex,1);
                        }
                        this.buildIndexMap();
                        this.rowCount = this.indexMap.length;
                        this.treeBox.rowCountChanged(idx + 1,this.rowCount-oldRowCount);
                        //if (this.rowCount > oldRowCount) this.treeBox.invalidateRange(idx,idx+this.rowCount-oldRowCount);
                        //else this.treeBox.invalidateRow(idx);
                        this.treeBox.invalidate();
                        if (idx != -1) this.selection.select(this.getIdxById(dest.id));
                        break;
                }
                this.lazyUpdate();
            }
        },
        init: function() {
            reksidebar.Rek.log('treeMgr init');
            // rek/bookmark tree
            this.rekView = $.extend({id:'rekView'},this.view);
            this.rekView.data = reksidebar.Rek.user.data.rekTree;
            this.rekView.buildIndexMap();
            this.rekView.rowCount = this.rekView.getRowCount();
            // friend tree
            this.friendView = $.extend({id:'friendView'},this.view);
            this.friendView.data = [];
            this.friendView.buildIndexMap();
            this.friendView.rowCount = this.rekView.getRowCount();
        },
        getNodeFlatList: function(id) {
            var data;
            var result = [];
            switch (id) {
                case 'rekView':
                    data = this.rekView.data;
                    break;
                case 'friendView':
                    data = [];
                    break;
            }
            var iterate = function(arr) {
                for (var i=0;i<arr.length;i++) {
                    result.push({
                        id:arr[i].id,
                        name:arr[i].name
                    });
                    if (arr[i].children.length) {
                        iterate(arr[i].children);
                    }
                }
            }
            iterate(data);

            return result;
        },
        showRekViewPopup: function(type,callback) {
            var rekView,tree;
            var template=[
            '<vbox id="rekPopup-folder-wrapper">',
            '<hbox class="toolbar">',
            '<hbox class="rekbutton" onclick="reksidebar.treeMgr.rekPopupView.addRow(true,true);">',
            '<vbox pack="center">',
            '<description value="New Root Folder"/>',
            '</vbox>',
            '</hbox>',
            '<hbox class="rekbutton" onclick="reksidebar.treeMgr.rekPopupView.addRow(false,true);">',
            '<vbox pack="center">',
            '<description value="New Sub Folder"/>',
            '</vbox>',
            '</hbox>',
            '<spacer flex="1"/>',
            '</hbox>',
            '<hbox id="rekPopup-folder-content" flex="1">',
            '<tree id="rekPopup-folder-tree" class="rek-dir-tree" hidecolumnpicker="true" seltype="single" editable="true" treelines="false" flex="1">',
            '<treecols>',
            '<treecol primary="true" label="" value="" flex="1"/>',
            '</treecols>',
            '<treechildren ondragstart="reksidebar.treeMgr.rekPopupView.dragStart(event);"/>',
            '</tree>',
            '</hbox>',
            '</vbox>',
            ];
            rekView = this.getImbeddedRekView(type);
            this.rekPopupView = rekView;
            reksidebar.modal.open({
                id:'dialog2',
                title:reksidebar.Rek.getProperty('rek.treeMgr.select'),
                text:template.join(''),
                buttons:[{
                    label:'Select',
                    callback: function() {
                        if (!$('#rekPopup-folder-tree')[0].currentIndex) $('#rekPopup-folder-tree')[0].view.selection.select(0);
                        if (callback) callback(rekView.indexMap[$('#rekPopup-folder-tree')[0].currentIndex].node);
                        reksidebar.treeMgr.releaseImbeddedView();
                        reksidebar.modal.close(this);
                    }
                },{
                    label:'Cancel',
                    callback: function(){
                        reksidebar.modal.close(this);
                        if (callback) callback({
                            id:0
                        });
                        reksidebar.treeMgr.releaseImbeddedView();
                    }
                }]
            });
            tree =  $('#rekPopup-folder-tree')[0];
            tree.view = rekView;
            tree.view.selection.select(0);
            tree.focus();
        },
        getImbeddedRekView: function(type) {
            var rekView  = $.extend({
                id:'rekPopupView'
            },this.view);
            rekView.data = reksidebar.Rek.user.data.rekTree;
            rekView.buildIndexMap();
            rekView.rowCount = rekView.getRowCount();
            if (type == 'rek') rekView.indexMap[0].node.name = 'Inbox';
            return rekView;
        },
        releaseImbeddedView: function() {
            //this.rekPopupView.indexMap[0].node.name = 'Ungrouped Folder (default)';
            reksidebar.treeMgr.rekView.treeBox.invalidate();
        },
        showFriendViewPopup: function() {
        }
    }
});
reksidebar.ns(function() {

    reksidebar.signup = {
        CONST:{
        },
        T:{
            importResult:[
            '<hbox class="signup-generic-result small" align="baseline" flex="1">',
            '<description value="{0}" flex="1" readonly="true" wrap="off" crop="end"/>',
            '<hbox width="100">',
            '<vbox pack="center">',
            '<image class="result-image" src="{1}"/>',
            '</vbox>',
            '<description class="result-text" value="{2}"/>',
            '</hbox>',
            '</hbox>'
            ]
        },
        userRecordID:null,
        tempSessionID:'',
        fbSession:null,
        curPage:null,
        valid: {
            userid: false,
            email:false,
            password:false
        },
        init: function() {
            reksidebar.Rek.log('signup init');
            /*var i,el,el2;
            var countries = reksidebar.Rek.CONST.COUNTRIES;
            // populate the country select list
            el = $('.countrymenu menupopup');
            for (i=0;i<countries.length;i++) {
                el2 = document.createElement("menuitem");
                $(el2).attr('label',countries[i][1]);
                $(el2).attr('value',countries[i][0]);
                $(el).append(el2);
            }*/
            //reksidebar.Rek.log(reksidebar.Rek.serializeDOM($('#signup-country')[0]));
            // reset all fields
            $('#deck-signup textbox:not(.signup-dob-default)').val('');
            $('#signup-import-deck').attr('selectedIndex',0);
            $('#signup-ff-result').attr('selectedIndex','0');
            $('#signup-ff-folder').val('Firefox Bookmarks');
            $('#signup-generic-infolder').attr('checked','false');
            $('#signup-generic-folder').attr('disabled','true');
            $('#signup-generic-folder').val('My Bookmarks');
            $('#signup-del-folder').val('Delicious Bookmarks');
            $('#signup-import-browse').val('');
            $('#signup-result-list').empty();
            
            // bind import folder checkboxes
            $('.signup-import-infolder').bind('click',function(){
                var $el = $(this).parent().find('textbox');
                if ($(this).attr('checked')) {
                    $el.removeAttr('disabled').focus();
                    $el[0].setSelectionRange(0,$el.val().length);
                } else {
                    $el.attr('disabled','true').blur();
                }
            });
            //$('#signup-dob-mm').val('MM');
            //$('#signup-dob-dd').val('DD');
            //$('#signup-dob-yyyy').val('YYYY');
            $('#deck-signup menulist').each(function(i,v){
                v.selectedIndex = 0;
            })
            $('#deck-signup checkbox').attr('checked','false');
            $('#deck-signup .status-icon').attr('src','chrome://rekommend/skin/images/s.gif');

            $('#deck-signup>vbox:gt(0)').hide();
            $('#deck-signup>vbox:eq(0)').show();
            this.curPage = 0;
            //this.showPage(3);
        },
        shutdown: function() {

        },
        validateEmail: function(el) {
            var _doUpdate = function() {
                if (reksidebar.Rek.isEmail(el.value)){
                    // email is a valid one...check it it already exists
                    $.ajax({
                        type: 'POST',
                        async: true,
                        url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/validateUserKey.php',
                        data: {
                            key: 'email_pri',
                            value: el.value
                        },
                        dataType: 'json',
                        success: function(json){
                            //reksidebar.Rek.log(text);
                            //json = JSON.parse(text);
                            if (json.result == 0) {
                                $('#signup-email-status').attr('src','chrome://rekommend/skin/images/check.png');
                                reksidebar.signup.valid.email = true;
                            } else {
                                $('#signup-email-status').attr('src','chrome://rekommend/skin/images/cancel16.png');
                                reksidebar.signup.valid.email = false;
                            }
                            reksidebar.signup.validatePage();
                        },
                        error: function(req,status,error){
                            // check on system status
                            reksidebar.Rek.validateStatus(error);
                        }
                    });
                }
                else {
                    $('#signup-email-status').attr('src','chrome://rekommend/skin/images/cancel16.png');
                    reksidebar.signup.valid.email = false;
                }
                reksidebar.signup.validatePage();
            }
            if (el.delay) clearTimeout(el.delay);
            if (el.value.length == 0) {
                $('#signup-email-status').attr('src','chrome://rekommend/skin/images/s.gif');
                this.valid.email = false;
            }
            else
                el.delay = setTimeout(_doUpdate,1500);
            this.validatePage();
        },
        validateUserID: function(el) {
            var _doUpdate = function() {
                if (el.value.length >= 6) {
                    reksidebar.Rek.log('validate user id');
                    $.ajax({
                        type: 'POST',
                        async: true,
                        url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/validateUserKey.php',
                        data: {
                            key:'userid',
                            value: el.value
                        },
                        dataType: 'json',
                        success: function(json){
                            reksidebar.Rek.log(json);
                            //json = JSON.parse(json);
                            if (json.result == 0) {
                                $(el).parent().find('.status-icon').attr('src','chrome://rekommend/skin/images/check.png');
                                reksidebar.signup.valid.userid = true;
                            } else {
                                $(el).parent().find('.status-icon').attr('src','chrome://rekommend/skin/images/cancel16.png');
                                reksidebar.signup.valid.userid = false;
                            }
                            reksidebar.signup.validatePage();
                        },
                        error: function(req,status,error){
                            // check on system status
                            reksidebar.Rek.validateStatus(error);
                        }
                    });
                } else {
                    $(el).parent().find('.status-icon').attr('src','chrome://rekommend/skin/images/cancel16.png');
                    reksidebar.signup.valid.userid = false;
                    reksidebar.signup.validatePage();
                }
            }
            if (el.delay) clearTimeout(el.delay);
            if (el.value.length == 0) {
                $(el).parent().find('.status-icon').attr('src','s.gif');
                this.valid.userid = false;
            } else {
                this.valid.userid = false;
                el.delay = setTimeout(_doUpdate,500);
            }
            this.validatePage();
        },
        validatePassword: function() {
            var el=$('#signup-pass1');
            var pass1 = $(el).val();
            var el2=$('#signup-pass2');
            var pass2 = $(el2).val();
            var _doUpdate = function() {
                var exp = /^.*(?=.{6,})(?=.*\d).*$/;
                if (pass1 == pass2) {
                    if (exp.test(pass1)) {
                        $('.signup-pass-status').attr('src','chrome://rekommend/skin/images/check.png');
                        reksidebar.signup.valid.password = true;
                    } else {
                        $('.signup-pass-status').attr('src','chrome://rekommend/skin/images/cancel16.png');
                        reksidebar.signup.valid.password = false;
                    }
                } else {
                    //passwords do not match
                    $('.signup-pass-status').attr('src','chrome://rekommend/skin/images/cancel16.png');
                    reksidebar.signup.valid.password = false;
                }
                reksidebar.signup.validatePage();
            }
            if (el[0].delay) clearTimeout(el[0].delay);
            if (pass1.length == 0 || pass2.length == 0) {
                $('.signup-pass-status').attr('src','s.gif');
                this.valid.password = false;
            } else
                el[0].delay = setTimeout(_doUpdate,1500);
            this.validatePage();
        },
        validatePage: function() {
            var el;
            var valid = true;
            switch (this.curPage) {
                case 1:
                    if (!this.valid.userid) valid = false;
                    else if (!this.valid.email) valid = false;
                    else if (!this.valid.password) valid = false;
                    else if (!($('#signup-agree')[0].checked)) valid = false;
                    // check dob as valid
                    
                    el = $('#signup-nav-continue-step1')[0];
                    if (valid) {
                        if (el.disabled) $(el).removeAttr('disabled');
                    } else {
                        if (!el.disabled) el.setAttribute('disabled','true');
                    }
                    break;
                case 2:
                    if ($('#signup-fname').val().length == 0) valid = false;
                    else if ($('#signup-lname').val().length == 0) valid = false;
                    else if ($('#signup-country')[0].selectedIndex < 1) valid = false;
                    else if ($('#signup-zip').val().length == 0) valid = false;
                    else {
                        var date = new Date($('#signup-dob-mm').val()+'/'+$('#signup-dob-dd').val()+'/'+$('#signup-dob-yyyy').val());
                        if (isNaN(date)) {
                            valid = false;
                        //$('#signup-dob-mm').val('').trigger('focus');
                        //$('#signup-dob-dd').val('').trigger('focus');
                        //$('#signup-dob-yyyy').val('').trigger('focus').trigger('blur');
                        }
                    }
                    el = $('#signup-nav-continue-step2')[0];
                    if (valid) {
                        if (el.disabled) $(el).removeAttr('disabled');
                    } else {
                        if (!el.disabled) el.setAttribute('disabled','true');
                    }
                    break;
                case 3:
                    el = $('#signup-nav-continue-stepfb')[0];
                    if (this.valid.userid) {
                        if (el.disabled) $(el).removeAttr('disabled');
                    } else {
                        if (!el.disabled) el.setAttribute('disabled','true');
                    }
                    break;
            }
        },
        showPage: function(page) {
            $('#deck-signup>vbox:eq('+this.curPage+')').fadeOut(function() {
                $('#deck-signup>vbox:eq('+page+')').fadeIn();
                reksidebar.signup.curPage = page;
            });
        },
        quickShowPage: function(page) {
            $('#deck-signup>vbox:eq('+this.curPage+')').hide();
            $('#deck-signup>vbox:eq('+page+')').show();
            reksidebar.signup.curPage = page;
        },
        fbsignup: function() {
            var self = this;
            $('.fb-connect .loader').removeClass('novis');
            reksidebar.account.fbfetch(function(fb){
                reksidebar.Rek.log(fb);
                if (fb) {
                    $.ajax({
                        type: 'POST',
                        async: true,
                        url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/fbconnect.php',
                        data: {
                            id: fb.id
                        },
                        dataType: 'text',
                        success: function(json){
                            reksidebar.Rek.log(json);
                            json = JSON.parse(json);
                            $('.fb-connect .loader').addClass('novis');
                            switch (json.result) {
                                case 0:
                                    break;
                                case -1:
                                    // duplicate email address
                                    // this should not happen
                                    break;
                                case -2:
                                    // duplicate / non-existent userid
                                    $('#signup-nav-continue-stepfb')[0].setAttribute('disabled','true'); 
                                    $('#signup-fb-username-wrapper').empty();
                                    if (fb.username) {
                                        reksidebar.Rek.appendDOMfromString($('#signup-fb-username-wrapper'),'<html:br/><description>Your Facebook username <html:b>'+fb.username+'</html:b> is already taken by another reKommend user.<html:br/><html:br/>Please choose a unique reKommend user name so that we can keep you straight.<html:br/><html:br/></description>');
                                    } else {
                                        reksidebar.Rek.appendDOMfromString($('#signup-fb-username-wrapper'),'<html:br/><description>We couldn\'t find a Facebook username in your profile.<html:br/><html:br/>Please choose a unique reKommend user name so that we can keep you straight.<html:br/><html:br/></description>');
                                    }
                                    self.fbSession = fb;
                                    $('#fbsignup-userid').val('');
                                    reksidebar.signup.validateUserID($('#fbsignup-userid')[0]);
                                    self.quickShowPage(3);
                                    reksidebar.show(reksidebar.Rek.CONST.SIDEBAR_SIGNUP);
                                    break;
                                case -3:
                                    self.fbSession = fb;
                                    $('#signup-fb-username-wrapper').empty();
                                    reksidebar.Rek.appendDOMfromString($('#signup-fb-username-wrapper'),'<html:br/><description>Your Facebook username <html:b>'+fb.username+'</html:b> is available for your reKommend account.<html:br/><html:br/>If you wish, you can change it below, then hit \'Continue\' to proceed with the signup process.<html:br/><html:br/></description>');
                                    $('#fbsignup-userid').val(fb.username);
                                    reksidebar.signup.validateUserID($('#fbsignup-userid')[0]);
                                    self.quickShowPage(3);
                                    reksidebar.show(reksidebar.Rek.CONST.SIDEBAR_SIGNUP);
                                    break;
                                default:
                                    // success
                                    // was already a member - log them in
                                    // notify once
                                    try {
                                        reksidebar.Rek.PREF.getBoolPref('fbnotify');
                                        reksidebar.showAppTab(reksidebar.Rek.CONST.SIDEBARTAB_REK);
                                        reksidebar.Rek.fblogin(fb);
                                    } catch (e) {
                                        reksidebar.Rek.PREF.setBoolPref('fbnotify',true);
                                        reksidebar.modal.open({
                                            title:'Facebook Connect',
                                            text:'We will automatically log into reKommend using your Facebook account.',
                                            buttons:[{
                                                label:'OK',
                                                callback: function() {
                                                    reksidebar.modal.close(this);
                                                    reksidebar.showAppTab(reksidebar.Rek.CONST.SIDEBARTAB_REK);
                                                    reksidebar.Rek.fblogin(fb);
                                                }
                                            }]
                                        });
                                    }
                            }
                            
                        },
                        error: function(req,status,error){
                            $('.fb-connect .loader').addClass('novis');
                            // check on system status
                            reksidebar.Rek.validateStatus(reksidebar.Rek.CONST.STATUS_LOGGED_OUT);
                        }
                    });
                } else {
                    // no connect option
                    reksidebar.modal.open({
                        title:'Cannot connect to Facebook',
                        icon:'exclamation.png',
                        text:'No conection to Facebook could be established. Please try again later or sign-up via reKommend.',
                        buttons:[{
                            label:'OK',
                            callback: function() {
                                reksidebar.modal.close(this);
                                $('.fb-connect .loader').addClass('novis');
                            }
                        }]
                    });
                }
            },true);
        },
        
        fbsignup2: function() {
            self = this;
            $.ajax({
                type: 'POST',
                async: true,
                url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/fbconnect.php',
                data: {
                    id: self.fbSession.id,
                    username: $('#fbsignup-userid').val()
                },
                dataType: 'json',
                success: function(json){
                    reksidebar.Rek.log(json);
                    //json = JSON.parse(json);
                    switch (json.result) {
                        case 0:
                            break;
                        case -1:
                            // duplicate email address
                            break;
                        case -2:
                            // duplicate / non-existent userid
                            break;
                        default:
                            // success
                            self.userRecordID = json.result;
                            self.tempSessionID = json.sessionId;
                            self.quickShowPage(4);
                            //reksidebar.show(reksidebar.Rek.CONST.SIDEBAR_SIGNUP);
                    }
                            
                },
                error: function(req,status,error){
                    $('.fb-connect .loader').addClass('novis');
                    // check on system status
                    reksidebar.Rek.validateStatus(reksidebar.Rek.CONST.STATUS_LOGGED_OUT);
                }
            });
        },
        
        /*fbsignup: function() {
            var self = this,
                step2 = function(fb) {
                    reksidebar.Rek.log(fb);
                    // check username availability
                    $.ajax({
                        type: 'POST',
                        async: true,
                        url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/validateUserKey.php',
                        data: {
                            key:'userid',
                            value: fb.username
                        },
                        dataType: 'json',
                        success: function(json){
                            reksidebar.Rek.log(json);
                            alert('here');
                            if (json.result == 0) {
                                $('#signup-userid').val(fb.username);
                                $('#signup-email').val(fb.email);
                                self.validateEmail($('#signup-email')[0]);
                                $('#signup-fname').val(fb.first_name);
                                $('#signup-lname').val(fb.last_name);
                                if (fb.birthday) {
                                    arr = fb.birthday.split('/');
                                    $('#signup-dob-mm').val(arr[0]);
                                    $('#signup-dob-dd').val(arr[1]);
                                    $('#signup-dob-yyyy').val(arr[2]);
                                }
                                $('#signup-gender').val(fb.gender);
                                $('#signup-userid-status').attr('src','chrome://rekommend/skin/images/check.png');
                                reksidebar.signup.valid.userid = true;
                            } else {
                                $('#signup-userid').val('');
                                reksidebar.modal.open({
                                    title:'Facebook Username Unavailable',
                                    text:'Your Facebook handle \'\' is currently in use by another user. Please choose a reKommend username.',
                                    buttons:[{
                                            label:'OK',
                                            callback: function() {
                                                reksidebar.modal.close(this);
                                                self.showPage(1);
                                            }
                                        }]
                                });
                            }
                            self.showPage(1);
                            reksidebar.signup.validatePage();
                        },
                        error: function(req,status,error){
                            // check on system status
                            reksidebar.Rek.validateStatus(error);
                        }
                    
                    });
            };
            // try to get a facebook session
            $.ajax({
                type: 'POST',
                async: true,
                url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/fbsignup.php',
                dataType: 'text',
                success: function(json) {
                    reksidebar.Rek.log(json);
                    json = JSON.parse(json);
                    //reksidebar.Rek.log(json);
                    if (json.result.session) {
                        // found a facebook session with correct permissions
                        step2(json.result);
                    } else {
                        // did not find a current facebook session
                        reksidebar.Rek.log(json.result.url);
                        w = window.open(json.result.url,'facebook login','width=600,height=400,chrome=yes,centerscreen,scrollbars=no,menubar=no,toolbar=no,location=no,personalbar=no,resizable=no,status=no,alwaysRaised=yes');
                        // wait for window to close (max 2 min)
                        var counter = 0;
                        var _wait = function() {
                            counter++;
                            if (w.document !== null && counter < 240) setTimeout(_wait,500);
                            else {
                                if (w) w.close();
                                // try again
                                $.ajax({
                                    type: 'POST',
                                    async: true,
                                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/fbsignup.php',
                                    dataType: 'json',
                                    success: function(json) {
                                        reksidebar.Rek.log(json);
                                        //json = JSON.parse(json);
                                        if (json.result.session) step2(json.result);
                                    },
                                    error: function() {
                                        reksidebar.modal.open({
                                            title:'Cannot connect to Facebook',
                                            text:'ReKommend could not connect to Facebook to locate your profile information. Either login to Facebook manually or try again later.',
                                            buttons:[{
                                                label:'OK',
                                                callback: function() {
                                                    reksidebar.modal.close(this);
                                                }
                                            }]
                                        });
                                    }
                                });
                            
                            }
                        }
                        _wait();
                    }
                },
                error: function() {
                    reksidebar.Rek.log('FAIL!!!');
                    reksidebar.modal.open({
                        title:'Cannot connect to Facebook',
                        text:'ReKommend could not connect to Facebook to locate your profile information. Either login to Facebook manually or try again later.',
                        buttons:[{
                            label:'OK',
                            callback: function() {
                                reksidebar.modal.close(this);
                            }
                        }]
                    });
                }
            });
        },*/
        createAccount: function() {
            //var dob = new Date($('#signup-dob-mm').val()+'/'+$('#signup-dob-dd').val()+'/'+$('#signup-dob-yyyy').val());
            reksidebar.Rek.log('create user');
            uid = $('#signup-userid').val();
            pass = $('#signup-pass1').val();
            email = $('#signup-email').val();
            $.ajax({
                type: 'POST',
                async: true,
                url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/createUser.php',
                data: {
                    //name_first:$('#signup-fname').val(),
                    //name_last:$('#signup-lname').val(),
                    userid:uid,
                    password:pass, // encrypt this later...
                    email_pri:email,
                    token:reksidebar.Rek.md5(uid+pass+email),
                    //country_id:$('#signup-country')[0].selectedItem.value,
                    //zip:$('#signup-zip').val(),
                    //dob:dob.getFullYear()+'-'+(dob.getMonth()+1)+'-'+dob.getDate(),
                    //gender:$('#signup-gender')[0].selectedItem.value,
                    preferences_json:JSON.stringify(reksidebar.Rek.CONST.DEFAULT_PREFS)
                },
                dataType: 'json',
                success: function(json){
                    reksidebar.Rek.log(json);
                    //json = JSON.parse(json);
                    if (json.result != 0) {
                        // success - record id returned
                        reksidebar.signup.userRecordID = parseInt(json.result);
                        reksidebar.signup.tempSessionID = json.session;
                    } else {
                        // the insert failed - most likely duplicate userid
                        reksidebar.modal.open({
                            title:reksidebar.Rek.getProperty('signup.createFailTitle'),
                            text:reksidebar.Rek.getProperty('signup.createFailText'),
                            buttons:[{
                                label:'OK',
                                callback: function() {
                                    reksidebar.modal.close(this);
                                    $('#signup-userid').val('');
                                    reksidebar.signup.validateUserID($('#signup-userid')[0]);
                                    reksidebar.signup.showPage(1);
                                }
                            }]
                        });
                    }
                },
                error: function(req,status,error){
                    // check on system status
                    //reksidebar.Rek.validateStatus(error);
                    reksidebar.Rek.log(status);
                }
            });
        },
        addAccountDetails: function() {
            reksidebar.Rek.log('add account details');
            var dob = new Date($('#signup-dob-mm').val()+'/'+$('#signup-dob-dd').val()+'/'+$('#signup-dob-yyyy').val());
            $.ajax({
                type: 'POST',
                async: true,
                url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/dbUpdateRecord.php',
                data: {
                    id:reksidebar.signup.userRecordID,
                    session:reksidebar.signup.tempSessionID,
                    table:'user',
                    recid:reksidebar.signup.userRecordID,
                    obj:JSON.stringify({
                        name_first:$('#signup-fname').val(),
                        name_last:$('#signup-lname').val(),
                        country_id:$('#signup-country')[0].selectedItem.value,
                        zip:$('#signup-zip').val(),
                        dob:dob.getFullYear()+'-'+(dob.getMonth()+1)+'-'+dob.getDate(),
                        gender:$('#signup-gender')[0].selectedItem.value
                    })
                },
                dataType: 'text',
                success: function(json){
                    reksidebar.Rek.log(json);
                    //json = JSON.parse(text);
                },
                error: function(req,status,error){
                    // check on system status
                    reksidebar.Rek.log.validateStatus(error);
                }
            });
        },
        importContacts: function() {
            uid = $('#signup-import-email').val();
            domain = $('#signup-import-domain').val();
            pass = $('#signup-import-password').val();
            if (uid && domain && pass) {
                reksidebar.friend.importContacts(uid,domain,pass,function(list){
                    if (list.length) {
                        arr = [];
                        $.each(list,function(i,v){
                            arr.push(v.email);
                        });
                        str = arr.join(',');
                        $el = $('#signup-friend-invite');
                        old = $el.val();
                        if (old.length && old.substr(-1,1) != ',') str = old+','+str;
                        else str = old+str;
                        $el.val(str);
                    }
                });
            } else {
                reksidebar.modal.open({
                    title:'No service or password',
                    icon:'exclamation.png',
                    text:'To import contacts, you need to enter your user ID, select a service and enter your account password.'
                });
            }
        },
        plaxo: function() {
            reksidebar.friend.importPlaxo(null,null,function(list){
                if (list.length) {
                    arr = [];
                    $.each(list,function(i,v){
                        arr.push(v.email);
                    });
                    str = arr.join(',');
                    $el = $('#signup-friend-invite');
                    old = $el.val();
                    if (old.length && old.substr(-1,1) != ',') str = old+','+str;
                    else str = old+str;
                    $el.val(str);
                }
            });
        },
        inviteFriends: function() {
            var str = $('#signup-friend-invite').val();
            var arr1 = [],arr2 = [];
            if (str.length) {
                arr1 = str.split(',');
                $.each(arr1,function(i,val){
                    arr2.push({
                        type:'',
                        name:'',
                        ref:val
                    });
                });
                $.ajax({
                    type: 'POST',
                    async: true,
                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/inviteFriends.php',
                    data: {
                        id:this.userRecordID,
                        session: this.tempSessionID,
                        arr:JSON.stringify(arr2)
                    },
                    dataType: 'json',
                    success: function(json){
                        reksidebar.Rek.log(json);
                    },
                    error: function(req,status,error){
                        // check on system status
                        reksidebar.Rek.validateStatus(status);
                    }
                });
            }
        },
        ffBmarkImport: function() {
            var fname,result,bmarks,rs = this;

            fname = $('#signup-ffimport-infolder:checked').length?$('#signup-ff-folder').val():null;
            if (!fname) fname = 'Firefox Bookmarks';
            result = reksidebar.data.ffBmarkImport(fname)
            if (result.count > 500) {
                reksidebar.modal.open({
                    title:'Bookmark Import',
                    icon:'exclamation.png',
                    text:'We have detected a large number of bookmarks to import. The import process could take several minutes to complete...',
                    buttons:[{
                        label:'Cancel',
                        callback: function(){
                            reksidebar.modal.close(this);
                        }
                    },{
                        label:'Continue',
                        callback: function(){
                            reksidebar.modal.close(this);
                            $('#signup-ff-result').attr('selectedIndex','1');
                            reksidebar.data.uploadBmarks(rs.userRecordID,rs.tempSessionID,result.bmarks,function(){
                                $('#signup-ff-result').attr('selectedIndex','2');
                            });
                        }
                    }]
                });
            } else {
                $('#signup-ff-result').attr('selectedIndex','1');
                reksidebar.data.uploadBmarks(rs.userRecordID,rs.tempSessionID,result.bmarks,function(){
                    $('#signup-ff-result').attr('selectedIndex','2');
                });
            }
        },
        
        browserSelect: function() {
            var v = $('#signup-account-browser').val(),
            str;
            switch (v) {
                
                case 'ie':
                    str = 'IE Bookmarks';
                    break;
                case 'chrome':
                    str = 'Chrome Bookmarks';
                    break;
                case 'safari':
                    str = 'Safari Bookmarks';
                    break;
                case 'delicious':
                    str = 'delicious Bookmarks';
                    break;
            }
            $('#signup-account-folder').attr('checked','false');
            $('#signup-import-foldername').val(str);
            $('#signup-import-foldername').attr('disabled','true');
        },

        toggleFolder: function() {
            var $el;
            if ($('#signup-account-folder').attr('checked') == 'true') {
                $el = $('#signup-import-foldername');
                $el.removeAttr('disabled').focus();
                $el[0].setSelectionRange(0,$el.val().length);

            } else {
                $('#signup-import-foldername').attr('disabled','true');
            }
        },
        
        bmarkSelect: function() {
            if ($('#signup-import-browse')[0].files.length) $('#signup-import-deck').attr('selectedIndex','1');
        },
        bmarkImport: function() {
            var fArr = $('#signup-import-browse')[0].files,file,fname,bmarks,rs = this,
            _doImport = function() {
                $('#signup-import-deck').attr('selectedIndex','1');
                file = fArr[0].name;
                reksidebar.data.bmarkImport('generic',fArr[0],fname,function(bmarks){
                    if (bmarks.items.length) {
                        // successful
                        reksidebar.data.uploadBmarks(rs.userRecordID,rs.tempSessionID,bmarks,function(){
                            // successful
                            reksidebar.Rek.appendDOMfromString($('#signup-result-list'),reksidebar.signup.T.importResult.join('').format(
                                file,
                                'chrome://rekommend/skin/images/check12.png',
                                'Succeeded'
                                ));
                        });
                    } else {
                        // failed
                        reksidebar.Rek.appendDOMfromString($('#signup-result-list'),reksidebar.signup.T.importResult.join('').format(
                            file,
                            'chrome://rekommend/skin/images/cancel12.png',
                            'No import'
                            ));
                    }
                    $('#signup-import-deck').attr('selectedIndex','0');
                });
            };
            
            fname = $('#signup-account-folder:checked').length?$('#signup-import-foldername').val():null;
            if (!fname) fname = 'Bookmark Import';
            
            //file = fArr[0].mozFullPath;
            file = fArr[0].fileName;
            if (fArr.length) {
                if (fArr[0].size > 100000) {
                    reksidebar.modal.open({
                        title:'Bookmark Import',
                        icon:'exclamation.png',
                        text:'We have detected a large number of bookmarks to import. The import process could take several minutes to complete...',
                        buttons:[{
                            label:'Cancel',
                            callback: function(){
                                reksidebar.modal.close(this);
                            }
                        },{
                            label:'Continue',
                            callback: function(){
                                reksidebar.modal.close(this);
                                _doImport();
                            }
                        }]
                    });
                } else {
                    _doImport();
                }
            } else {
                // no import
                reksidebar.Rek.appendDOMfromString($('#signup-result-list'),reksidebar.signup.T.importResult.join('').format(
                    '<no file selected>',
                    'chrome://rekommend/skin/images/cancel12.png',
                    'Failed'
                    ));
            }

            $('#signup-import-deck').attr('selectedIndex',0);
            $('#signup-import-browse').val('');
            $('#signup-generic-infolder').attr('checked','false');
            $('#signup-generic-folder').attr('disabled','true');
            $('#signup-generic-folder').val('My Bookmarks');
        },
        redirectLogin: function() {
            var userid = $('#signup-userid').val();
            $('#login-userid').val(userid);
            $('#login-password').val('');
            reksidebar.showAppTab(reksidebar.Rek.CONST.SIDEBARTAB_REK);
            if (this.fbSession) {
                reksidebar.Rek.fblogin(this.fbSession);
                this.sendInviteMail(this.fbSession.email);
            } else {
                reksidebar.Rek.login($('#signup-userid').val(),$('#signup-pass1').val());
                this.sendInviteMail($('#signup-email').val());
            }
            // put the browser menu at 0
            $('#browse-browse-menulist').val('0');
        },
        
        sendInviteMail: function(to) {
            reksidebar.Rek.log('send invite email to: '+to);
            $.ajax({
                type: 'POST',
                async: true,
                url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/sendMail.php',
                data: {
                    to:to,
                    subject:'Welcome to reKommend.com!',
                    body:"Thank you for joining reKommend.com! ReKommend is a browser sidebar that allows you to quickly and easily share and bookmark websites. The days of copying and pasting links into emails are over! To make a recommendation, all you have to do is open your reKommend sidebar and go to a web page that you want to share. Within the sidebar, select one or more of your friends and then click the 'reKommend It!' button. It is that easy! We hope you enjoy our add on. We are currently in Beta and would really appreciate getting feedback and bug reports. You can find the feedback/bug report link at the bottom of the sidebar.\n\nRegards,\n\nThe reKommend Team"
                },
                dataType: 'text',
                success: function(json){
                    reksidebar.Rek.log(json);
                },
                error: function(req,status,error){
                    // check on system status
                    reksidebar.Rek.validateStatus(error);
                }
            });
        }
    }
});
reksidebar.ns(function() {

    reksidebar.browse = {
        CONST: {
        },
        templates: {
            inbox: [
            '<hbox class="browse-inbox-listitem listitem{0}{18}{23}" recid="{1}" rekid="{14}" nodeid="{11}" url="{8}" tiny="{20}" type="rek">',
            '<grid flex="1">',
            '<columns><column flex="1"/></columns>',
            '<rows>',
            '<row class="browse-listitem-item">',
            '<hbox class="collapse">',
            '<vbox><checkbox class="browse-checkbox" checked="{10}" onclick="event.stopPropagation();"/></vbox>',
            '<vbox flex="1">',

            // inline edit rek title
            /*'<hbox class="collapse" flex="1">',
            '<hbox class="" onclick="event.stopPropagation();">',
            '<vbox pack="center">',
            '<image class="" src="chrome://rekommend/skin/images/lock8.png"/>',
            '</vbox>',
            '</hbox>',
            '<stack flex="1">',
            '<description class="browse-title-static {2}" value="{3}" flex="1" crop="end" tooltiptext="{3}" ondblclick="reksidebar.browse.startEdit(this);"/>',
            '<html:input class="browse-title-editable" flex="1" style="display:none;" type="text" value="{3}" onmousedown="event.stopPropagation();" onkeydown="if (event.keyCode == 13) reksidebar.browse.stopEdit(\'browse.inbox\',this);" onblur="reksidebar.browse.stopEdit(\'browse.inbox\',this);"/>',
            '</stack>',
            '</hbox>',*/
                
            '<hbox class="collapse" flex="1" onclick="reksidebar.browse.read(\'browse.inbox\',$(this).parents(\'.browse-inbox-listitem\'),reksidebar.Rek.user.data.preferences[\'inbox_open\']);">',
            '<hbox class="browse-listitem-privateicon">',
            '<vbox pack="center">',
            '<image class="" src="chrome://rekommend/skin/images/lock8.png"/>',
            '</vbox>',
            '</hbox>',
            '<description class="browse-pagetitle hidden" value="{21}"/>',
            '<description class="browse-title-static {2}" value="{3}" flex="1" crop="end" tooltiptext="{3}" ondblclick=""/>',
            
            '<vbox pack="start">',
            '<hbox class="popup-hover-button" popup="popup-browse1" onclick="event.stopPropagation();">',
            '<vbox pack="center"><image src="chrome://rekommend/skin/images/browse_popup2.png"/></vbox>',
            '</hbox>',
            '</vbox>',
            
            '<spacer width="3"/>',
            '</hbox>',

            '<hbox hidden="{22}">',
            '<spacer width="4"/>',
            //'<description class="browse-sub-description from small" crop="end" value="From: {4}"/>',
            '<description class="browse-sub-description from small" flex="1">From: {4}</description>',
            '<hbox class="hover-button hidden" onclick="event.stopPropagation();reksidebar.browse.nodeClick(\'browse.inbox\',$(this).parents(\'.browse-inbox-listitem\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/folder_page12.png"/>',
            '</vbox>',
            '<description class="browse-sub-description node small" nodeid="{11}" value="{5}" crop="end" />',
            '</hbox>',
            '<hbox>',
            //'<hbox class="separator"/>',
            '<hbox class="hover-button" onclick="event.stopPropagation();reksidebar.browse.showComments(\'browse.inbox\',$(this).parents(\'.browse-inbox-listitem\').find(\'.browse-listitem-row.comments\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/comments12.png"/>',
            '</vbox>',
            '<description class="browse-sub-description comment small {6}" value="{7}" total="{9}"/>',
            '</hbox>',
            '<hbox class="{15}">',
            //'<hbox class="separator"/>',
            '<hbox class="hover-button" onclick="event.stopPropagation();reksidebar.browse.showTags(\'browse.inbox\',$(this).parents(\'.browse-inbox-listitem\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/tag_orange12.png"/>',
            '</vbox>',
            '<description class="browse-sub-description tag small" value="{16}"/>',
            '</hbox>',
            '</hbox>',
            '</hbox>',
            '<spacer width="28"/>',
            '</hbox>',
            '</vbox>',
            '</hbox>',
            '</row>',

            // loader
            '<row class="browse-listitem-row loader">',
            '<hbox pack="center" flex="1"><image src="chrome://rekommend/skin/images/loader_12.gif"/></hbox>',
            '</row>',

            // edit row
            '<row class="browse-listitem-row edit">',
            '<vbox flex="1">',

            '<textbox class="browse-edit-title collapse"/>',
            '<hbox><spacer width="10"/><description class="collapse smaller" value="* Required"/></hbox>',
            '<spacer height="3"/>',

            '<hbox class="browse-edit-folder" flex="1">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/folder_page12.png"/>',
            '</vbox>',
            '<menulist class="browse-edit-menulist small" oncommand="" flex="1">',
            '<menupopup class="browse-edit-folderpopup"></menupopup>',
            '</menulist>',
            '</hbox>',
            
            '<vbox class="browse-edit-tags">',
            '<hbox class="browse-tags-list center"></hbox>',
            '<spacer height="5"/>',
            '<hbox>',
            '<vbox pack="center"><label class="" value="Add tag(s):"/></vbox>',
            '<textbox class="browse-edit-addtag collapse" type="autocomplete" autocompletesearch="simple-autocomplete" showcommentcolumn="false" autocompletesearchparam=\'\' flex="1" ontextentered="reksidebar.browse.addTag($(this).parents(\'.browse-listitem-row.edit\'));"/>',
            //'<vbox pack="center">',
            //'<vbox class="rekbutton" tooltiptext="Add Tag" onclick="reksidebar.browse.addTag($(this).parents(\'.browse-listitem-row.edit\'));">',
            //'<image class="collapse" src="chrome://rekommend/skin/images/tag_orange_add12.png"/>',
            //'</vbox>',
            //'</vbox>',
            '</hbox>',
            '<hbox pack="center"><description class="collapse smaller" value="* Separate by comma - 34 max characters per tag "/></hbox>',
            '<spacer height="3"/>',
            '</vbox>',

            '<hbox class="browse-edit-private hidden"><checkbox class="browse-edit-private-checkbox small" label="Private" disabled="true"/></hbox>',

            '<hbox class="browse-edit-submit" pack="center">',
            '<hbox class="rekbutton" width="50" pack="center" onclick="reksidebar.browse.closeEdit(\'browse.inbox\',$(this).parents(\'.browse-inbox-listitem\'),\'save\');"><description class="small" value="Save"/></hbox>',
            '<spacer width="5"/>',
            '<hbox class="rekbutton" width="50" pack="center" onclick="reksidebar.browse.closeEdit(\'browse.inbox\',$(this).parents(\'.browse-inbox-listitem\'),\'cancel\');"><description class="small" value="Cancel"/></hbox>',
            '</hbox>',
            '</vbox>',
            '</row>',

            // comments row
            '<row class="browse-listitem-row comments {13}">',
            '<vbox flex="1">',
            '<vbox class="browse-comments-list">',
            '</vbox>',
            '<vbox class="browse-comments-submit">',
            '<textbox class="browse-comments-textbox" multiline="true" rows="2" height="36" value="" onfocus="reksidebar.Rek.skipPulse();" onblur="reksidebar.Rek.resumePulse();"/>',
            '<hbox pack="center"><button class="small" label="Add Comment" onclick="reksidebar.browse.addComment(\'browse.inbox\',$(this).parents(\'.browse-inbox-listitem\'));"/></hbox>',
            '</vbox>',
            '</vbox>',
            '</row>',

            // tags row
            '<row class="browse-listitem-row tags {17}">',
            '<vbox flex="1">',
            '<hbox class="browse-tags-list center">',
            '{19}',
            '</hbox>',
            '</vbox>',
            '</row>',

            '</rows>',
            '</grid>',
            '</hbox>'
            ],
            comments: [
            '<hbox class="browse-comments-listitem listitem{0}{18}{23}" recid="{1}" rekid="{14}" nodeid="{11}" url="{8}" tiny="{20}" type="{12}">',
            '<grid flex="1">',
            '<columns><column flex="1"/></columns>',
            '<rows>',
            '<row class="browse-listitem-item">',
            '<hbox class="collapse">',
            '<vbox><checkbox class="browse-checkbox" checked="{10}" onclick="event.stopPropagation();"/></vbox>',
            '<vbox flex="1">',

            // inline edit rek title
            /*'<hbox class="collapse" flex="1">',
            '<hbox class="" onclick="event.stopPropagation();">',
            '<vbox pack="center">',
            '<image class="" src="chrome://rekommend/skin/images/lock8.png"/>',
            '</vbox>',
            '</hbox>',
            '<stack flex="1">',
            '<description class="browse-title-static {2}" value="{3}" flex="1" crop="end" tooltiptext="{3}" ondblclick="reksidebar.browse.startEdit(this);"/>',
            '<html:input class="browse-title-editable" flex="1" style="display:none;" type="text" value="{3}" onmousedown="event.stopPropagation();" onkeydown="if (event.keyCode == 13) reksidebar.browse.stopEdit(\'browse.comments\',this);" onblur="reksidebar.browse.stopEdit(\'browse.inbox\',this);"/>',
            '</stack>',
            '</hbox>',*/

            '<hbox class="collapse" flex="1" onclick="reksidebar.browse.read(\'browse.comments\',$(this).parents(\'.browse-comments-listitem\'),reksidebar.Rek.user.data.preferences[\'comments_open\']);">',
            '<hbox class="browse-listitem-privateicon">',
            '<vbox pack="center">',
            '<image class="" src="chrome://rekommend/skin/images/lock8.png"/>',
            '</vbox>',
            '</hbox>',
            '<description class="browse-pagetitle hidden" value="{21}"/>',
            '<description class="browse-title-static {2}" value="{3}" flex="1" crop="end" tooltiptext="{3}" ondblclick=""/>',
            '<vbox pack="start">',
            '<hbox class="popup-hover-button" popup="popup-browse1" onclick="event.stopPropagation();">',
            '<vbox pack="center"><image src="chrome://rekommend/skin/images/browse_popup2.png"/></vbox>',
            '</hbox>',
            '</vbox>',
            '<spacer width="3"/>',
            '</hbox>',

            '<hbox hidden="{22}">',
            '<spacer width="4"/>',
            //'<description class="browse-sub-description from small" crop="end" value="{4}"/>',
            '<description class="browse-sub-description from small" flex="1">{4}</description>',
            '<vbox pack="start">',
            '<hbox class="hover-button hidden" onclick="event.stopPropagation();reksidebar.browse.nodeClick(\'browse.comments\',$(this).parents(\'.browse-comments-listitem\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/folder_page12.png"/>',
            '</vbox>',
            '<description class="browse-sub-description node small" nodeid="{11}" value="{5}" crop="end" />',
            '</hbox>',
            '</vbox>',
            '<hbox>',
            //'<hbox class="separator"/>',
            '<vbox pack="start">',
            '<hbox class="hover-button" onclick="event.stopPropagation();reksidebar.browse.showComments(\'browse.comments\',$(this).parents(\'.browse-comments-listitem\').find(\'.browse-listitem-row.comments\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/comments12.png"/>',
            '</vbox>',
            '<description class="browse-sub-description comment small {6}" value="{7}" total="{9}"/>',
            '</hbox>',
            '</vbox>',
            '<hbox class="{15}">',
            //'<hbox class="separator"/>',
            '<vbox pack="start">',
            '<hbox class="hover-button" onclick="event.stopPropagation();reksidebar.browse.showTags(\'browse.comments\',$(this).parents(\'.browse-comments-listitem\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/tag_orange12.png"/>',
            '</vbox>',
            '<description class="browse-sub-description tag small" value="{16}"/>',
            '</hbox>',
            '</vbox>',
            '</hbox>',
            '</hbox>',
            '<spacer width="28"/>',
            '</hbox>',
            '</vbox>',
            '</hbox>',
            '</row>',

            // loader
            '<row class="browse-listitem-row loader">',
            '<hbox pack="center" flex="1"><image src="chrome://rekommend/skin/images/loader_12.gif"/></hbox>',
            '</row>',

            // edit row
            '<row class="browse-listitem-row edit">',
            '<vbox flex="1">',

            '<textbox class="browse-edit-title collapse"/>',
            '<hbox><spacer width="10"/><description class="collapse smaller" value="* Required"/></hbox>',
            '<spacer height="3"/>',

            '<hbox class="browse-edit-folder" flex="1">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/folder_page12.png"/>',
            '</vbox>',
            '<menulist class="browse-edit-menulist small" oncommand="" flex="1">',
            '<menupopup class="browse-edit-folderpopup"></menupopup>',
            '</menulist>',
            '</hbox>',

            '<vbox class="browse-edit-tags">',
            '<hbox class="browse-tags-list center"></hbox>',
            '<spacer height="5"/>',
            '<hbox>',
            '<vbox pack="center"><label class="" value="Add tag(s):"/></vbox>',
            '<textbox class="browse-edit-addtag collapse" type="autocomplete" autocompletesearch="simple-autocomplete" showcommentcolumn="false" autocompletesearchparam=\'\' flex="1" ontextentered="reksidebar.browse.addTag($(this).parents(\'.browse-listitem-row.edit\'));"/>',
            //'<vbox pack="center">',
            //'<vbox class="rekbutton" tooltiptext="Add Tag" onclick="reksidebar.browse.addTag($(this).parents(\'.browse-listitem-row.edit\'));">',
            //'<image class="collapse" src="chrome://rekommend/skin/images/tag_orange_add12.png"/>',
            //'</vbox>',
            //'</vbox>',
            '</hbox>',
            '<hbox pack="center"><description class="collapse smaller" value="* Separate by comma - 34 max characters per tag "/></hbox>',
            '<spacer height="3"/>',
            '</vbox>',

            '<hbox class="browse-edit-private hidden"><checkbox class="browse-edit-private-checkbox small" label="Private" disabled="true"/></hbox>',

            '<hbox class="browse-edit-submit" pack="center">',
            '<hbox class="rekbutton" width="50" pack="center" onclick="reksidebar.browse.closeEdit(\'browse.comments\',$(this).parents(\'.browse-comments-listitem\'),\'save\');"><description class="small" value="Save"/></hbox>',
            '<spacer width="5"/>',
            '<hbox class="rekbutton" width="50" pack="center" onclick="reksidebar.browse.closeEdit(\'browse.comments\',$(this).parents(\'.browse-comments-listitem\'),\'cancel\');"><description class="small" value="Cancel"/></hbox>',
            '</hbox>',
            '</vbox>',
            '</row>',

            // comments row
            '<row class="browse-listitem-row comments {13}">',
            '<vbox flex="1">',
            '<vbox class="browse-comments-list">',
            '</vbox>',
            '<vbox class="browse-comments-submit">',
            '<textbox class="browse-comments-textbox" multiline="true" rows="2" height="36" value="" onfocus="reksidebar.Rek.skipPulse();" onblur="reksidebar.Rek.resumePulse();"/>',
            '<hbox pack="center"><button class="small" label="Add Comment" onclick="reksidebar.browse.addComment(\'browse.comments\',$(this).parents(\'.browse-comments-listitem\'));"/></hbox>',
            '</vbox>',
            '</vbox>',
            '</row>',

            // tags row
            '<row class="browse-listitem-row tags {17}">',
            '<vbox flex="1">',
            '<hbox class="browse-tags-list center">',
            '{19}',
            '</hbox>',
            '</vbox>',
            '</row>',

            '</rows>',
            '</grid>',
            '</hbox>'
            ],
            bmark: [
            '<hbox class="browse-bmark-listitem listitem{0}{12}{19}" recid="{1}" rekid="{8}" nodeid="{6}" url="{4}" tiny="{16}" type="bookmark">',
            '<grid flex="1">',
            '<columns><column flex="1"/></columns>',
            '<rows>',
            '<row class="browse-listitem-item">',
            '<hbox class="collapse">',
            '<vbox><checkbox class="browse-checkbox" checked="{5}" onclick="event.stopPropagation();"/></vbox>',
            '<vbox flex="1">',

            '<hbox class="collapse" flex="1" onclick="reksidebar.browse.read(\'browse.bmark\',$(this).parents(\'.browse-bmark-listitem\'),reksidebar.Rek.user.data.preferences[\'bmark_open\']);">',
            '<hbox class="browse-listitem-privateicon">',
            '<vbox pack="center">',
            '<image class="" src="chrome://rekommend/skin/images/lock8.png"/>',
            '</vbox>',
            '</hbox>',
            '<description class="browse-pagetitle hidden" value="{17}"/>',
            '<description class="browse-title-static" value="{2}" flex="1" crop="end" tooltiptext="{2}" ondblclick=""/>',
            '<vbox pack="start">',
            '<hbox class="popup-hover-button" popup="popup-browse1" onclick="event.stopPropagation();">',
            '<vbox pack="center"><image src="chrome://rekommend/skin/images/browse_popup2.png"/></vbox>',
            '</hbox>',
            '</vbox>',
            '<space width="3"/>',
            '</hbox>',

            '<hbox hidden="{18}">',
            '<spacer width="4"/>',
            '<hbox>',
            '<hbox class="hover-button" onclick="event.stopPropagation();reksidebar.browse.showComments(\'browse.bmark\',$(this).parents(\'.browse-bmark-listitem\').find(\'.browse-listitem-row.comments\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/note12.png"/>',
            '</vbox>',
            '<description class="browse-sub-description comment small" value="{9}" total="{20}"/>',
            '</hbox>',
            //'<hbox class="separator"/>',
            '<hbox class="hover-button" onclick="event.stopPropagation();reksidebar.browse.nodeClick(\'browse.bmark\',$(this).parents(\'.browse-bmark-listitem\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/folder_page12.png"/>',
            '</vbox>',
            '<description class="browse-sub-description node small" nodeid="{6}" value="{3}" crop="end" />',
            '</hbox>',
            '<hbox class="{10}">',
            //'<hbox class="separator"/>',
            '<hbox class="hover-button" onclick="event.stopPropagation();reksidebar.browse.showTags(\'browse.bmark\',$(this).parents(\'.browse-bmark-listitem\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/tag_orange12.png"/>',
            '</vbox>',
            '<description class="browse-sub-description tag small" value="{11}"/>',
            '</hbox>',
            '</hbox>',
            '</hbox>',
            '<spacer width="28"/>',
            '</hbox>',
            '</vbox>',
            '</hbox>',
            '</row>',

            // loader
            '<row class="browse-listitem-row loader">',
            '<hbox pack="center" flex="1"><image src="chrome://rekommend/skin/images/loader_12.gif"/></hbox>',
            '</row>',

            // edit row
            '<row class="browse-listitem-row edit">',
            '<vbox flex="1">',

            '<textbox class="browse-edit-title collapse"/>',
            '<hbox><spacer width="10"/><description class="collapse smaller" value="* Required"/></hbox>',
            '<spacer height="3"/>',

            '<hbox class="browse-edit-folder" flex="1">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/folder_page12.png"/>',
            '</vbox>',
            '<menulist class="browse-edit-menulist small" oncommand="" flex="1">',
            '<menupopup class="browse-edit-folderpopup"></menupopup>',
            '</menulist>',
            '</hbox>',

            '<vbox class="browse-edit-tags">',
            '<hbox class="browse-tags-list center"></hbox>',
            '<spacer height="5"/>',
            '<hbox>',
            '<vbox pack="center"><label class="" value="Add tag(s):"/></vbox>',
            '<textbox class="browse-edit-addtag collapse" type="autocomplete" autocompletesearch="simple-autocomplete" showcommentcolumn="false" autocompletesearchparam=\'\' flex="1" ontextentered="reksidebar.browse.addTag($(this).parents(\'.browse-listitem-row.edit\'));"/>',
            //'<vbox pack="center">',
            //'<vbox class="rekbutton" tooltiptext="Add Tag" onclick="reksidebar.browse.addTag($(this).parents(\'.browse-listitem-row.edit\'));">',
            //'<image class="collapse" src="chrome://rekommend/skin/images/tag_orange_add12.png"/>',
            //'</vbox>',
            //'</vbox>',
            '</hbox>',
            '<hbox pack="center"><description class="collapse smaller" value="* Separate by comma - 34 max characters per tag "/></hbox>',
            '<spacer height="3"/>',
            '</vbox>',

            '<hbox class="browse-edit-private"><checkbox class="browse-edit-private-checkbox small" label="Private"/></hbox>',

            '<hbox class="browse-edit-submit" pack="center">',
            '<hbox class="rekbutton" width="50" pack="center" onclick="reksidebar.browse.closeEdit(\'browse.bmark\',$(this).parents(\'.browse-bmark-listitem\'),\'save\');"><description class="small" value="Save"/></hbox>',
            '<spacer width="5"/>',
            '<hbox class="rekbutton" width="50" pack="center" onclick="reksidebar.browse.closeEdit(\'browse.bmark\',$(this).parents(\'.browse-bmark-listitem\'),\'cancel\');"><description class="small" value="Cancel"/></hbox>',
            '</hbox>',
            '</vbox>',
            '</row>',

            // comments row
            '<row class="browse-listitem-row comments {13}">',
            '<vbox flex="1">',
            '<vbox class="browse-comments-list">',
            '</vbox>',
            '<vbox class="browse-comments-submit">',
            '<textbox class="browse-comments-textbox" multiline="true" rows="2" height="36" value="" onfocus="reksidebar.Rek.skipPulse();" onblur="reksidebar.Rek.resumePulse();"/>',
            '<hbox pack="center"><button class="small" label="Add Note" onclick="reksidebar.browse.addComment(\'browse.bmark\',$(this).parents(\'.browse-bmark-listitem\'));"/></hbox>',
            '</vbox>',
            '</vbox>',
            '</row>',

            // tags row
            '<row class="browse-listitem-row tags {14}">',
            '<vbox flex="1">',
            '<hbox class="browse-tags-list center">',
            '{15}',
            '</hbox>',
            '</vbox>',
            '</row>',

            '</rows>',
            '</grid>',
            '</hbox>'
            ],
            tags: [
            '<hbox class="browse-tags-listitem listitem" tag="{1}" type="tag">',
            '<grid flex="1">',
            '<columns><column flex="1"/></columns>',
            '<rows>',
            '<row class="browse-listitem-item" onclick="reksidebar.browse.toggleTag($(this).parents(\'.browse-tags-listitem\'));">',
            '<hbox class="collapse">',
            '<vbox pack="center">',
            '<hbox class="twisty"/>',
            '</vbox>',

            '<vbox flex="1">',
            '<hbox class="" flex="1" align="baseline">',
            '<description class="browse-title-static tag-listitem last" value="{1}"/>',
            '<spacer flex="1"/>',
            '<description class="browse-tags-count small" value="({2})"/>',
            '</hbox>',
            '</vbox>',

            '<vbox pack="center">',
            '<hbox class="popup-hover-button" popup="popup-browse1" onclick="event.stopPropagation();">',
            '<vbox pack="center"><image src="chrome://rekommend/skin/images/browse_popup2.png"/></vbox>',
            '</hbox>',
            '</vbox>',
            '<spacer width="3"/>',
            '</hbox>',
            '</row>',

            // loader
            '<row class="browse-listitem-row loader">',
            '<hbox pack="center" flex="1"><image src="chrome://rekommend/skin/images/loader_12.gif"/></hbox>',
            '</row>',

            // edit row
            '<row class="browse-listitem-row edit">',
            '<vbox flex="1">',

            '<hbox align="baseline"><label value="Title:"/><textbox class="browse-edit-title" flex="1"/></hbox>',

            '<hbox class="browse-edit-submit" pack="center">',
            '<hbox class="rekbutton" width="50" pack="center" onclick="reksidebar.browse.closeEdit(\'browse.tags\',$(this).parents(\'.browse-tags-listitem\'),\'save\');"><description class="small" value="Save"/></hbox>',
            '<spacer width="5"/>',
            '<hbox class="rekbutton" width="50" pack="center" onclick="reksidebar.browse.closeEdit(\'browse.tags\',$(this).parents(\'.browse-tags-listitem\'),\'cancel\');"><description class="small" value="Cancel"/></hbox>',
            '</hbox>',
            '</vbox>',
            '</row>',

            // tag detail row
            '<row class="browse-listitem-row browse-tags-detail">',
            '<vbox flex="1">',
            '</vbox>',
            '</row>',

            '</rows>',
            '</grid>',
            '</hbox>'
            ],
            sent: [
            '<hbox class="browse-sent-listitem listitem{0}{9}{20}" recid="{1}" rekid="{10}" nodeid="{16}" url="{3}" tiny="{17}" type="sent">',
            '<grid flex="1">',
            '<columns><column flex="1"/></columns>',
            '<rows>',
            '<row class="browse-listitem-item">',
            '<hbox class="collapse">',
            '<vbox><checkbox class="browse-checkbox" checked="{5}" onclick="event.stopPropagation();"/></vbox>',
            '<vbox flex="1">',

            '<hbox class="collapse" flex="1" onclick="reksidebar.Rek.openURLKey($(this).parents(\'.browse-sent-listitem\').attr(\'tiny\'),reksidebar.Rek.user.data.preferences[\'sent_open\']);">',
            '<hbox class="browse-listitem-privateicon">',
            '<vbox pack="center">',
            '<image class="" src="chrome://rekommend/skin/images/lock8.png"/>',
            '</vbox>',
            '</hbox>',
            '<description class="browse-pagetitle hidden" value="{18}"/>',
            '<description class="browse-title-static" value="{2}" flex="1" crop="end" tooltiptext="{2}" ondblclick=""/>',
            '<vbox pack="start">',
            '<hbox class="popup-hover-button" popup="popup-browse1" onclick="event.stopPropagation();">',
            '<vbox pack="center"><image src="chrome://rekommend/skin/images/browse_popup2.png"/></vbox>',
            '</hbox>',
            '</vbox>',
            '<spacer width="3"/>',
            '</hbox>',
            '<hbox hidden="{19}">',
            '<spacer width="4"/>',
            //'<description class="browse-sub-description2 small" value="To: {4}" crop="end" tooltiptext="{4}"/>',
            '<description class="browse-sub-description from small" flex="1">To: {4}</description>',
            //'<hbox class="separator"/>',
            '<hbox>',
            '<vbox pack="start">',
            '<hbox class="hover-button" onclick="event.stopPropagation();reksidebar.browse.showComments(\'browse.sent\',$(this).parents(\'.browse-sent-listitem\').find(\'.browse-listitem-row.comments\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/comments12.png"/>',
            '</vbox>',
            '<description class="browse-sub-description comment small {7}" value="{8}" total="{21}"/>',
            '</hbox>',
            '</vbox>',
            '<vbox class="{11}" pack="start">',
            //'<hbox class="separator"/>',
            '<hbox class="hover-button" onclick="event.stopPropagation();reksidebar.browse.showTags(\'browse.sent\',$(this).parents(\'.browse-sent-listitem\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/tag_orange12.png"/>',
            '</vbox>',
            '<description class="browse-sub-description tag small" value="{12}"/>',
            '</hbox>',
            '</vbox>',
            '</hbox>',
            '<spacer width="28"/>',
            '</hbox>',
            '</vbox>',
            '</hbox>',
            '</row>',

            // loader
            '<row class="browse-listitem-row loader">',
            '<hbox pack="center" flex="1"><image src="chrome://rekommend/skin/images/loader_12.gif"/></hbox>',
            '</row>',

            // edit row
            '<row class="browse-listitem-row edit">',
            '<vbox flex="1">',

            '<textbox class="browse-edit-title" disabled="true"/>',

            '<hbox class="browse-edit-folder" flex="1">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/folder_page12.png"/>',
            '</vbox>',
            '<menulist class="browse-edit-menulist small" disabled="true" flex="1">',
            '<menupopup class="browse-edit-folderpopup"></menupopup>',
            '</menulist>',
            '</hbox>',

            '<vbox class="browse-edit-tags">',
            '<hbox class="browse-tags-list center"></hbox>',
            '<hbox>',
            '<vbox pack="center"><label class="" value="Add tag(s):"/></vbox>',
            '<textbox class="browse-edit-addtag collapse" type="autocomplete" autocompletesearch="simple-autocomplete" showcommentcolumn="false" autocompletesearchparam=\'\' flex="1" ontextentered="reksidebar.browse.addTag($(this).parents(\'.browse-listitem-row.edit\'));"/>',
            //'<vbox pack="center">',
            //'<vbox class="rekbutton" tooltiptext="Add Tag" onclick="reksidebar.browse.addTag($(this).parents(\'.browse-listitem-row.edit\'));">',
            //'<image class="collapse" src="chrome://rekommend/skin/images/tag_orange_add12.png"/>',
            //'</vbox>',
            //'</vbox>',
            '</hbox>',
            '<hbox pack="center"><description class="collapse smaller" value="* Separate by comma - 34 max characters per tag "/></hbox>',
            '<spacer height="3"/>',
            '</vbox>',

            '<hbox class="browse-edit-private hidden"><checkbox class="browse-edit-private-checkbox small" label="Private"/></hbox>',

            '<hbox class="browse-edit-submit" pack="center">',
            '<hbox class="rekbutton" width="50" pack="center" onclick="reksidebar.browse.closeEdit(\'browse.sent\',$(this).parents(\'.browse-sent-listitem\'),\'save\');"><description class="small" value="Save"/></hbox>',
            '<spacer width="5"/>',
            '<hbox class="rekbutton" width="50" pack="center" onclick="reksidebar.browse.closeEdit(\'browse.sent\',$(this).parents(\'.browse-sent-listitem\'),\'cancel\');"><description class="small" value="Cancel"/></hbox>',
            '</hbox>',
            '</vbox>',
            '</row>',

            // comments row
            '<row class="browse-listitem-row comments {13}">',
            '<vbox flex="1">',
            '<vbox class="browse-comments-list">',
            '</vbox>',
            '<vbox class="browse-comments-submit">',
            '<textbox class="browse-comments-textbox" multiline="true" rows="2" height="36" value="" onfocus="reksidebar.Rek.skipPulse();" onblur="reksidebar.Rek.resumePulse();"/>',
            '<hbox pack="center"><button class="small" label="Add Comment" onclick="reksidebar.browse.addComment(\'browse.sent\',$(this).parents(\'.browse-sent-listitem\'));"/></hbox>',
            '</vbox>',
            '</vbox>',
            '</row>',

            // tags row
            '<row class="browse-listitem-row tags {14}">',
            '<vbox flex="1">',
            '<hbox class="browse-tags-list center">',
            '{15}',
            '</hbox>',
            '</vbox>',
            '</row>',

            '</rows>',
            '</grid>',
            '</hbox>'
            ],
            comment: [
            '<vbox class="comment-listitem" recid="{0}">',
            '<hbox class="{1}" pack="center"><hbox class="hover-button" onclick="reksidebar.browse.updateComments(\'{9}\',$(this).parents(\'.browse-listitem-row.comments\'),{6});">',
            '<vbox pack="center"><description class="collapse small" value="more..."/></vbox>',
            '</hbox></hbox>',
            '<vbox class="browse-comment-wrapper">',
            '<vbox class="browse-comment small{10}">',
            '<stack>',
            '<description class="break-word">{2}</description>',
            '<hbox class="browse-comment-close-wrapper{10}" pack="end"><vbox pack="start"><image class="browse-comment-close" src="chrome://rekommend/skin/images/close10.png" onclick="reksidebar.browse.removeComment(\'{9}\',$(this).parents(\'.comment-listitem\'));" tooltiptext="Remove comment"/></vbox></hbox>',
            '</stack>',
            '</vbox>',
            '<hbox class="comment-tag-right {4}" pack="end"><description class="comment-tag-description smaller" value="{3}"/><vbox pack="center"><image class="comment-tag-arrow" src="chrome://rekommend/skin/images/comment_arrow_right.png"/></vbox></hbox>',
            '<hbox class="comment-tag-left {5}" pack="start"><vbox pack="center"><image class="comment-tag-arrow" src="chrome://rekommend/skin/images/comment_arrow_left.png"/></vbox><description class="comment-tag-description smaller" value="{3}"/></hbox>',
            '</vbox>',
            '<hbox class="{7}" pack="center"><hbox class="hover-button" onclick="reksidebar.browse.updateComments(\'{9}\',$(this).parents(\'.browse-listitem-row.comments\'),{8});">',
            '<vbox pack="center"><description class="collapse small" value="more..."/></vbox>',
            '</hbox></hbox>',
            '</vbox>'
            ],
            note: [
            '<vbox class="comment-listitem" recid="{0}">',
            '<hbox class="{1}" pack="center"><hbox class="hover-button" onclick="reksidebar.browse.updateComments(\'{9}\',$(this).parents(\'.browse-listitem-row.comments\'),{6});">',
            '<vbox pack="center"><description class="collapse small" value="more..."/></vbox>',
            '</hbox></hbox>',
            '<vbox class="browse-note small">',
            '<stack>',
            '<description class="break-word">{2}</description>',
            '<hbox class="browse-comment-close-wrapper{10}" pack="end"><vbox pack="start"><image class="browse-comment-close" src="chrome://rekommend/skin/images/close10.png" onclick="reksidebar.browse.removeComment(\'{9}\',$(this).parents(\'.comment-listitem\'));" tooltiptext="Remove comment"/></vbox></hbox>',
            '</stack>',
            '</vbox>',
            '<hbox class="{7}" pack="center"><hbox class="hover-button" onclick="reksidebar.browse.updateComments(\'{9}\',$(this).parents(\'.browse-listitem-row.comments\'),{8});">',
            '<vbox pack="center"><description class="collapse small" value="more..."/></vbox>',
            '</hbox>',
            '</hbox>',
            '</vbox>'
            ],
            tag: [
            '<hbox class="tag-listitem{1}{2}" onclick="reksidebar.browse.tagClick(this);">',
            '<description class="tag-name small" value="{0}"/>',
            '<vbox pack="center" onclick="event.stopPropagation();reksidebar.browse.removeTag($(this).parents(\'.tag-listitem\'));"><image class="tag-closebox" src="chrome://rekommend/skin/images/close10.png"/></vbox>',
            '</hbox>'
            ],
            tagitem: [
            '<hbox class="tag-detail-item listitem" url="{1}" tiny="{3}" context="popup-browse2">',
            '<hbox>',
            '<vbox class="tag-detail-item-icon {2}" pack="center">',
            '</vbox>',
            '</hbox>',
            '<description class="browse-pagetitle hidden" value="{4}"/>',
            '<description class="small" value="{0}" flex="1" crop="end" tooltiptext="{1}" onclick="if (event.which == 1) reksidebar.Rek.openURLKey($(this).parents(\'.tag-detail-item\').attr(\'tiny\'));"/>',
            '</hbox>'
            ],
            itemPopup: [
            '<menuitem class="menuitem-non-iconic" label="Edit" oncommand="reksidebar.browse.showEdit(\'{0}\',$(document.popupNode).parents(\'.listitem\'));"/>',
            '<menuitem class="menuitem-non-iconic" label="Delete" oncommand="reksidebar.browse.removeRecords(\'{0}\',$(document.popupNode).parents(\'.listitem\'));"/>',
            '{1}'
            ],
            sentPopup: [
            '<menuitem class="menuitem-non-iconic" label="Delete" oncommand="reksidebar.browse.removeRecords(\'browse.sent\',$(document.popupNode).parents(\'.listitem\'));"/>',
            '{0}'
            ],
            top100: [
            '<hbox class="browse-top100-listitem listitem{0}" url="{1}" tiny="{2}" onclick="reksidebar.Rek.openURLKey($(this).attr(\'tiny\'));">',
            '<grid flex="1">',
            '<columns><column flex="1"/></columns>',
            '<rows>',
            '<row class="browse-listitem-item">',
            '<hbox class="collapse">',
            '<spacer width="5"/>',
            '<vbox flex="1">',

            '<hbox class="collapse" flex="1">',
            //'<vbox pack="center"><image src="chrome://rekommend/skin/images/rek_12.png"/></vbox><description class="browse-sub-description from small" value=" x {4}"/><spacer width="5"/>',
            '<description class="browse-top100-position right" width="22" value="{4}"/><spacer width="0"/>',
            '<description class="browse-title-static" value="{3}" flex="1" crop="end" tooltiptext="{3}"/>',
            '</hbox>',

            '</vbox>',
            '<spacer width="8"/>',
            '</hbox>',
            '</row>',

            '</rows>',
            '</grid>',
            '</hbox>'
            ],
            addTag: [
            '<vbox>',
            '<spacer height="5"/>',
            '<hbox>',
            '<vbox pack="center"><label value="Add tag(s):"/></vbox>',
            '<textbox id="bulk-addtag-textbox" type="autocomplete" flex="1" autocompletesearch="simple-autocomplete" showcommentcolumn="false" autocompletesearchparam=\'{0}\'/>',
            //'<vbox pack="center">',
            //'<vbox class="rekbutton" tooltiptext="Add Tag" onclick="reksidebar.browse.addTag($(this).parents(\'.browse-listitem-row.edit\'));">',
            //'<image class="collapse" src="chrome://rekommend/skin/images/tag_orange_add12.png"/>',
            //'</vbox>',
            //'</vbox>',
            '</hbox>',
            '<spacer height="2"/>',
            '<hbox pack="center"><description class="small" value="* Separate by comma - 34 max characters per tag "/></hbox>',
            '<spacer height="3"/>',
            '</vbox>',
            ]
        },

        // member variables
        curView: null,
        rootCount: 0,

        inboxCrc: null,
        inboxUnread: null,
        inboxStart: 0,
        inboxTotal: 0,
        inboxPageSize: 15,

        commentsCrc: null,
        commentsUnread: null,
        commentsStart: 0,
        commentsTotal: 0,
        commentsPageSize: 15,

        bmarkCrc: null,
        bmarkStart: 0,
        bmarkTotal: 0,
        bmarkPageSize: 15,

        sentCrc: null,
        sentStart: 0,
        sentTotal: 0,
        sentPageSize: 15,

        top100Crc: null,
        top100Start: 0,
        top100Total: 0,
        top100PageSize: 25,

        inlineCommentStart: 0,

        init: function() {
            reksidebar.Rek.log('browse init');

            this.inboxCrc = null;
            $('#broadcastBrowseInbox').attr('crc','');
            $('#broadcastBrowseInbox').attr('unread','');

            this.commentsCrc = null;
            $('#broadcastBrowseComments').attr('crc','');
            $('#broadcastBrowseComments').attr('unread','');

            this.bmarkCrc = null,
            $('#broadcastBrowseBmark').attr('crc','');

            this.sentCrc = null,
            $('#broadcastBrowseSent').attr('crc','');

            this.top100Crc = null,
            $('#broadcastBrowseTop100').attr('crc','');

            var idx = $('#browse-browse-menulist')[0].value;
            $('#browse-browse-deck').attr('selectedIndex',idx);
            this.curView = $('#browse-browse-menulist menuitem').eq(idx).attr('view');

            $('.browse-list-wrapper').empty();

            // update tag list
            this.updateTagList();

            // display options - set options to preferences
            $('.display-pref').each(function(i,v) {
                var pref = $(v).attr('pref');
                $(v).find('.display-option').removeClass('selected');
                $(v).find('.display-option[prefvalue='+reksidebar.Rek.user.data.preferences[pref]+']').addClass('selected');
            });

        //this.updatePager(this.curView);
        },
        tabclick: function(el) {
            var idx;
            var oldView = this.curView;
            switch ($(el).find('.tabbox-tab.active').attr('tab')) {
                case '0': // browse
                    idx = parseInt($('#browse-browse-menulist').val());
                    this.curView = $('#browse-browse-menulist menuitem:nth-child('+(idx+1)+')').attr('view');
                    switch (this.curView) {
                        case 'browse.folders':
                        case 'browse.tags':
                            $('#browse-pager').attr('hidden','true');
                            break;
                        default:
                            $('#browse-pager').attr('hidden','false');
                            break;
                    }
                    break;
                case '1': // top 100
                    this.curView = 'browse.top100';
                    $('#browse-pager').attr('hidden','false');
                    break;
            }
            if (oldView != this.curView) {
                this.updatePager(this.curView);
            }
        },
        onInboxListUpdate: function() {
            $('#broadcastBrowseInbox').attr('crc',this.inboxCrc);
            $('#broadcastBrowseInbox').attr('unread',this.inboxUnread);
        },
        updateInboxList: function() {
            reksidebar.Rek.log('update inbox list');
            var inbox = reksidebar.Rek.user.browse.inbox;
            var str = '',str2;
            var arr = [];
            var exEl,exRecId;
            // get the current selected recids
            $.each($('.browse-inbox-listitem checkbox.browse-checkbox:checked').parents('.browse-inbox-listitem'),function(i,v) {
                arr.push(parseInt($(v).attr('recid')));
            });

            exEl = $('.browse-inbox-listitem .browse-listitem-row.expanded');
            exRecId = $(exEl).parents('.browse-inbox-listitem').attr('recid');
            
            $('#browse-inbox-list').empty();
            $.each(inbox,function(i,r){
                var j,checked='false';
                for (j in arr) {
                    if (r.id == arr[j]) {
                        checked='true';
                        break;
                    }
                }

                // place tags
                str2 = '';
                $.each(r.tags,function(i,name) {
                    str2 += reksidebar.browse.templates.tag.join('').format(
                        reksidebar.Rek.xmlEncode(name),
                        (i==r.tags.length-1?' last':''),
                        ' orig'
                        );
                });

                str += reksidebar.browse.templates.inbox.join('').format(
                    i%2?' odd':' even',
                    r.id,
                    r.date_read===null?'unread':'',
                    r.alt_title?reksidebar.Rek.xmlEncode(r.alt_title):reksidebar.Rek.xmlEncode(r.title),
                    r.uid,
                    r.nodeid==reksidebar.Rek.user.data.rek_top_node_id?'Inbox':reksidebar.Rek.xmlEncode(r.nodename),
                    r.newcom=='0'?'':'red bold',
                    r.newcom=='0'?(r.com=='0'?'Add':r.com):r.newcom+' '+reksidebar.Rek.getProperty('new.label'),
                    reksidebar.Rek.xmlEncode(r.url),
                    r.com,
                    checked,
                    r.nodeid,
                    'rek',
                    (exEl.hasClass('comments') && r.id == exRecId)?'expanded':'',
                    r.rekid,
                    r.tags.length == '0'?'hidden':'',
                    r.tags.length,
                    (exEl.hasClass('tags') && r.id == exRecId)?'expanded':'',
                    r.priv == '0'?' public':'',
                    str2,
                    r.tiny,
                    reksidebar.Rek.xmlEncode(r.title),
                    reksidebar.Rek.user.data.preferences['inbox_twoline'] == '1'?'false':'true',
                    i == 0?' first':''
                    );
                        if (i == 0) reksidebar.Rek.log(str);
            });
            
            
            if (str) {
                reksidebar.Rek.appendDOMfromString($('#browse-inbox-list'),str);
                exEl = $('.browse-inbox-listitem .browse-listitem-row.expanded');
                if (exEl.hasClass('comments')) this.updateComments('browse.inbox',exEl,this.inlineCommentStart);
            //else if (exEl.hasClass('edit')) this.updateEdit('browse.inbox',exEl);

            }
            //$('#browse-browse-content stack > vbox:nth-child(1)').hide();
            //$('#browse-browse-content stack > vbox:nth-child(2)').show();

            // take care of pager
            this.updatePager();

            // take care of search results
            reksidebar.search.reload();

            // trigger a browse.folders update
            // set count to sum of reks and bookmarks in ungrouped folder -- this is generated in db fetch (browse.inbox)
            reksidebar.browse.folders.setCount(reksidebar.Rek.user.data.rek_top_node_id,this.rootCount);
        },
        updateInboxUnread: function() {
            reksidebar.Rek.log('update inbox unread');
            if (this.inboxUnread > 0) {
                $('#browse-browse-menulist menuitem:nth-child(1)').attr('label',reksidebar.Rek.getProperty('inbox.label')+' ('+this.inboxUnread+' '+reksidebar.Rek.getProperty('new.label')+')');
                $('#app-browse-tab-value').val(this.inboxUnread);
                $('#app-browse-tab-value-box').css('display','-moz-box');
            } else {
                $('#browse-browse-menulist menuitem:nth-child(1)').attr('label',reksidebar.Rek.getProperty('inbox.label'));
                $('#app-browse-tab-value-box').css('display','none');
            }
        },
        onCommentsListUpdate: function() {
            $('#broadcastBrowseComments').attr('crc',this.commentsCrc);
            $('#broadcastBrowseComments').attr('unread',this.commentsUnread);
        },
        updateCommentsList: function() {
            reksidebar.Rek.log('update comments list');
            var  comments = reksidebar.Rek.user.browse.comments;
            var str = '',str2,str3;
            var arr = [];
            var exEl,exRecId;
            // get the current selected recids
            $.each($('.browse-comments-listitem checkbox.browse-checkbox:checked').parents('.browse-comments-listitem'),function(i,v) {
                arr.push(parseInt($(v).attr('recid')));
            });

            exEl = $('.browse-comments-listitem .browse-listitem-row.expanded');
            exRecId = $(exEl).parents('.browse-comments-listitem').attr('recid');

            $('#browse-comments').empty();
            $.each(comments,function(i,r){
                var j,checked='false';
                for (j in arr) {
                    if (r.id == arr[j]) {
                        checked='true';
                        break;
                    }
                }

                // place tags
                str2 = '';
                $.each(r.tags,function(i,name) {
                    str2 += reksidebar.browse.templates.tag.join('').format(
                        reksidebar.Rek.xmlEncode(name),
                        (i==r.tags.length-1?' last':''),
                        ' orig'
                        );
                });
                //reksidebar.Rek.log(r);
                if (r.nodeid == reksidebar.Rek.user.data.rek_top_node_id) str3 = 'Inbox';
                else if (r.nodeid == reksidebar.Rek.user.data.sent_node_id) str3 = 'Sent';
                else str3 = reksidebar.Rek.xmlEncode(r.nodename);
                str += reksidebar.browse.templates.comments.join('').format(
                    i%2?' odd':' even',
                    r.id,
                    r.date_read===null?'unread':'',
                    r.alt_title?reksidebar.Rek.xmlEncode(r.alt_title):reksidebar.Rek.xmlEncode(r.title),
                    r.nodeid == reksidebar.Rek.user.data.sent_node_id?'To: '+r.sent:'From: '+r.uid,
                    str3,
                    r.newcom=='0'?'':'red bold',
                    r.newcom=='0'?(r.com=='0'?'Add comment':r.com):r.newcom+' '+reksidebar.Rek.getProperty('new.label'),
                    reksidebar.Rek.xmlEncode(r.url),
                    r.com,
                    checked,
                    r.nodeid,
                    //r.nodeid == reksidebar.Rek.user.data.sent_node_id?'sent':'rek',
                    'comment',
                    (exEl.hasClass('comments') && r.id == exRecId)?'expanded':'',
                    r.rekid,
                    r.tags.length == '0'?'hidden':'',
                    r.tags.length,
                    (exEl.hasClass('tags') && r.id == exRecId)?'expanded':'',
                    r.priv == '0'?' public':'',
                    str2,
                    r.tiny,
                    reksidebar.Rek.xmlEncode(r.title),
                    reksidebar.Rek.user.data.preferences['comments_twoline'] == '1'?'false':'true',
                    i == 0?' first':''
                    );
            });
            
            if (str) {
                reksidebar.Rek.appendDOMfromString($('#browse-comments'),str);
                exEl = $('.browse-comments-listitem .browse-listitem-row.expanded');
                if (exEl.hasClass('comments')) this.updateComments('browse.comments',exEl,this.inlineCommentStart);
            //else if (exEl.hasClass('edit')) this.updateEdit('browse.inbox',exEl);

            }
            //$('#browse-browse-content stack > vbox:nth-child(1)').hide();
            //$('#browse-browse-content stack > vbox:nth-child(2)').show();

            // take care of pager
            this.updatePager();

        // take care of search results
        //reksidebar.search.reload();
        },
        updateCommentsUnread: function() {
            reksidebar.Rek.log('update comments unread');
            if (this.commentsUnread > 0) {
                $('#browse-browse-menulist menuitem:nth-child(2)').attr('label','Comments ('+this.commentsUnread+' '+reksidebar.Rek.getProperty('new.label')+')');
            } else {
                $('#browse-browse-menulist menuitem:nth-child(2)').attr('label','Comments');
            }
        },
        onBmarkListUpdate: function() {
            $('#broadcastBrowseBmark').attr('crc',this.bmarkCrc);
        },
        updateBmarkList: function() {
            reksidebar.Rek.log('update bmark list');
            var bmark = reksidebar.Rek.user.browse.bmark;
            var str = '',str2;
            var arr = [];
            var exEl,exRecId;
            // get the current selected recids
            $.each($('.browse-bmark-listitem checkbox.browse-checkbox:checked').parents('.browse-bmark-listitem'),function(i,v) {
                arr.push(parseInt($(v).attr('recid')));
            });
            
            exEl = $('.browse-bmark-listitem .browse-listitem-row.expanded');
            exRecId = $(exEl).parents('.browse-bmark-listitem').attr('recid');

            $('#browse-bmark-list').empty();
            $.each(bmark,function(i,r){
                var j,checked='false';
                for (j in arr) {
                    if (r.id == arr[j]) {
                        checked='true';
                        break;
                    }
                }

                // place tags
                str2 = '';
                $.each(r.tags,function(i,name) {
                    str2 += reksidebar.browse.templates.tag.join('').format(
                        reksidebar.Rek.xmlEncode(name),
                        (i==r.tags.length-1?' last':''),
                        ' orig'
                        );
                });
                str += reksidebar.browse.templates.bmark.join('').format(
                    i%2?' odd':' even',
                    r.id,
                    r.alt_title?reksidebar.Rek.xmlEncode(r.alt_title):reksidebar.Rek.xmlEncode(r.title),
                    (r.nodeid==reksidebar.Rek.user.data.rek_top_node_id?'Ungrouped':reksidebar.Rek.xmlEncode(reksidebar.treeMgr.rekView.getNode(r.nodeid).name)),
                    reksidebar.Rek.xmlEncode(r.url),
                    checked,
                    r.nodeid,
                    'bookmark',
                    r.rekid,
                    (r.com=='0'?'Add note':r.com),
                    r.tags.length == '0'?'hidden':'',
                    r.tags.length,
                    r.priv == '0'?' public':'',
                    (exEl.hasClass('comments') && r.id == exRecId)?'expanded':'',
                    (exEl.hasClass('tags') && r.id == exRecId)?'expanded':'',
                    str2,
                    r.tiny,
                    reksidebar.Rek.xmlEncode(r.title),
                    reksidebar.Rek.user.data.preferences['bmark_twoline'] == '1'?'false':'true',
                    i == 0?' first':'',
                    r.com
                    );
            });
            if (str) {
                reksidebar.Rek.appendDOMfromString($('#browse-bmark-list'),str);
                exEl = $('.browse-bmark-listitem .browse-listitem-row.expanded');
                if (exEl.hasClass('comments')) this.updateComments('browse.bmark',exEl,this.inlineCommentStart);
            }
            $('#browse-bmark-content stack > vbox:nth-child(1)').hide();
            $('#browse-bmark-content stack > vbox:nth-child(2)').show();

            // take care of pager
            this.updatePager();

            // take care of search results
            reksidebar.search.reload();
        },
        onSentListUpdate: function() {
            $('#broadcastBrowseSent').attr('crc',this.sentCrc);
        },
        updateSentList: function() {
            reksidebar.Rek.log('update sent list');
            var sent = reksidebar.Rek.user.browse.sent;
            var str = '',str2;
            var arr = [];
            var exEl,exRecId;
            // get the current selected recids
            $.each($('.browse-sent-listitem checkbox.browse-checkbox:checked').parents('.browse-sent-listitem'),function(i,v) {
                arr.push(parseInt($(v).attr('recid')));
            });

            exEl = $('.browse-sent-listitem .browse-listitem-row.expanded');
            exRecId = $(exEl).parents('.browse-sent-listitem').attr('recid');

            $('#browse-sent-list').empty();
            $.each(sent,function(i,r){
                var j,checked='false';
                for (j in arr) {
                    if (r.id == arr[j]) {
                        checked='true';
                        break;
                    }
                }

                // place tags
                str2 = '';
                $.each(r.tags,function(i,name) {
                    str2 += reksidebar.browse.templates.tag.join('').format(
                        reksidebar.Rek.xmlEncode(name),
                        (i==r.tags.length-1?' last':''),
                        ' orig'
                        );
                });

                str += reksidebar.browse.templates.sent.join('').format(
                    i%2?' odd':' even',
                    r.id,
                    r.alt_title?reksidebar.Rek.xmlEncode(r.alt_title):reksidebar.Rek.xmlEncode(r.title),
                    reksidebar.Rek.xmlEncode(r.url),
                    r.sent,
                    checked,
                    'rek',
                    r.newcom=='0'?'':'red bold',
                    r.newcom=='0'?(r.com=='0'?'Add':r.com):r.newcom+' '+reksidebar.Rek.getProperty('new.label'),
                    r.priv == '0'?' public':'',
                    r.rekid,
                    r.tags.length == '0'?'hidden':'',
                    r.tags.length,
                    (exEl.hasClass('comments') && r.id == exRecId)?'expanded':'',
                    (exEl.hasClass('tags') && r.id == exRecId)?'expanded':'',
                    str2,
                    reksidebar.Rek.user.data.sent_node_id,
                    r.tiny,
                    reksidebar.Rek.xmlEncode(r.title),
                    reksidebar.Rek.user.data.preferences['sent_twoline'] == '1'?'false':'true',
                    i == 0?' first':'',
                    r.com
                    );
            });
            //reksidebar.Rek.log(str);
            if (str) {
                reksidebar.Rek.appendDOMfromString($('#browse-sent-list'),str);
                //$('#browse-browse-select-toggle').attr('action','select');
                //$('#browse-browse-select-toggle').find('description').val(reksidebar.Rek.getProperty('rek.rekommend.select'));
                $('#browse-browse-sent .browse-comments-wrapper:not(.expanded)').hide();
                exEl = $('.browse-sent-listitem .browse-listitem-row.expanded');
                if (exEl.hasClass('comments')) this.updateComments('browse.sent',exEl,this.inlineCommentStart);
            }
            $('#browse-sent-content stack > vbox:nth-child(1)').hide();
            $('#browse-sent-content stack > vbox:nth-child(2)').show();

            // take care of pager
            this.updatePager();

            // take care of search results
            reksidebar.search.reload();
        },
        updateTagList: function() {
            reksidebar.Rek.log('update browse.tags');
            var str = '';
            // sort the list...
            var _sortFunc = function(a,b) {
                //reksidebar.Rek.log(reksidebar.Rek.user.data.preferences['tag_sort']);
                //reksidebar.Rek.log(a);
                //reksidebar.Rek.log(b);
                switch (reksidebar.Rek.user.data.preferences['tag_sort']) {
                    case 'date':
                        if (a.date < b.date) result = 1;
                        else result = -1;
                        break;
                    case 'popular':
                        if (a.count < b.count) result = 1;
                        else result = -1;
                        break;
                    default: // name sort
                        if (a.name <= b.name) result = -1;
                        else result = 1;
                }

                return result;
            };
            reksidebar.Rek.user.data.tagList.sort(_sortFunc);
            $.each(reksidebar.Rek.user.data.tagList,function(i,tag){
                if (tag.count > 0) {
                    str += reksidebar.browse.templates.tags.join('').format(
                        tag.id,
                        reksidebar.Rek.xmlEncode(tag.name),
                        tag.count
                        );
                }
            });
            
            
            $('#browse-tags-list').empty();
            if (str) {
                reksidebar.Rek.appendDOMfromString($('#browse-tags-list'),str);
            }
            $('#browse-sent-content stack > vbox:nth-child(2)').show();

            // take care of search results
            reksidebar.search.reload();
        },
        onTop100Update: function() {
            $('#broadcastBrowseTop100').attr('crc',this.top100Crc);
        },
        updateTop100: function() {
            reksidebar.Rek.log('update top100');
            var self=this,str = '';
            $('#browse-top100-list').empty();
            $.each(reksidebar.Rek.user.browse.top100,function(i,r){
                str += reksidebar.browse.templates.top100.join('').format(
                    i%2?' odd':' even',
                    reksidebar.Rek.xmlEncode(r.url),
                    r.tiny,
                    reksidebar.Rek.xmlEncode(r.title),
                    //r.count
                    self.top100Start+i+1
                    );
            });
            //reksidebar.Rek.log(str);
            if (str) {
                reksidebar.Rek.appendDOMfromString($('#browse-top100-list'),str);
            }

            // take care of pager
            this.updatePager();
        },
        menuSelect: function(el) {
            var view;
            var index = parseInt(el.value);
            view = $('#browse-browse-menulist menuitem:nth-child('+(index+1)+')').attr('view');
            $('#browse-browse-deck').attr('selectedIndex',index);
            switch (view) {
                case 'browse.inbox':
                case 'browse.comments':
                case 'browse.bmark':
                case 'browse.sent':
                    $('#browse-pager').attr('hidden','false');
                    break;
                case 'browse.tags':
                    $('#browse-pager').attr('hidden','true');
                    this.updateTagList();
                    break;
                case 'browse.folders':
                    $('#browse-pager').attr('hidden','true');
                    break;
            }
            this.closeAllExpanded();
            this.curView = view;
            this.updatePager(view);
        },
        read: function(view,el,where) {
            reksidebar.Rek.openURLKey($(el).attr('tiny'),where);
            this.markAsRead(view,$(el));
        },
        markAsRead: function(view,$el) {
            //var o = this.describeView(view);
            var arr = [];
            $.each($el,function(i,v){
                if ($(v).find('.browse-title-static').hasClass('unread')) arr.push($(v).attr('recid'));
            });
            if (arr.length) {
                reksidebar.Rek.db.setRecordSet('rek_in_tree_node','date_read',arr,reksidebar.Rek.date('c',new Date().getTime()/1000));

                $el.find('.browse-title-static').removeClass('unread');
                this.inboxUnread -= arr.length;
                $('#broadcastBrowseInbox').attr('unread',this.inboxUnread);
            }
        },
        moveToNode: function(view,$sel) {
            reksidebar.Rek.log('MOVE TO NODE');
            var o = this.describeView(view);
            var _moveToNodeCallback = function(obj) {
                if (obj.id) {
                    var arr = [];
                    //var changed = [];
                    //changed.push(parseInt(obj.id));
                    $.each($sel,function(i,v) {
                        var nodeId = parseInt($(v).attr('nodeid'));
                        arr.push($(v).attr('recid'));
                        //arr.push(nodeId);
                        //changed.push(nodeId);
                        $(v).attr('nodeid',obj.id.toString());
                        $(v).find('.browse-sub-description.node').attr('nodeid',obj.id.toString());
                        // handle the folder counts
                        if (obj.id != nodeId) {
                            reksidebar.browse.folders.incCount(obj.id,1);
                            reksidebar.browse.folders.decCount(nodeId,1);
                        }
                    });
                    // update the database
                    reksidebar.Rek.db.setRecordSet(o.table,'tree_node_id',arr,obj.id,function(){
                        reksidebar.browse.reload([view]);
                    });
                    if (obj.id != reksidebar.Rek.user.data.rek_top_node_id) $sel.find('.browse-sub-description.node').val(obj.name);
                    else $sel.find('.browse-sub-description.node').val(o.root);
                    // force update of folder names
                    //var v = parseInt($('#broadcastTreeUpdate').attr('rek'))+1;
                    //$('#broadcastTreeUpdate').attr('rek',v.toString());
                }
            };
            reksidebar.treeMgr.showRekViewPopup(o.type,_moveToNodeCallback);
        },
        moveSelectedToNode: function(view) {
            var o = this.describeView(view);
            var $sel;
            $sel = $('.'+o.listCls+' checkbox.browse-checkbox:checked').parents('.'+o.listCls);
            if ($sel.length) {
                this.closeAllExpanded();
                this.moveToNode(view,$sel);
            }
        },
        rekFolderUpdate: function() {
            reksidebar.Rek.log('update folder names');
            $.each($('.browse-sub-description.node'),function(i,v) {
                var nodename = '';
                var nodeid = parseInt($(v).attr('nodeid'));
                var iterate = function(arr) {
                    var i;
                    for (i=0;i<arr.length;i++) {
                        if (arr[i].id == nodeid) {
                            nodename = arr[i].name;
                            break;
                        }
                        if (arr[i].children.length && !nodename) {
                            iterate(arr[i].children);
                        }
                    }
                    $(v).val(nodename);
                }
                if (nodeid != reksidebar.Rek.user.data.rek_top_node_id) iterate(reksidebar.Rek.user.data.rekTree);
            });
        },
        startEdit: function(el) {
            var textbox = $(el).next();
            reksidebar.Rek.skipPulse();
            $(el).hide();
            $(textbox).css('display','block').focus();
            //$(textbox).show().focus();
            $(textbox)[0].setSelectionRange(0,$(textbox).val().length);
        },
        stopEdit: function(view,el) {
            var arr = [];
            var o = this.describeView(view);
            var prev = $(el).prev()[0];
            var val = $(el).val();
            if (val && val != $(prev).val()) {
                $(prev).val(val);
                arr.push($(el).parents('.'+o.listCls).attr('recid'));
                reksidebar.Rek.db.setRecordSet(o.table,'alt_description',arr,val);
            } else {
                $(el).val($(prev).val());
            }
            $(el).hide();
            $(prev).show();
            reksidebar.Rek.resumePulse();
        },
        updatePager: function(view) {
            if (!view) view = this.curView;
            var o = this.describeView(view);
            //reksidebar.Rek.log(o);
            // total pages
            var total = parseInt(Math.floor(o.pagerTotal/o.pageSize)+(o.pagerTotal%o.pageSize > 0));
            if (total == 0) total = 1;
            $('#'+o.pagerEl+' .pager-total-pages').val('of '+total);
            // current page
            $('#'+o.pagerEl+' .pager-curpage').val(Math.floor(o.pagerStart/o.pageSize)+1).blur();
            // range
            if (o.pagerTotal > 0) $('#'+o.pagerEl+' .pager-range').val((o.pagerStart+1)+' - '+(o.pagerStart+o.data.length)+' of '+o.pagerTotal);
            else $('#'+o.pagerEl+' .pager-range').val(reksidebar.Rek.getProperty('rek.emptyResultSet'));
        },
        pagerFirst: function(view) {
            var o = this.describeView(view);
            var curPage;
            curPage = Math.floor(o.pagerStart/o.pageSize);
            if (curPage != 0) this.gotoPage(o,0);
        },
        pagerPrev: function(view) {
            var o = this.describeView(view);
            var curPage;
            curPage = Math.floor(o.pagerStart/o.pageSize);
            if (curPage > 0) this.gotoPage(o,curPage-1);
        },
        pagerNext: function(view) {
            var o = this.describeView(view);
            var curPage,maxPage;
            curPage = Math.floor(o.pagerStart/o.pageSize);
            maxPage = Math.floor(o.pagerTotal/o.pageSize)+(o.pagerTotal%o.pageSize > 0) - 1;
            if (curPage < maxPage) this.gotoPage(o,curPage+1);
        },
        pagerLast: function(view) {
            var o = this.describeView(view);
            var curPage,maxPage;
            curPage = Math.floor(o.pagerStart/o.pageSize);
            maxPage = Math.floor(o.pagerTotal/o.pageSize)+(o.pagerTotal%o.pageSize > 0) - 1;
            if (curPage != maxPage) this.gotoPage(o,maxPage);
        },
        pagerToPage: function(view,page) {
            var o = this.describeView(view);
            var curPage,maxPage;
            page -=1;
            curPage = parseInt(Math.floor(o.pagerStart/o.pageSize));
            maxPage = parseInt(Math.floor(o.pagerTotal/o.pageSize)+(o.pagerTotal%o.pageSize > 0) - 1);
            if (page < 0 || page > maxPage) {
                $('#'+o.pagerEl+' .pager-curpage').val(curPage+1).blur();
            } else {
                this.gotoPage(o,page);
            }
        },
        gotoPage: function(viewObj,page) {
            reksidebar.Rek.log('goto page:'+page)
            var requestArr = [];
            switch (viewObj.view) {
                case 'browse.inbox':
                    this.inboxStart = viewObj.pageSize*page;
                    break;
                case 'browse.comments':
                    this.commentsStart = viewObj.pageSize*page;
                    break;
                case 'browse.bmark':
                    this.bmarkStart = viewObj.pageSize*page;
                    break
                case 'browse.sent':
                    this.sentStart = viewObj.pageSize*page;
                    break;
                case 'browse.top100':
                    this.top100Start = viewObj.pageSize*page;
                    break;
                case 'search.all':
                case 'search.mine':
                    reksidebar.search.start = viewObj.pageSize*page;
                    break;
            }
            this.reload([viewObj.view]);
        },
        removeSelected: function(view) {
            var o = this.describeView(view);
            var $sel;
            $sel = $('.'+o.listCls+' checkbox.browse-checkbox:checked').parents('.'+o.listCls);
            if ($sel.length) this.removeRecords(view,$sel);
        },
        removeRecords: function(view,$sel) {
            var o = this.describeView(view);
            var arr = [];
            //reksidebar.Rek.log(view);
            //reksidebar.Rek.log($sel);
            //reksidebar.Rek.log(view+'.removeTitle');
            //reksidebar.Rek.log(reksidebar.Rek.getProperty(view+'.removeTitle'));
            switch (view) {
                case 'browse.inbox':
                case 'browse.comments':
                case 'browse.bmark':
                case 'browse.sent':
                    if ($sel.siblings().length == 0 && this.bmarkStart >= o.pageSize) this.bmarkStart -= o.pageSize;
                    if ($sel.length > 0) {
                        $.each($sel,function(i,val){
                            arr.push($(val).attr('recid'));
                        });
                        reksidebar.modal.open({
                            title:reksidebar.Rek.getProperty(view+'.removeTitle'),
                            icon:'exclamation.png',
                            text:reksidebar.Rek.getProperty(view+'.removeText'),
                            skip:'br_rm',
                            buttons:[{
                                label:'Remove',
                                callback: function() {
                                    reksidebar.modal.close(this);
                                    if (reksidebar.Rek.db.setActiveStatus(o.table,arr,'false')) {
                                        // update tag count
                                        $.each($sel,function(i,el){
                                            $.each($(el).find('.tag-name'),function(j,tagEl){
                                                var tagName = $(tagEl).val();
                                                $.each(reksidebar.Rek.user.data.tagList,function(k,rec){
                                                    if (rec.name == tagName) {
                                                        rec.count--;
                                                        if (rec.count < 0) rec.count = 0;
                                                        return false;
                                                    }
                                                });
                                            });
                                            // update folder count
                                            var nodeid = $(el).attr('nodeid');
                                            reksidebar.browse.folders.decCount(nodeid,1);
                                        });
                                        reksidebar.browse.updateTagList();
                                        $sel.remove();
                                        reksidebar.browse.reload([view]);
                                    }
                                }
                            },{
                                label:'Cancel',
                                callback: function(){
                                    reksidebar.modal.close(this);
                                }
                            }]
                        });
                    }
                    break;
                case 'browse.tags':
                    reksidebar.Rek.log('remove tags');
                    if ($sel.length > 0) {
                        reksidebar.modal.open({
                            title:reksidebar.Rek.getProperty('browse.tags.removeTitle'),
                            icon:'exclamation.png',
                            text:reksidebar.Rek.getProperty('browse.tags.removeText'),
                            skip:'br_rm',
                            buttons:[{
                                label:'Remove',
                                callback: function() {
                                    reksidebar.modal.close(this);
                                    $.each($sel,function(i,val){
                                        arr.push($(val).attr('tag'));
                                    });
                                    $.ajax({
                                        type: 'POST',
                                        async: true,
                                        url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/removeTag.php',
                                        data: {
                                            id:reksidebar.Rek.user.id,
                                            session:reksidebar.Rek.user.session,
                                            arr:JSON.stringify(arr)
                                        },
                                        dataType: 'text',
                                        success: function(text){
                                            json = JSON.parse(text);
                                            $.each(arr,function(i,name){
                                                $.each(reksidebar.Rek.user.data.tagList,function(k,rec){
                                                    if (rec.name == name) {
                                                        rec.count = 0;
                                                        return false;
                                                    }
                                                });
                                            });
                                            $sel.remove();
                                            // update the views
                                            reksidebar.browse.reload(['browse.inbox','browse.bmark','browse.sent']);
                                        },
                                        error: function(req,status,error){
                                            // check on system status
                                            reksidebar.Rek.validateStatus(status);
                                        }
                                    });
                                }
                            },{
                                label:'Cancel',
                                callback: function(){
                                    reksidebar.modal.close(this);
                                }
                            }]
                        });
                    }
                    break;
            }
            
        },
        rekommend: function(view) {
            var o = this.describeView(view);
            var arr = [];
            $.each($('.'+o.listCls+' checkbox.browse-checkbox:checked').parents('.'+o.listCls),function(i,v){
                var type = $(v).attr('type');
                if (type == 'sent') type = 'rek';
                arr.push({
                    id: $(v).attr('recid'),
                    type: type,
                    title: $(v).find('.browse-pagetitle').val(),
                    alt: $(v).find('.browse-title-static').val(),
                    url: $(v).attr('url')
                });
            });
            if (arr.length) reksidebar.rekommend.showPopupRekommend(arr);
        },
        rekommendItem: function(el) {
            var arr = [];
            var type = $(el).attr('type');
            if (type == 'sent') type = 'rek';
            arr.push({
                id: $(el).attr('recid'),
                type: type,
                title: $(el).find('.browse-pagetitle').val(),
                alt: $(el).find('.browse-title-static').val(),
                url: $(el).attr('url')
            });
            reksidebar.rekommend.showPopupRekommend(arr);
        },
        bmark: function(view) {
            var o = this.describeView(view);
            var arr = [];
            $.each($('.'+o.listCls+' checkbox.browse-checkbox:checked').parents('.'+o.listCls),function(i,v){
                var type = $(v).attr('type');
                if (type == 'sent') type = 'rek';
                arr.push({
                    type: type,
                    title: $(v).find('.browse-pagetitle').val(),
                    alt: $(v).find('.browse-title-static').val(),
                    url: $(v).attr('url')
                });
            });
            if (arr.length) reksidebar.bmark.showPopupBmark(arr);
        },
        bmarkItem: function(el) {
            var arr = [];
            var type = $(el).attr('type');
            if (type == 'sent') type = 'rek';
            arr.push({
                id: $(el).attr('recid'),
                type: type,
                title: $(el).find('.browse-pagetitle').val(),
                alt: $(el).find('.browse-title-static').val(),
                url: $(el).attr('url')
            });
            //reksidebar.Rek.log(arr);
            reksidebar.bmark.showPopupBmark(arr);
        },
        updateComments: function(view,el,start) {
            var self = this;
            var limit = 5;
            var parent = $(el).parents('.listitem');
            this.inlineCommentStart = start;
            //$(el).children().attr('hidden','true');
            parent.siblings().andSelf().find('.browse-listitem-row').removeClass('expanded');
            //$(parent).find('.browse-listitem-row.loader').addClass('expanded');
            // ajax call for comments
            reksidebar.Rek.log('get comments');
            $.ajax({
                type: 'POST',
                async: true,
                url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/getComments.php',
                data: {
                    id:reksidebar.Rek.user.id,
                    session:reksidebar.Rek.user.session,
                    view: view,
                    recid: parent.attr('recid'),
                    rekid: parent.attr('rekid'),
                    start: start,
                    limit: limit
                },
                dataType: 'json',
                success: function(json){
                    //reksidebar.Rek.log//(json);
                    //json = JSON.parse(text);
                    var list = $(el).find('.browse-comments-list')[0];
                    var template;
                    var str = '';
                    var isOwner;
                    var dec;
                    
                    // remove the highlighting
                    //.browse-sub-description.comment
                    //reksidebar.Rek.log(parent);
                    //reksidebar.Rek.log(parent.find('.browse-sub-description.comment'));
                    dec = parseInt(parent.find('.browse-sub-description.comment').val());
                    $('.listitem[rekid="'+parent.attr('rekid')+'"] .browse-sub-description.comment').each(function(i,v){
                        num = $(v).attr('total');
                        if (parent.attr('type') == 'bookmark') {
                            $(v).val(num == 0?'Add note':num).removeClass('red bold');
                        } else {
                            $(v).val(num == 0?'Add':num).removeClass('red bold');
                        }
                    });
                    // update the menu
                    self.commentsUnread -= dec;
                    self.updateCommentsUnread();
                    //var height = 92 + json.data.length * 800;
                    $.each(json.data,function(i,r){
                        switch (view) {
                            case 'browse.inbox':
                            case 'browse.sent':
                            case 'browse.comments':
                                template = reksidebar.browse.templates.comment;
                                break;
                            case 'browse.bmark':
                                template = reksidebar.browse.templates.note;
                                break;
                            case 'search.mine':
                                if (parent.attr('type') == 'bookmark') template = reksidebar.browse.templates.note;
                                else template = reksidebar.browse.templates.comment;
                                break;
                        }
                        isOwner = r.aid == reksidebar.Rek.user.id;
                        str += template.join('').format(
                            r.id,
                            (i != 0 || start+limit >= json.numrows?'hidden':''),
                            reksidebar.Rek.xmlEncode(r.tx).replace(new RegExp("(\\w{20})(?=\\w)", "g"), "$1&#8203;"),
                            r.uid+'    '+r.dt,
                            isOwner?'hidden':'',
                            isOwner?'':'hidden',
                            start+limit,
                            (i != json.data.length-1 || start == 0?'hidden':''),
                            (start-limit<0?0:start-limit),
                            view,
                            isOwner?' owner':''
                            );
                    });
                    $(list).empty();
                    reksidebar.Rek.appendDOMfromString($(list),str);
                    //$(parent).find('.browse-listitem-row.loader').removeClass('expanded');
                    reksidebar.Rek.skipPulse();
                    $(el).addClass('expanded');
                },
                error: function(req,status,error){
                    // check on system status
                    reksidebar.Rek.validateStatus(status);
                }
            });
        },
        showComments: function(view,el) {
            if ($(el).hasClass('expanded')) {
                $(el).removeClass('expanded');
                reksidebar.Rek.resumePulse();
                reksidebar.browse.reload([view,'browse.comments']);
            } else {
                this.closeAllExpanded();
                this.updateComments(view,el,0);
            }
        },
        addComment: function(view,el) {
            reksidebar.Rek.log('add comment');
            var textbox = $(el).find('.browse-comments-textbox');
            var text = $(textbox).val();
            if (text.length) {
                $.ajax({
                    type: 'POST',
                    async: true,
                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/addComment.php',
                    data: {
                        id:reksidebar.Rek.user.id,
                        session:reksidebar.Rek.user.session,
                        //view: view,
                        recid: $(el).attr('recid'),
                        rekid: $(el).attr('rekid'),
                        text: text
                    },
                    dataType: 'text',
                    success: function(json){
                        //reksidebar.Rek.log(json);
                        $(textbox).val('');
                        //reksidebar.browse.updateComments($(el).find('.browse-comments-wrapper'),0);
                        reksidebar.browse.inlineCommentStart = 0;
                        reksidebar.browse.reload([view,'browse.comments']);
                    },
                    error: function(req,status,error){
                        // check on system status
                        reksidebar.Rek.validateStatus(status);
                    }
                });
            }
        },
        removeComment: function(view,el) {
            reksidebar.Rek.log('remove comment');
            var arr = [];
            arr.push(el.attr('recid'));
            reksidebar.Rek.db.setActiveStatus('rek_comment',arr,'false',function(){
                reksidebar.browse.reload([view,'browse.comments']);
            });
        },
        showTags: function(view,el) {
            var tagEl = $(el).find('.browse-listitem-row.tags');
            if (tagEl.hasClass('expanded')) {
                tagEl.removeClass('expanded');
            } else {
                this.closeAllExpanded();
                $.each(el.siblings().andSelf(),function(i,v){
                    $(v).find('.browse-listitem-row').removeClass('expanded');
                })
                tagEl.addClass('expanded');
            }
        },
        removeTag: function(tagEl) {
            if (tagEl.hasClass('last')) tagEl.prev().addClass('last');
            tagEl.addClass('hidden');
        },
        addTag: function(el) {
            /*var dup=false,str;
            var tag = reksidebar.Rek.trim(el.find('.browse-edit-addtag').val().toLowerCase());
            if (tag) {
                // check for duplicate
                $.each(el.find('.tag-listitem:not(.hidden) .tag-name'),function(i,v){
                    if (tag == $(v).val()) {
                        dup = true;
                        return false;
                    }
                });
                if (!dup) {
                    str = reksidebar.browse.templates.tag.join('').format(reksidebar.Rek.xmlEncode(tag),' last','');
                    el.find('.tag-listitem:not(.hidden):last').removeClass('last');
                    reksidebar.Rek.appendDOMfromString(el.find('.browse-tags-list'),str);
                    el.find('.browse-edit-addtag').val('').focus();
                }
            }*/
            var arr = this.parseUniqueTags(el,el.find('.browse-edit-addtag').val()),
                str = '';
            if (arr.length) {
                el.find('.tag-listitem:not(.hidden)').removeClass('last');
                $.each(arr,function(i,tag){
                    str += reksidebar.browse.templates.tag.join('').format(reksidebar.Rek.xmlEncode(tag),'','');
                });
                reksidebar.Rek.appendDOMfromString(el.find('.browse-tags-list'),str);
                el.find('.tag-listitem:not(.hidden):last').addClass('last');
                el.find('.browse-edit-addtag').val('').focus();
            }
        },
        bulkAddTag: function(view) {
            var o = this.describeView(view);
            var $sel;
            $sel = $('.'+o.listCls+' checkbox.browse-checkbox:checked').parents('.'+o.listCls);
            if ($sel.length) {
                var tagArr = [];
                $.each(reksidebar.Rek.user.data.tagList,function(i,v){
                    tagArr.push({
                        value:v.name
                    })
                });
                reksidebar.modal.open({
                    id:'dialog2',
                    template:'insert',
                    title:'Add Tags',
                    text:[reksidebar.browse.templates.addTag.join('').format(JSON.stringify(tagArr))],
                    buttons:[{
                        label:'Add',
                        callback: function() {
                            var recArr = [],tagArr = $('#bulk-addtag-textbox').val().toLowerCase().split(',');
                            $sel.each(function(i,el){
                                recArr.push($(el).attr('recid'));
                            });
                            $.ajax({
                                type: 'POST',
                                async: true,
                                url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/bulkAddTags.php',
                                data: {
                                    id:reksidebar.Rek.user.id,
                                    session:reksidebar.Rek.user.session,
                                    records:JSON.stringify(recArr),
                                    tags:JSON.stringify(tagArr)
                                },
                                dataType: 'json',
                                success: function(json){
                                    //reksidebar.Rek.log(json);
                                    if (json.result == 0) {
                                        reksidebar.Rek.user.data.tagList = json.tagList;
                                        reksidebar.browse.reload([view,'browse.tags']);
                                    } else {
                                        // failed session validation
                                    }
                                },
                                error: function(req,status,error){
                                    // check on system status
                                    reksidebar.Rek.validateStatus(status);
                                }
                            });

                            reksidebar.modal.close(this);
                        }
                    },{
                        label:'Cancel',
                        callback: function(){
                            reksidebar.modal.close(this);
                        }
                    }]
                });
            }
        },
        parseUniqueTags: function(el,tagstr) {
            var arr = [],
                tagArr = [],
                dup;
            arr = tagstr.toLowerCase().split(',');
            $.each(arr,function(i,tag){
                tag = reksidebar.Rek.trim(tag);
                dup = false;
                if (tag.length > 0 && tag.length < 35) {
                    // check for duplicate
                    $.each(el.find('.tag-listitem:not(.hidden) .tag-name'),function(j,u){
                        if (tag == $(u).val()) {
                            dup = true;
                            return false;
                        }
                    });
                    if (!dup) tagArr.push(tag);
                }
            });

            return tagArr;
        },
        toggleTag: function(el) {
            if (el.find('.browse-tags-detail').hasClass('expanded')) {
                this.closeTag(el);
            } else {
                this.showTagDetail(el);
            }
        },
        closeTag: function(el) {
            el.find('.twisty').removeClass('expanded');
            el.find('.browse-tags-detail').removeClass('expanded');
        },
        collapseTags: function() {
            $('.browse-tags-listitem .twisty').removeClass('expanded');
            $('.browse-tags-listitem .browse-tags-detail').removeClass('expanded');
        },
        expandTags: function() {
            reksidebar.browse.showTagDetail($('.browse-tags-listitem'));
        },
        showTagDetail: function(tagEl) {
            var arr = [];
            $.each(tagEl,function(i,v){
                arr.push($(v).attr('tag'));
                $(v).find('.twisty').addClass('expanded');
            });
            // make ajax call to get tag detail
            $.ajax({
                type: 'POST',
                async: true,
                url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/getTagDetail.php',
                data: {
                    id:reksidebar.Rek.user.id,
                    session:reksidebar.Rek.user.session,
                    arr:JSON.stringify(arr)
                },
                dataType: 'json',
                success: function(json){
                    reksidebar.Rek.log(json);
                    $.each(tagEl,function(i,v){
                        var el = $(v).find('.browse-tags-detail>vbox');
                        var str = '';
                        el.empty();
                        // sort the items
                        var _sortFunc = function(a,b) {
                            //reksidebar.Rek.log(a);
                            //reksidebar.Rek.log(b);
                            return a.alt_title.toLowerCase() > b.alt_title.toLowerCase();
                        }
                        json[i].list.sort(_sortFunc);
                        $.each(json[i].list,function(i,v){
                            str += reksidebar.browse.templates.tagitem.join('').format(
                                v.alt_title?reksidebar.Rek.xmlEncode(v.alt_title):reksidebar.Rek.xmlEncode(v.title),
                                reksidebar.Rek.xmlEncode(v.url),
                                v.type,
                                v.tiny,
                                reksidebar.Rek.xmlEncode(v.title)
                                );
                        });
                        reksidebar.Rek.appendDOMfromString(el,str);
                        $(v).find('.browse-tags-detail').addClass('expanded');
                    });
                },
                error: function(req,status,error){
                    // check on system status
                    reksidebar.Rek.validateStatus(status);
                }
            });
        },
        tagClick: function(el) {
            var box = $('#browse-tags-list')[0];
            var tag = $(el).find('.tag-name').val();
            if ($(el).parents('.browse-listitem-row').hasClass('tags')) {
                this.closeAllExpanded();
                // show browse tab
                reksidebar.showAppTab(reksidebar.Rek.CONST.SIDEBARTAB_BROWSE);
                // change the menu - fires update of the tag list
                $('#browse-browse-menulist').val('4');
                this.curView = 'browse.tags';
                this.updatePager();

                // expand the clicked tag
                $.each($('#browse-tags-list .browse-tags-listitem'),function(i,v){
                    if ($(v).attr('tag') == tag) {
                        reksidebar.browse.showTagDetail($(v));
                        box.scrollTop = v.boxObject.screenY - box.boxObject.screenY;
                    }
                });
            }
        },
        nodeClick: function(view,el) {
            // show browse tab
            reksidebar.showAppTab(reksidebar.Rek.CONST.SIDEBARTAB_BROWSE);
            var nodeid = $(el).attr('nodeid');
            if (nodeid == reksidebar.Rek.user.data.sent_node_id) {
                $('#browse-browse-menulist').val('5');
                this.curView = 'browse.sent';
                this.updatePager();
            } else {
                // open the node (and its parents) in browse.folders
                reksidebar.browse.folders.openById(nodeid);
                // scroll the browse.folders view if necessary
                var el2 = $('.browse-folders-folder[recid='+nodeid+']')[0];
                var box = $('#browse-folders-list')[0];
                box.scrollTop = el2.boxObject.screenY - box.boxObject.screenY;
                // highligh (select) the folder
                $('#browse-folders-list .listitem').removeClass('selected');
                $(el2).addClass('selected');
                // change the view
                $('#browse-browse-menulist').val('3');
                this.curView = 'browse.folders';
                this.updatePager();
            }
        },
        updateEdit: function(view,el) {
            var parent = el.parents('.listitem');
            var type = parent.attr('type');
            var arr = [],tagArr = [];
            var str = '',sel;
            var menuItem = '<menuitem label="{0}" value="{1}"/>'
            
            // title
            el.find('.browse-edit-title').val(parent.find('.browse-title-static').val());
            
            // folder
            switch (type) {
                case 'rek':
                case 'bookmark':
                    arr = reksidebar.treeMgr.getNodeFlatList('rekView');
                    $.each(arr,function(i,v){
                        if (type == 'rek' && v.name == 'Ungrouped Folder') v.name = 'Inbox';
                        str += menuItem.format(reksidebar.Rek.xmlEncode(v.name),v.id);
                        if (v.id == parent.attr('nodeid')) sel = i;
                    });
                    break;
                case 'tag':
                    sel = null;
                    break;
                case 'sent':
                    str += menuItem.format('Sent',reksidebar.Rek.user.data.sent_node_id);
                    sel = 0;
                    break;
            }
            el.find('.browse-edit-folderpopup').empty();
            reksidebar.Rek.appendDOMfromString(el.find('.browse-edit-folderpopup'),str);
            if (type == 'sent') el.find('.browse-edit-menulist').attr('disabled','true');
            if (sel !== null) el.find('menulist')[0].selectedIndex = sel;

            // tags
            el.find('.browse-tags-list').empty();
            el.find('.browse-tags-list').append(parent.find('.browse-listitem-row.tags .browse-tags-list').children().clone());
            el.find('.browse-edit-addtag').val('');
            $.each(reksidebar.Rek.user.data.tagList,function(i,v){
                tagArr.push({
                    value:v.name
                })
            });
            el.find('.browse-edit-addtag').attr('autocompletesearchparam',JSON.stringify(tagArr));

            // private
            el.find('.browse-edit-private-checkbox').attr('checked',parent.hasClass('public')?'false':'true');
        },
        showEdit: function(view,el) {
            var editEl = el.find('.browse-listitem-row.edit');
            $.each(el.siblings(),function(i,v) {
                $(v).find('.browse-listitem-row').removeClass('expanded');
                $(v).find('.browse-listitem-item').show();
            });
            el.find('.browse-listitem-item').hide();
            el.find('.twisty').removeClass('expanded');
            el.find('.browse-tags-detail').removeClass('expanded');
            el.find('.browse-listitem-row').removeClass('expanded');

            this.updateEdit(view,editEl);

            editEl.addClass('expanded');
            // suspend the pulse, but set a timer to close edit (need to resume pulse at some point)
            reksidebar.Rek.skipPulse();
            /*el.rekTimer = setTimeout(function(){
                reksidebar.browse.closeEdit(view,el,'cancel');
            },30000);*/
        },
        closeEdit: function(view,el,command) {
            var editEl = el.find('.browse-listitem-row.edit');
            var tags = [];
            var oldTitle,title,oldNodeId,nodeId;
            if (el.rekTimer) clearTimeout(el.rekTimer);
            if (command == 'save') {
                switch (view) {
                    case 'browse.inbox':
                    case 'browse.comments':
                    case 'browse.bmark':
                    case 'browse.sent':
                    case 'search.mine':
                        reksidebar.Rek.log('browse - update rek');
                        // titles
                        oldTitle = el.find('.browse-title-static').val();
                        title = editEl.find('.browse-edit-title').val();
                        // node IDs
                        oldNodeId = el.attr('nodeid');
                        nodeId = editEl.find('menulist')[0].selectedItem.value;
                        // add entered tags
                        this.addTag(editEl);
                        // tags listed
                        $.each(editEl.find('.tag-listitem:not(.hidden) .tag-name'),function(i,v){
                            tags.push($(v).val());
                        });
                        $.ajax({
                            type: 'POST',
                            async: true,
                            url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/updateRek.php',
                            data: {
                                id:reksidebar.Rek.user.id,
                                session:reksidebar.Rek.user.session,
                                rekArr: JSON.stringify([{
                                    id: el.attr('recid'),
                                    title: title,
                                    node: nodeId,
                                    tags: tags,
                                    priv: editEl.find('.browse-edit-private-checkbox:checked').length
                                }])
                            },
                            dataType: 'json',
                            success: function(json){
                                //reksidebar.Rek.log(json);
                                // update tag count and add the new tags to popup list
                                $.each(editEl.find('.tag-listitem'),function(i,v){
                                    var match = false;
                                    var name = $(v).find('.tag-name').val();
                                    $.each(reksidebar.Rek.user.data.tagList,function(j,w){
                                        if (name == w.name) {
                                            if ($(v).hasClass('orig')) {
                                                if ($(v).hasClass('hidden')) w.count -= 1;
                                            } else {
                                                if (!($(v).hasClass('hidden'))) w.count += 1;
                                            }
                                            match = true;
                                            return false;
                                        }
                                    });
                                    if (!match) {
                                        reksidebar.Rek.user.data.tagList.push({
                                            name:name,
                                            count:1,
                                            date:Math.round((new Date()).getTime()/1000)
                                        });
                                    }
                                });
                                // update folder count and fire folder updates
                                if (oldNodeId != nodeId) {
                                    reksidebar.browse.folders.decCount(oldNodeId,1);
                                }
                                reksidebar.browse.folders.incCount(nodeId,oldNodeId!=nodeId?1:0);
                                switch (el.attr('type')) {
                                    case 'rek':
                                        reksidebar.browse.reload(['browse.inbox','browse.comments']);
                                        break;
                                    case 'bookmark':
                                        reksidebar.browse.reload(['browse.bmark']);
                                        break;
                                    case 'tag':
                                        reksidebar.browse.reload(['browse.tags']);
                                        break;
                                    case 'sent':
                                        reksidebar.browse.reload(['browse.sent','browse.comments']);
                                        break;
                                }
                            },
                            error: function(req,status,error){
                                // check on system status
                                reksidebar.Rek.validateStatus(status);
                            }
                        });
                        break;
                    case 'browse.tags':
                        reksidebar.Rek.log('browse - update tag');
                        var old = el.attr('tag');
                        var name = editEl.find('.browse-edit-title').val().toLowerCase();
                        if (name.length) {
                            $.ajax({
                                type: 'POST',
                                async: true,
                                url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/updateTag.php',
                                data: {
                                    id:reksidebar.Rek.user.id,
                                    session:reksidebar.Rek.user.session,
                                    arr: JSON.stringify([{
                                        old:old,
                                        name:name
                                    }])
                                },
                                dataType: 'json',
                                success: function(json){
                                    //reksidebar.Rek.log(json);
                                    $.each(reksidebar.Rek.user.data.tagList,function(i,v){
                                        if (v.name == old) {
                                            v.name = name;
                                            return false;
                                        }
                                    });
                                    el.attr('tag',name);
                                    el.find('.browse-title-static').val(name);
                                    $('#app-browse .tag-name[value='+old+']').val(name);
                                },
                                error: function(req,status,error){
                                    // check on system status
                                    reksidebar.Rek.validateStatus(status);
                                }
                            });
                        }
                        
                        break;
                }
                
            }
            editEl.removeClass('expanded');
            $(el).find('.browse-listitem-item').show();
            reksidebar.Rek.resumePulse();
        },
        closeAllExpanded: function() {
            $('#browse-browse-content .browse-listitem-row.expanded').removeClass('expanded');
            $('#browse-browse-content .browse-listitem-item').show();
            reksidebar.Rek.resumePulse();
        },
        onItemPopup: function(e) {
            var str;
            var el = $(document.popupNode).parents('.listitem').eq(0);
            switch (el.attr('type')) {
                case 'rek':
                    str = this.templates.itemPopup.join('').format('browse.inbox','<menuseparator/><menuitem class="menuitem-non-iconic" label="Bookmark..." oncommand="reksidebar.browse.bmarkItem($(document.popupNode).parents(\'.listitem\').eq(0));"/><menuitem class="menuitem-non-iconic" label="Forward..." oncommand="reksidebar.browse.rekommendItem($(document.popupNode).parents(\'.listitem\').eq(0));"/>');
                    break;
                case 'sent':
                    str = this.templates.sentPopup.join('').format('<menuseparator/><menuitem class="menuitem-non-iconic" label="Bookmark..." oncommand="reksidebar.browse.bmarkItem($(document.popupNode).parents(\'.listitem\').eq(0));"/><menuitem class="menuitem-non-iconic" label="Forward..." oncommand="reksidebar.browse.rekommendItem($(document.popupNode).parents(\'.listitem\').eq(0));"/>');
                    break;
                case 'bookmark':
                    str = this.templates.itemPopup.join('').format('browse.bmark','<menuseparator/><menuitem class="menuitem-non-iconic" label="Forward..." oncommand="reksidebar.browse.rekommendItem($(document.popupNode).parents(\'.listitem\').eq(0));"/>');
                    break;
                case 'comment':
                    str = '<menuitem class="menuitem-non-iconic" label="Bookmark..." oncommand="reksidebar.browse.bmarkItem($(document.popupNode).parents(\'.listitem\').eq(0));"/><menuitem class="menuitem-non-iconic" label="Forward..." oncommand="reksidebar.browse.rekommendItem($(document.popupNode).parents(\'.listitem\').eq(0));"/>';
                    break;
                case 'tag':
                default:
                    str = this.templates.itemPopup.join('').format('','');
                    break;
            }
            $('#popup-browse1').empty();
            reksidebar.Rek.appendDOMfromString($('#popup-browse1'),str);
        },
        onDisplayOption: function() {
            var $el,pref,view,arr=[];
            if (!$(this).hasClass('selected')) {
                 $el = $(this).parent('.display-pref');

                pref = $el.attr('pref');
                //reksidebar.Rek.log(pref);
                //reksidebar.Rek.log($(this).attr('prefvalue'));
                reksidebar.Rek.user.data.preferences[pref] = $(this).attr('prefvalue');
                view = $el.attr('view');
                //reksidebar.Rek.log(view);
                if (view) {
                    if (view == 'browse.tags') reksidebar.browse.updateTagList();
                    else if (view == 'browse.folders') reksidebar.treeMgr.rekView.sort(null,true);
                    else arr.push(view);
                }
               
                $el.find('.display-option').removeClass('selected');
                $(this).addClass('selected');

                // reload the view
                reksidebar.browse.reload(arr);
                reksidebar.Rek.db.putPrefs();
            }
        },
        bulkSetPrivate: function(view,locked) {
            var o = this.describeView(view),
                $sel,arr = [];
            $sel = $('.'+o.listCls+' checkbox.browse-checkbox:checked').parents('.'+o.listCls);
            if ($sel.length) {
                this.closeAllExpanded();
                $.each($sel,function(i,v) {
                    arr.push($(v).attr('rekid'));
                });
                // update the database
                reksidebar.Rek.db.setRecordSet('rek','private',arr,locked?1:0,function(){
                    reksidebar.browse.reload([view]);
                });
            }
        },
        toggleDisplay: function(view) {
            var o = this.describeView(view);
            var el = $('#'+o.parent).find('.browse-display-options');
            var hidden = el.attr('hidden') == 'true';
            $(el).attr('hidden',(!hidden).toString());
        },
        describeView: function(view) {
            var obj = {};
            //reksidebar.Rek.log(view);
            switch (view) {
                case 'browse.inbox':
                    obj.view = view;
                    obj.type = 'rek';
                    obj.data = reksidebar.Rek.user.browse.inbox;
                    obj.table = 'rek_in_tree_node',
                    obj.root = reksidebar.Rek.getProperty('rek.browse.defaultRekRoot');
                    obj.parent = 'browse-browse-inbox';
                    obj.listCls = 'browse-inbox-listitem';
                    obj.pagerEl = 'browse-pager';
                    obj.pagerStart = this.inboxStart;
                    obj.pagerTotal = this.inboxTotal;
                    obj.pageSize = reksidebar.Rek.user.data.preferences['inbox_twoline'] == '1'?this.inboxPageSize:this.inboxPageSize*2;
                    obj.crc = this.inboxCrc;
                    obj.sort = {
                        sort: reksidebar.Rek.user.data.preferences['inbox_sort']
                    };
                    break;
                case 'browse.comments':
                    obj.view = view;
                    obj.type = 'rek';
                    obj.data = reksidebar.Rek.user.browse.comments;
                    obj.table = 'rek_in_tree_node',
                    obj.root = reksidebar.Rek.getProperty('rek.browse.defaultRekRoot');
                    obj.parent = 'browse-browse-comments';
                    obj.listCls = 'browse-comments-listitem';
                    obj.pagerEl = 'browse-pager';
                    obj.pagerStart = this.commentsStart;
                    obj.pagerTotal = this.commentsTotal;
                    obj.pageSize = reksidebar.Rek.user.data.preferences['comments_twoline'] == '1'?this.commentsPageSize:this.commentsPageSize*2;
                    obj.crc = this.commentsCrc;
                    break;
                case 'browse.bmark':
                    obj.view = view;
                    obj.type = 'bmark';
                    obj.data = reksidebar.Rek.user.browse.bmark;
                    obj.table = 'rek_in_tree_node',
                    obj.root = reksidebar.Rek.getProperty('rek.browse.defaultBmarkRoot');
                    obj.parent = 'browse-browse-bookmarks';
                    obj.listCls = 'browse-bmark-listitem';
                    obj.pagerEl = 'browse-pager';
                    obj.pagerStart = this.bmarkStart;
                    obj.pagerTotal = this.bmarkTotal;
                    obj.pageSize = reksidebar.Rek.user.data.preferences['bmark_twoline'] == '1'?this.bmarkPageSize:this.bmarkPageSize*2;
                    obj.crc = this.bmarkCrc;
                    obj.sort = {
                        sort: reksidebar.Rek.user.data.preferences['bmark_sort'],
                        priv: reksidebar.Rek.user.data.preferences['bmark_private']
                    };
                    break;
                case 'browse.tags':
                    obj.view = view;
                    obj.type = 'tags';
                    obj.data = reksidebar.Rek.user.data.tagList;
                    obj.table = '',
                    obj.root = '';
                    obj.parent = 'browse-browse-tags';
                    obj.listCls = 'browse-tags-listitem';
                    obj.pagerEl = 'browse-pager';
                    obj.pagerStart = 0;
                    obj.pagerTotal = reksidebar.Rek.user.data.tagList.length;
                    obj.pageSize = 99999999;
                    obj.crc = 0;
                    break;
                case 'browse.sent':
                    obj.view = view;
                    obj.type = 'rek';
                    obj.data = reksidebar.Rek.user.browse.sent;
                    obj.table = 'rek_in_tree_node',
                    obj.root = '';
                    obj.parent = 'browse-browse-sent';
                    obj.listCls = 'browse-sent-listitem';
                    obj.pagerEl = 'browse-pager';
                    obj.pagerStart = this.sentStart;
                    obj.pagerTotal = this.sentTotal;
                    obj.pageSize = reksidebar.Rek.user.data.preferences['sent_twoline'] == '1'?this.sentPageSize:this.sentPageSize*2;
                    obj.crc = this.sentCrc;
                    obj.sort = {
                        sort: reksidebar.Rek.user.data.preferences['sent_sort']
                    };
                    break;
                case 'browse.top100':
                    obj.view = view;
                    obj.type = '';
                    obj.data = reksidebar.Rek.user.browse.top100;
                    obj.table = 'url',
                    obj.root = '';
                    obj.parent = 'browse-browse-top100';
                    obj.listCls = 'browse-top100-listitem';
                    obj.pagerEl = 'browse-pager';
                    obj.pagerStart = this.top100Start;
                    obj.pagerTotal = this.top100Total;
                    obj.pageSize = this.top100PageSize;
                    obj.crc = this.top100Crc;
                    obj.sort = {
                        sort: $('#browse-top100-menulist')[0].value
                    };
                    break;
                case 'search.mine':
                    obj.view = view;
                    obj.type = '';
                    obj.data = reksidebar.search.result.data;
                    obj.table = 'rek_in_tree_node',
                    obj.root = '';
                    obj.parent = 'search-mine-content';
                    obj.listCls = 'search-listitem';
                    obj.pagerEl = 'search-pager';
                    obj.pagerStart = reksidebar.search.start;
                    obj.pagerTotal = reksidebar.search.total;
                    obj.pageSize = reksidebar.search.pageSize;
                    obj.crc = reksidebar.search.crc;
                    break;
                case 'search.all':
                    obj.view = view;
                    obj.type = '';
                    obj.data = reksidebar.search.result.data;
                    obj.table = 'rek',
                    obj.root = '';
                    obj.parent = 'search-all-content';
                    obj.listCls = 'search-listitem';
                    obj.pagerEl = 'search-pager';
                    obj.pagerStart = reksidebar.search.start;
                    obj.pagerTotal = reksidebar.search.total;
                    obj.pageSize = reksidebar.search.pageSize;
                    obj.crc = reksidebar.search.crc;
                    break;
            }
            return obj;
        },
        buildFetchArr: function(viewArr) {
            var exists,o,requestArr = [];
            $.each(viewArr,function(i,view){
                // don't allow duplicates
                exists = false;
                for (var j=0;j<requestArr.length;j++) {
                    if (requestArr[j].id == view) {
                        exists = true;
                        break;
                    }
                }
                if (!exists) {
                    o = reksidebar.browse.describeView(view);
                    requestArr.push({
                        id:view,
                        crc: o.crc,
                        limit: o.pageSize,
                        start: o.pagerStart,
                        sort: o.sort
                    });
                }
            });

            return requestArr;
        },
        reload: function(viewArr) {
            var exists,o,arr = [];

            // strip out search requests
            $.each(viewArr, function(i,view) {
                if (view != 'search.mine' && view != 'search.all') arr.push(view);
                else reksidebar.search.reload();
            });

            reksidebar.Rek.db.fetch(false,this.buildFetchArr(arr));

            /*if (viewArr[0] == 'search.mine') {
                reksidebar.search.reload();
            } else {
                $.each(viewArr,function(i,view){
                    // don't allow duplicates
                    exists = false;
                    for (var j=0;j<requestArr.length;j++) {
                        if (requestArr[j].id == view) {
                            exists = true;
                            break;
                        }
                    }
                    if (!exists) {
                        o = reksidebar.browse.describeView(view);
                        requestArr.push({
                            id:view,
                            crc: o.crc,
                            limit: o.pageSize,
                            start: o.pagerStart,
                            sort: o.sort
                        });
                    }
                });
                
                //reksidebar.Rek.log('view:'+view);
                ///reksidebar.Rek.log('crc:'+o.crc);
                //reksidebar.Rek.log('pagesize:'+o.pageSize);
                //reksidebar.Rek.log('pagerStart:'+o.pagerStart);
                // show loader
                //$('#'+o.parent+' stack > vbox:nth-child(2)').hide();
                //$('#'+o.parent+' stack > vbox:nth-child(1)').show();
                // load new data
                reksidebar.Rek.db.fetch(false,requestArr);
            }*/
        }
    }
});
reksidebar.ns(function() {

    reksidebar.browse.folders = {
        CONST: {
        },
        templates: {
            folder: [
            '<vbox class="browse-folders-folder listitem{5}{4}" recid="{1}" lvl="{2}" date="{10}">',
            '<hbox class="browse-folders-wrapper">',
            '<hbox class="twisty"/>',
            '<hbox class="browse-folders-head" flex="1"{7}{9} ondragover="reksidebar.browse.folders.dragOver(event);" ondragexit="reksidebar.browse.folders.dragExit(event);" ondragend="reksidebar.browse.folders.dragEnd(event);" ondrop="reksidebar.browse.folders.onDrop(event);">',
            '<hbox class="folder-image"/>',

            '<stack class="" flex="1">',
            '<description class="folder-title-static title{8}" value="{0}" flex="1" crop="end"/>',
            '<hbox class="folder-title-editable collapse" hidden="true" onclick="event.stopPropagation();">',
            '<html:input class="folder-title-editable-input moz-box flex" flex="1" type="text" value="{0}" onkeydown="if (event.keyCode == 13) reksidebar.browse.folders.stopEdit(this,false);else if (event.keyCode == 27) reksidebar.browse.folders.cancelAdd($(this).parent(\'.folder-title-editable\'));" onblur="reksidebar.browse.folders.stopEdit(this,false);"/>',
            '<description class="folder-editable-escape bold" value="X" onclick="reksidebar.browse.folders.cancelAdd($(this).parent(\'.folder-title-editable\'));"/>',
            '</hbox>',
            '</stack>',
            
            '</hbox>',
            '</hbox>',
            '{6}',
            '</vbox>'
            ],
            item: [
            '<hbox class="browse-folders-item listitem {1}" recid="{2}" nodeid="{4}" url="{3}" tiny="{6}" date="{8}" context="context-browse-folders-select" tagJSON="{5}">',
            '<hbox class="browse-folders-item-wrapper" flex="1" ondragstart="reksidebar.browse.folders.dragStart(event);" ondragend="reksidebar.browse.folders.dragEnd(event);">',
            '<description class="browse-pagetitle hidden" value="{7}"/>',
            '<description class="title" value="{0}" flex="1" crop="end"/>',
            '</hbox>',
            '</hbox>'
            ],
            contextRek:[
            '<menuitem class="menuitem-non-iconic" label="Open" oncommand="reksidebar.browse.folders.contextOpen(\'current\');"/>',
            '<menuitem class="menuitem-non-iconic" label="Open in a New Window" oncommand="reksidebar.browse.folders.contextOpen(\'window\');"/>',
            '<menuitem class="menuitem-non-iconic" label="Open in a New Tab" oncommand="reksidebar.browse.folders.contextOpen(\'tab\');"/>',
            '<menuseparator />',
            '<menuitem class="menuitem-non-iconic" label="Delete {0}" oncommand="reksidebar.browse.folders.contextDelete();"/>'
            ],
            contextFolder:[
            '<menuitem class="menuitem-non-iconic" label="Rename" oncommand="reksidebar.browse.folders.contextRename();"/>',
            '<menuitem class="menuitem-non-iconic" label="Delete" oncommand="reksidebar.browse.folders.contextDelete();"/>'
            ],
            contextMultiple:[
            '<menuitem class="" label="Delete All" oncommand="reksidebar.browse.folders.contextDelete();"/>'
            ]
        },

        // member variables
        folderMap: null,
        rootId: null,
        sentId: null,
        updateTimer: null,
        contextSel: [],

        init: function() {
            reksidebar.Rek.log('browse.folders init');

            this.rootId = reksidebar.Rek.user.data.rek_top_node_id;
            this.sentId = reksidebar.Rek.user.data.sent_node_id;

            // initial rendering - need to build the folder map
            this.update();
        },
        update: function() {
            reksidebar.Rek.log('browse.folders update');
            var sel = [];
            // preserve selected records, if any
            $.each($('#browse-folders-list .selected'),function(i,v){
                var type = $(v).hasClass('browse-folders-folder')?'browse-folders-folder':'browse-folders-item';
                sel.push({
                    type: type,
                    id: $(v).attr('recid')
                })
            });
            // iterate through the tree nodes
            var str;
            var idx = -1;
            this.folderMap = [];
            var iterate = function(arr,parent,level) {
                var obj,itemArr,domArr=[];
                for (var i=0;i<arr.length;i++) {
                    itemArr = [];
                    idx++;
                    obj = {};
                    obj.node = arr[i];
                    if (obj.node.count + obj.node.children.length == 0) obj.node.browseOpen = false;
                    obj.node.browseOpen = !!obj.node.browseOpen;
                    obj.level = level;
                    obj.parent = parent;
                    obj.sibling = (arr.length > 1 && i != arr.length-1);
                    reksidebar.browse.folders.folderMap.push(obj);
                    // get current rek/bookmarks from DOM
                    $.each($('.browse-folders-folder[recid='+obj.node.id+']>.browse-folder-content>.browse-folders-item'),function(i,v){
                        itemArr.push(reksidebar.Rek.serializeDOM(v));
                    });
                    if (idx == 0) {
                        domArr.push(reksidebar.browse.folders.templates.folder.join('').format(
                            'Ungrouped',
                            obj.node.id,
                            obj.level,
                            obj.node.count,
                            obj.node.count == 0?' empty':'',
                            obj.node.browseOpen?' expanded':'',
                            '<vbox class="browse-folder-content">{0}</vbox>',
                            '',
                            '',
                            '',
                            obj.node.date
                            ));
                    } else {
                        domArr.push(reksidebar.browse.folders.templates.folder.join('').format(
                            reksidebar.Rek.xmlEncode(obj.node.name),
                            obj.node.id,
                            obj.level,
                            obj.node.count,
                            obj.node.count + obj.node.children.length == 0?' empty':'',
                            obj.node.browseOpen?' expanded':'',
                            '<vbox class="browse-folder-content">{0}</vbox>',
                            ' ondragstart="reksidebar.browse.folders.dragStart(event);"',
                            '',
                            ' context="context-browse-folders-select"',
                            obj.node.date
                            ));
                    }
                    if (obj.node.children.length > 0) itemArr = iterate(obj.node.children,idx,level+1).concat(itemArr);
                    // sort itemArr
                    //reksidebar.browse.folders.sort(itemArr,0);
                    domArr[domArr.length-1] = domArr[domArr.length-1].format(itemArr.join(''));
                }
                return domArr;
            }
            str = iterate(reksidebar.Rek.user.data.rekTree,-1,0).join('');
            $('#browse-folders-list').empty();
            if (str) reksidebar.Rek.appendDOMfromString($('#browse-folders-list'),str);
            //reksidebar.Rek.log(str);

            // restore selection
            $.each(sel,function(i,v){
                var box,el;
                el = $('#browse-folders-list .'+v.type+'[recid='+v.id+']');
                el.addClass('selected');
            });

            // bind the events to folders
            $('.browse-folders-folder .browse-folders-head').single_double_click(function(e){
                reksidebar.browse.folders.click(e);
            },function(e){
                reksidebar.browse.folders.fldrDblclick(e);
            },210);
            $('.browse-folders-folder .twisty').bind('click',function(e){
                e.stopPropagation();
                reksidebar.browse.folders.click(e);
            });

            // make the request for open folders
            this.fetchAll();
        },
        sort: function(arr,start) {
            // arr is an array of DOM strings to be inserted in the DOM
            // sort is done on first instance of value attribute
            reksidebar.Rek.log('sort start at index:'+start);
            //$.each(arr,function(i,v){reksidebar.Rek.log(v)});
            var i,j,o,done;
            for (i=start+1;i<arr.length;i++) {
                o = arr[i];
                j = i - 1;
                done = false;
                do {
                    switch (reksidebar.Rek.user.data.preferences['tree_sort']) {
                        case 'date':
                            if (reksidebar.Rek.xmlDecode(arr[j]).match(/date=\"([^\"]*)\"/i)[0] < reksidebar.Rek.xmlDecode(o).match(/date=\"([^\"]*)\"/i)[0]) {
                                arr[j+1] = arr[j];
                                j = j - 1;
                                if (j < start) done = true;
                            } else
                                done = true;
                            break;
                        case 'name':
                            //reksidebar.Rek.log(arr[j].match(/class=".*title" value=\"([^\"]*)\"/i));
                            //reksidebar.Rek.log(o);
                            //reksidebar.Rek.log(o.match(/class=".*title" value=\"([^\"]*)\"/i));
                            if (reksidebar.Rek.xmlDecode(arr[j]).match(/class=".*title" value=\"([^\"]*)\"/i)[1].toLowerCase() > reksidebar.Rek.xmlDecode(o).match(/class=".*title" value=\"([^\"]*)\"/i)[1].toLowerCase()) {
                                arr[j+1] = arr[j];
                                j = j - 1;
                                if (j < start) done = true;
                            } else
                                done = true;
                            break;
                        case 'named':
                            if (reksidebar.Rek.xmlDecode(arr[j]).match(/class=".*title" value=\"([^\"]*)\"/i)[1].toLowerCase() < reksidebar.Rek.xmlDecode(o).match(/class=".*title" value=\"([^\"]*)\"/i)[1].toLowerCase()) {
                                arr[j+1] = arr[j];
                                j = j - 1;
                                if (j < start) done = true;
                            } else
                                done = true;
                            break;
                        default:
                    }
                } while (!done);
                arr[j+1] = o;
            }
            reksidebar.Rek.log('sort end');
            //$.each(arr,function(i,v){reksidebar.Rek.log(v)});
        },
        click: function(e) {
            var el,sel,count;
            el = $(e.currentTarget).parents('.listitem').eq(0);
            sel = $('#browse-folders-list .selected');
            count = sel.length;
            if (e.which != 3) {
                if (!e.shiftKey) {
                    if (document.commandDispatcher.focusedElement) document.commandDispatcher.focusedElement.blur();
                    if (el.hasClass('browse-folders-folder')) reksidebar.browse.folders.toggle(el);
                    sel.removeClass('selected');
                    count = 0;
                }
                // don't allow the ungrouped folder to be multi-selected
                if (count == 0 || el.attr('recid') != reksidebar.Rek.user.data.rek_top_node_id) el.addClass('selected');

                sel = $('#browse-folders-list .selected');
                if (sel.length == 1 && sel.hasClass('browse-folders-item')) reksidebar.Rek.openURLKey(sel.attr('tiny'));
            }
        },
        fldrDblclick: function(e) {
            var el = $(e.currentTarget).parents('.browse-folders-folder').eq(0);
            $('#browse-folders-list .selected').removeClass('selected');
            el.addClass('selected');
            this.startEdit(el);
        },
        onSelectContext: function(e) {
            reksidebar.Rek.log('update context');
            var newSel = true,foldercount = 0,rekcount = 0,bmarkcount = 0,str = '';
            var el = $(document.popupNode).parents('.listitem').eq(0);
            this.contextSel = $('#browse-folders-list .selected');
            $.each(this.contextSel,function(i,v){
                if ($(v).hasClass('browse-folders-folder')) foldercount++;
                if ($(v).hasClass('rek')) rekcount++;
                if ($(v).hasClass('bookmark')) bmarkcount++;
                if ($(v)[0] == el[0]) newSel = false;
            });
            if (newSel) this.contextSel = el;
            if (this.contextSel.length == 1) {
                if (this.contextSel.hasClass('browse-folders-folder')) {
                    str = reksidebar.browse.folders.templates.contextFolder.join('');
                } else if (this.contextSel.hasClass('rek')) {
                    str = reksidebar.browse.folders.templates.contextRek.join('').format('Rek');
                } else {
                    str = reksidebar.browse.folders.templates.contextRek.join('').format('Bookmark');
                }
            } else {
                str = reksidebar.browse.folders.templates.contextMultiple.join('');
            }
            $('#context-browse-folders-select').empty();
            reksidebar.Rek.appendDOMfromString($('#context-browse-folders-select'),str);
        },
        contextOpen: function(where) {
            reksidebar.Rek.openURLKey($(document.popupNode).parents('.listitem').eq(0).attr('tiny'),where);
        },
        contextRename: function(){
            this.startEdit($(document.popupNode).parents('.listitem').eq(0));
        },
        contextDelete: function() {
            reksidebar.Rek.log('context delete');
            this.remove(this.contextSel,false);
        },
        remove: function(sel,keepItems) {
            reksidebar.Rek.log('remove');
            var arr,folderArr=[],itemArr=[],match,id,nodeid;
            $.each(sel,function(i,v){
                if ($(v).hasClass('browse-folders-folder')) {
                    folderArr.push(v);
                    if (!keepItems) {
                        $.each($(v).children('.browse-folder-content').find('.browse-folders-item'),function(j,item){
                            itemArr.push(item);
                        });
                    }
                } else if ($(v).hasClass('browse-folders-item')) {
                    itemArr.push(v);
                }
            });
            // take care of items first
            if (itemArr.length) {
                var count = {};
                arr = [];
                // remove duplicates
                $.each(itemArr,function(i,v){
                    id = $(v).attr('recid');
                    nodeid = $(v).attr('nodeid');
                    match = false;
                    $.each(arr,function(k,u){
                        if (id == u) {
                            match = true;
                            return false;
                        }
                    })
                    if (!match) {
                        arr.push(id);
                        if (typeof(count[nodeid]) == 'undefined') {
                            count[nodeid] = 1;
                        } else {
                            count[nodeid] += 1;
                        }
                    }
                });
                // make the db call
                reksidebar.Rek.db.setActiveStatus('rek_in_tree_node',arr,'false',function(){
                    // callback function - trigger update of ui
                    // update tag count
                    $.each(itemArr,function(i,v){
                        $.each(JSON.parse(reksidebar.Rek.xmlDecode($(v).attr('tagJSON'))),function(j,name){
                            $.each(reksidebar.Rek.user.data.tagList,function(k,rec){
                                if (rec.name == name) {
                                    rec.count--;
                                    if (rec.count < 0) rec.count = 0;
                                    return false;
                                }
                            });
                        });
                    });
                    //$.each(itemArr,function(i,v){$(v).remove();});
                    reksidebar.browse.updateTagList();
                    // browse.folders
                    $.each(count,function(i,v){
                        reksidebar.browse.folders.decCount(i,count[i]);
                    });
                });
            }

            // take care of folders through treeMgr
            if (folderArr.length) {
                arr = [];
                $.each(folderArr,function(i,v){
                    arr.push($(v).attr('recid'));
                });
                $.each(folderArr,function(i,v){$(v).remove();});
                reksidebar.treeMgr.rekView.removeRows(arr);
            }
            reksidebar.browse.reload(['browse.inbox','browse.bmark']);
        },
        contextEdit: function() {
            reksidebar.Rek.log('context edit');
        },
        startEdit: function(el) {
            reksidebar.Rek.log('start edit');
            if (this.getIdxByNodeId($(el).attr('recid')) != 0) {
                reksidebar.Rek.skipPulse();
                var editbox = el.find('.folder-title-editable').eq(0);
                var inputbox = el.find('.folder-title-editable-input');
                el.find('.folder-title-static').eq(0).hide();
                editbox.attr('hidden','false');
                inputbox[0].setSelectionRange(0,inputbox.val().length);
                inputbox[0].focus();
            }
        },
        stopEdit: function(el,ignore) {
            reksidebar.Rek.log('stop edit');
            var id;
            var text = $(el).val();
            var editbox = $(el).parent('.folder-title-editable').eq(0);
            var parent = $(el).parents('.browse-folders-folder').eq(0);
            var staticbox = $(parent).find('.folder-title-static').eq(0);
            
            if (!text.length || $(el).val() == $(el).prev().val()) ignore = true;
            if (!ignore) {
                id = parseInt(parent.attr('recid'));
                reksidebar.treeMgr.rekView.setCellTextById(id,text);
                $(el).val(text);
                $(staticbox).val(text);
            } else {
                $(el).val($(el).prev().val());
            }
            $(editbox).attr('hidden','true').blur();
            $(staticbox).css('display','-moz-box');
            reksidebar.Rek.resumePulse();
        },
        fetchItemsArr: function(arr,andChildren) {
            var idx,node,startLvl,reqArr=[];
            for (var i=0;i<arr.length;i++) {
                idx = this.getIdxByNodeId(arr[i]);
                startLvl = this.folderMap[idx].level;
                if (this.folderMap[idx].node.browseOpen) reqArr.push(this.folderMap[idx].node.id);
                if (andChildren) {
                    for (i = idx+1;i<=this.folderMap.length-1;i++) {
                        node = this.folderMap[i].node;
                        if (this.folderMap[i].level > startLvl && node.browseOpen) reqArr.push(node.id);
                        if (this.folderMap[i].level == startLvl) break;
                    }
                }
            }
            this._doFetch(reqArr);
        },
        fetchItemsIdx: function(startIdx,andChildren) {
            //reksidebar.Rek.log('startidx: '+startIdx);
            var i,node,startLvl,reqArr = [];
            startLvl = this.folderMap[startIdx].level;
            if (this.folderMap[startIdx].node.browseOpen) reqArr.push(this.folderMap[startIdx].node.id);
            if (andChildren) {
                //reksidebar.Rek.log(this.folderMap);
                for (i = startIdx+1;i<=this.folderMap.length-1;i++) {
                    node = this.folderMap[i].node;
                    if (this.folderMap[i].level > startLvl && node.browseOpen) reqArr.push(node.id);
                    if (this.folderMap[i].level == startLvl) break;
                }
            }
            //reksidebar.Rek.log(reqArr);
            this._doFetch(reqArr);
        },
        fetchAll: function() {
            var i,node,reqArr = [];
            for (i=0;i<=this.folderMap.length-1;i++) {
                node = this.folderMap[i].node;
                if (node.browseOpen) reqArr.push(node.id);
            }
            this._doFetch(reqArr);
        },
        _doFetch: function(reqArr) {
            var el,focusId,selStart,selEnd;
            if (reqArr.length) {
                // determine if there is a focused edit element
                $.ajax({
                    type: 'POST',
                    async: true,
                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/getRekNodeDetail.php',
                    data: {
                        id: reksidebar.Rek.user.id,
                        session: reksidebar.Rek.user.session,
                        arr: JSON.stringify(reqArr)
                    },
                    dataType: 'json',
                    success: function(json){
                        reksidebar.Rek.log(json);
                        try {
                            selStart = document.commandDispatcher.focusedElement.selectionStart;
                            selEnd = document.commandDispatcher.focusedElement.selectionEnd;
                            focusId =$(document.commandDispatcher.focusedElement).parents('.browse-folders-folder').eq(0).attr('recid');
                        } catch(err) {
                            focusId = null;
                        }
                        
                        $.each(json,function(i,v){
                            var domArr = [],wrapper;

                            $.each(v.data,function(j,item){
                                domArr.push(reksidebar.browse.folders.templates.item.join('').format(
                                    item.alt_title?reksidebar.Rek.xmlEncode(item.alt_title):reksidebar.Rek.xmlEncode(item.title),
                                    item.type,
                                    item.recid,
                                    reksidebar.Rek.xmlEncode(item.url),
                                    item.nodeid,
                                    reksidebar.Rek.xmlEncode(JSON.stringify(item.tags)),
                                    item.tiny,
                                    reksidebar.Rek.xmlEncode(item.title),
                                    item.date
                                    ));
                            });
                            //reksidebar.Rek.log(domArr);
                            wrapper = $('.browse-folders-folder[recid='+v.id+']>.browse-folder-content');
                            //reksidebar.Rek.log(wrapper);
                            $.each(wrapper.children('.browse-folders-folder'),function(j,item){
                                domArr.push(reksidebar.Rek.serializeDOM(item));
                            });
                            reksidebar.browse.folders.sort(domArr,0);
                            wrapper.empty();
                            reksidebar.Rek.appendDOMfromString(wrapper,domArr.join(''));
                            // ensure a single selection is visible
                            /*var el = $('#browse-folders-list .selected');
                            if (el.length == 1) {
                                var box = $('#browse-folders-list')[0];
                                box.scrollTop = el[0].boxObject.screenY - box.boxObject.screenY;
                            }*/
                            // bind item click
                            wrapper.find('.browse-folders-item-wrapper').bind('click',function(e){
                                reksidebar.browse.folders.click(e)
                            });
                            // bind the events to folders
                            wrapper.find('.browse-folders-folder .browse-folders-head').single_double_click(function(e){
                                reksidebar.browse.folders.click(e);
                            },function(e){
                                reksidebar.browse.folders.fldrDblclick(e);
                            },210);
                            wrapper.find('.browse-folders-folder .twisty').bind('click',function(e){
                                e.stopPropagation();
                                reksidebar.browse.folders.click(e);
                            });
                            // reinstate focused element and selection range, if exists
                            if (focusId) {
                                el = $('.browse-folders-folder[recid='+focusId+']>.browse-folders-wrapper .folder-title-editable');
                                el[0].setSelectionRange(selStart,selEnd);
                                el.focus();
                            }
                        });
                    },
                    error: function(req,status,error){
                        reksidebar.Rek.log('module.browse.folders fetch failed');
                        reksidebar.Rek.validateStatus(status);
                    }
                });
            }
        },
        openById: function(id) {
            var o = this.folderMap[this.getIdxByNodeId(id)];
            var el = $('.browse-folders-folder[recid='+id+']')[0];
            if (!$(el).hasClass('expanded')) this.toggle(el);
            if (o.parent != -1) this.openById(this.folderMap[o.parent].node.id);
        },
        toggle: function(el) {
            reksidebar.Rek.log('toggle');
            var idx = this.getIdxByNodeId($(el).attr('recid'));
            if (!($(el).hasClass('empty'))) {
                if ($(el).hasClass('expanded')) {
                    $(el).find('.browse-folders-item').removeClass('selected');
                    $(el).removeClass('expanded');
                    this.folderMap[idx].node.browseOpen = false;
                } else {
                    $(el).find('.browse-folders-item').remove();
                    $(el).addClass('expanded');
                    this.folderMap[idx].node.browseOpen = true;
                    this.fetchItemsIdx(idx,true);
                }
            }
        },
        expandAll: function() {
            for (var i=0;i<this.folderMap.length;i++) {
                this.folderMap[i].node.browseOpen = true;
            }
            this.update();
        },
        collapseAll: function() {
            for (var i=0;i<this.folderMap.length;i++) {
                this.folderMap[i].node.browseOpen = false;
            }
            this.update();
        },
        toggleDisplay: function() {
            var el = $('#browse-browse-folders .browse-display-options');
            var hidden = el.attr('hidden') == 'true';
            $(el).attr('hidden',(!hidden).toString());
        },
        dragStart: function(event) {
            reksidebar.Rek.log('dragStart');
            // stop editing, if applicable
            var dt = event.dataTransfer;
            var el = event.currentTarget;
            var parent = $(el).parents('.listitem').eq(0);
            // being edited? if so, stop it
            var editEl = $(el).find('.folder-title-editable:visible').eq(0);
            if (editEl.length) this.stopEdit(editEl,false);
            // determine selection
            // if currentTaget is selected, move all selected
            // otherwise just use curren target, regardless of selection status
            if (parent.hasClass('selected')) {
                $.each($('#browse-folders-list .selected'),function(i,v){
                    dt.mozSetDataAt('application/x-browse-folders',JSON.stringify({
                        type: $(v).hasClass('browse-folders-folder')?'folder':'rek',
                        id: $(v).attr('recid')
                    }),i);
                });
            } else {
                dt.mozSetDataAt('application/x-browse-folders',JSON.stringify({
                    type: parent.hasClass('browse-folders-folder')?'folder':'rek',
                    id: parent.attr('recid')
                }),0);
            }
            event.dataTransfer.setDragImage(el,event.screenX - el.boxObject.screenX,event.screenY - el.boxObject.screenY);
        },
        dragOver: function(event) {
            var canDrop = true;
            var dt = event.dataTransfer;
            var el = $(event.currentTarget).parents('.browse-folders-folder').eq(0);
            var node = this.getNode(el.attr('recid'));
            
            for (var i=0;i<dt.mozItemCount;i++) {
                var rec = JSON.parse(dt.mozGetDataAt('application/x-browse-folders',i));
                // can't drag a folder onto ungrouped
                if (rec.type == 'folder' && this.getIdxByNodeId(node.id) == 0) {
                    canDrop = false;
                    break;
                }
                // can't drag a folder onto one of its children folders
                if (rec.type == 'folder') {
                    if (this.isChild(node.id,this.getNode(rec.id))) {
                        canDrop = false;
                        break;
                    }
                }
            }

            if (canDrop) {
                if (!el.hasClass('dragover')) {
                    el.addClass('dragover');
                    // set a timer to open folder if it is closed
                    if (!node.browseOpen) {
                        el[0].rektimer = setTimeout(function(){
                            // TODO: folder opening animation
                            reksidebar.browse.folders.toggle(el);
                        },1000);
                    }
                }
                event.preventDefault();
            }
        },
        dragExit: function(event) {
            var el = $(event.currentTarget).parents('.browse-folders-folder').eq(0);
            if (el[0].rektimer) clearTimeout(el[0].rektimer);
            el.removeClass('dragover');
        },
        onDrop: function(event) {
            reksidebar.Rek.log('onDrop');
            var id,o,arr,count={},itemArr=[],folderArr=[];
            var dt = event.dataTransfer;
            var el = $(event.currentTarget).parents('.browse-folders-folder').eq(0);
            var node = this.getNode(el.attr('recid'));
            count[node.id] = 0;
            for (var i = 0; i < dt.mozItemCount; i++) {
                o = JSON.parse(dt.mozGetDataAt('application/x-browse-folders',i));
                switch (o.type) {
                    case 'rek':
                        itemArr.push(o.id);
                        count[node.id]+=1;
                        // find the containing folder id
                        id = $('.browse-folders-item[recid='+o.id+']').attr('nodeid');
                        if (typeof(count[id]) == 'undefined') count[id] = 0;
                        count[id]-=1;
                        break;
                    case 'folder':
                        if (node.id != o.id) folderArr.push(o.id);
                        break;
                }
            }
            // handle the items
            reksidebar.Rek.db.setRecordSet('rek_in_tree_node','tree_node_id',itemArr,node.id,function(){
                // remove items from old DOM positions
                $.each(itemArr,function(i,v){$('.browse-folders-item[recid='+v+']').remove();});
                $.each(count,function(i,v){
                    reksidebar.browse.folders.incCount(i,count[i]);
                });
                $.each(folderArr,function(i,v){
                    reksidebar.treeMgr.rekView.moveNode(reksidebar.treeMgr.rekView.getNode(v),node,reksidebar.treeMgr.rekView.DROP_ON);
                })
                if (folderArr.length == 0) reksidebar.browse.folders.update();
                // browse
                reksidebar.browse.reload(['browse.inbox']);
                reksidebar.browse.reload(['browse.bmark']);
            });
            // handle the folders
            
        },
        dragEnd: function(event) {
            reksidebar.Rek.log('dragEnd');
        },
        setCount: function(nodeId,count) {
            reksidebar.Rek.log('browse.folders setCount');
            var idx = this.getIdxByNodeId(nodeId);
            if (idx != -1) {
                var folder = this.folderMap[idx];
                var el = $('.browse-folders-folder[recid='+folder.node.id+']');
                folder.node.count = count;
                if (folder.node.count + folder.node.children.length == 0) {
                    folder.node.browseOpen = false;
                    el.removeClass('expanded');
                    el.addClass('empty');
                }
                else {
                    el.removeClass('empty');
                }
                this.fetchItemsArr([nodeId],false);
            }
        },
        incCount: function(nodeId,count) {
            //reksidebar.Rek.log('Node:'+nodeId+'   count:'+count);
            var idx = this.getIdxByNodeId(nodeId);
            if (idx != -1) {
                var folder = this.folderMap[idx];
                var el = $('.browse-folders-folder[recid='+folder.node.id+']');
                folder.node.count = parseInt(folder.node.count) + count;
                if (folder.node.count + folder.node.children.length == 0) {
                    folder.node.browseOpen = false;
                    el.removeClass('expanded');
                    el.addClass('empty');
                }
                else {
                    el.removeClass('empty');
                }
                this.fetchItemsArr([nodeId],false);
            }
        },
        decCount: function(nodeId,count) {
            var idx = this.getIdxByNodeId(nodeId);
            if (idx != -1) {
                var folder = this.folderMap[idx];
                var el = $('.browse-folders-folder[recid='+folder.node.id+']');
                folder.node.count = parseInt(folder.node.count) - count;
                // remove twisty, close folder if now empty
                if (folder.node.count + folder.node.children.length == 0) {
                    folder.node.browseOpen = false;
                    el.removeClass('expanded');
                    el.addClass('empty');
                }
                else {
                    el.removeClass('empty');
                }
                this.fetchItemsArr([nodeId],false);
            }
        },
        incDecCount: function(incNodeId,decNodeId,count) {
            var incIdx = this.getIdxByNodeId(incNodeId);
            var decIdx = this.getIdxByNodeId(decNodeId);
            if (incIdx != -1 && decIdx != -1) {
                var incFolder = this.folderMap[incIdx];
                var decFolder = this.folderMap[decIdx];
                incFolder.node.count = parseInt(incFolder.node.count) + count;
                decFolder.node.count = parseInt(decFolder.node.count) - count;
                this.fetchItemsArr([incNodeId,decNodeId],false);
            }
        },
        addFolder: function(inRoot) {
            reksidebar.Rek.log('add folder');
            var id,idx,self = this;
            rootId = parentId = this.folderMap[0].node.id;
            var sel = $('.browse-folders-folder.selected');
            if (sel.length == 1 && !inRoot) {
                id = sel.attr('recid');
                //idx = this.folderMap[this.getIdxByNodeId(id)].parent;
                //if (idx != -1) parentId = this.folderMap[idx].node.id;
                parentId = this.folderMap[this.getIdxByNodeId(id)].node.id;
            }
            
            reksidebar.Rek.log('parentId: '+parentId);
            reksidebar.treeMgr.rekView.addNode(reksidebar.Rek.getProperty('rek.newTreeNodeName'),parentId,function(id){
                // this bugs me and seems like a hack
                // have to wait until the DOM element is built through the broadcast event before I can fire edit
                // that is an asyncronous event - so i have to periodically check for its existence
                var fireEdit = function(id) {
                    var el = $('.browse-folders-folder[recid='+id+']');
                    if (el.length) {
                        // open the folder
                        if (rootId != parentId) self.openById(parentId);
                        $('#browse-folders-list .selected').removeClass('selected');
                        el.addClass('selected');
                        reksidebar.browse.folders.startEdit(el);
                    } else {
                        setTimeout(function(){fireEdit(id)},100);
                    }
                }
                setTimeout(function(){fireEdit(id)},100);
            });
        },
        cancelAdd: function($el) {
            var parent = $el.parents('.browse-folders-folder:first');
            this.stopEdit($el.find('.folder-title-editable-input').eq(0),true);
            this.remove(parent,false);
        },
        delayUpdate: function() {
            var _doUpdate = function() {
                reksidebar.Rek.log('lazy browse.folders update');
                var v = parseInt($('#broadcastTreeUpdate').attr('rek'))+1;
                $('#broadcastTreeUpdate').attr('rek',v.toString());
            }
            if (this.updateTimer) {
                clearTimeout(this.updateTimer);
            }
            this.updateTimer = setTimeout(_doUpdate,1000);
        },
        batchUpdate: function(arr) {
            $.each(arr,function(i,v){
                
            })
        },
        getNode: function(nodeId) {
            var node = null;
            $.each(this.folderMap,function(i,v){
                if (v.node.id == nodeId) {
                    node = v.node;
                    return false;
                }
            })
            return node;
        },
        getIdxByNodeId: function(nodeId) {
            var idx = -1;
            $.each(this.folderMap,function(i,v){
                if (v.node.id == nodeId) {
                    idx = i;
                    return false;
                }
            })
            return idx;
        },
        isChild: function(id,node) {
            var result = false;
            var iterate = function(arr) {
                for (var i=0;i<arr.length;i++) {
                    if (arr[i].id == id) {
                        result = true;
                        break;
                    }
                    if (!result && arr[i].children.length) iterate(arr[i].children);
                }
            }
            if (node.children.length) iterate(node.children);
            return result;
        }
    }
});
reksidebar.ns(function() {

    reksidebar.rekommend = {
        CONST: {
            inviteArr:[]
        },
        templates: {
            friendItem: ['<hbox class="reklistbox1 listitem{2}" recid="{1}" tooltiptext="{0}"><checkbox/><vbox flex="1"><description value="{0}" crop="end"/></vbox></hbox>'],
            emailInvite: [
            '<grid id="grid-emailinvite">',
            '<columns>',
            '<column flex="1"/>',
            '<column flex="1"/>',
            '</columns>',
            '<rows>',
            '<row><description value="{0}"/><description value="{1}"/></row>',
            '{2}',
            '<row class="inputrow"><textbox class="email"/><textbox class="name"/><vbox pack="center"></vbox></row>',
            '<row class="inputrow"><textbox class="email"/><textbox class="name"/><vbox pack="center"></vbox></row>',
            '<row class="inputrow"><textbox class="email"/><textbox class="name"/><vbox pack="center"></vbox></row>',
            '<row class="inputrow"><textbox class="email"/><textbox class="name"/><vbox pack="center"></vbox></row>',
            '<row class="inputrow last"><textbox class="email"/><textbox class="name"/><vbox pack="center"><image class="addrow" src="chrome://rekommend/skin/images/add.png" tooltiptext="Add row"/></vbox></row>',
            //'<row class="inputrow"><textbox class="email"/><textbox class="name"/></row>',
            //'<row class="inputrow"><textbox class="email"/><textbox class="name"/></row>',
            //'<row class="inputrow"><textbox class="email"/><textbox class="name"/></row>',
            '</rows>',
            '</grid>',
            ],
            emailInviteRow:['<row class="inputrow"><textbox class="email" value="{1}"/><textbox class="name" value="{0}"/></row>'],
            phoneInvite: [
            '<grid id="grid-phoneinvite">',
            '<columns>',
            '<column flex="1"/>',
            '<column flex="1"/>',
            '</columns>',
            '<rows>',
            '<row><description value="{0}"/><description value="{1}"/></row>',
            '<row class="inputrow last"><textbox class="phone"/><textbox class="name"/><vbox pack="center"><image class="addrow" src="chrome://rekommend/skin/images/add.png" tooltiptext="Add row"/></vbox></row>',
            //'<row class="inputrow"><textbox class="phone"/><textbox class="name"/></row>',
            //'<row class="inputrow"><textbox class="phone"/><textbox class="name"/></row>',
            //'<row class="inputrow"><textbox class="phone"/><textbox class="name"/></row>',
            '</rows>',
            '</grid>',
            '<groupbox><description class="red italic small">Only US numbers supported. International support coming soon...</description></groupbox>',
            ],
            postInvite: [
            '<deck id="postto-stack" selectedIndex="0">',
            '<vbox class="loader-wrapper">',
            '<hbox class="loader-12">',
            '<image src="chrome://rekommend/skin/images/loader_12.gif"/>',
            '</hbox>',
            '</vbox>',
            '<vbox id="postto-list">',
            '</vbox>',
            '</deck>'
            ],
            postInviteItem: [
            '<hbox class="reklistbox1 listitem" recid="{0}">',
            '<checkbox/><hbox><vbox pack="center"><image src="chrome://rekommend/skin/images/{1}"/></vbox>',
            '<spacer width="9"/>',
            '<vbox pack="center"><description value="{2}" crop="end"/></vbox></hbox>',
            '</hbox>',
            ]
        },
        sentCount: null,
        emailCount: 0,
        init: function() {
            reksidebar.Rek.log('rekommend init');
        },
        updateContacts: function() {
            reksidebar.Rek.log('update rekommend contacts');
            var rekStr = '',emailStr = '',postStr = '',textStr = '';
            var str,str2,name,emailArr = [];

            this.emailCount = 0;
            $.each(reksidebar.Rek.user.friend.friends,function(i,val){
                if (val.nd) name = val.nd;
                else if(val.rn) name = val.rn;
                else name = '';
                // is there a rek id/username
                if (val.rn && val.st == reksidebar.friend.CONST.CONTACT_STATUS_ACCEPTED || val.st == reksidebar.friend.CONST.CONTACT_STATUS_FRIEND) {
                    rekStr += reksidebar.rekommend.templates.friendItem.join('').format(reksidebar.Rek.xmlEncode((val.rn==name)?name:name+' ('+val.rn+')'),val.id,' rekmember');
                }
                
                // is there an email address and it is flagged as an email to
                if (val.e1 && val.et == '1') {
                    if (name) str2 = val.e1 + ' ('+name+')';
                    else str2 = val.e1;
                    emailArr.push({
                        email:str2,
                        id:val.id
                    });
                }

                // is there a mobile number
                if (val.m1) {
                    //str = (val.rn)?' rekmember':'';
                    if (name) str2 = val.m1 + ' ('+name+')';
                    else str2 = val.m1;
                    textStr += reksidebar.rekommend.templates.friendItem.join('').format(reksidebar.Rek.xmlEncode(str2),val.id,' textto');
                }
            });
            
            // build the email string
            // sort the array
            _sortfunc = function(a,b) {
                return a.email < b.email ? -1 : 1;
            }
            emailArr.sort(_sortfunc);
            $.each(emailArr,function(i,v){
                emailStr += reksidebar.rekommend.templates.friendItem.join('').format(reksidebar.Rek.xmlEncode(v.email),v.id,' emailto');
            });
            reksidebar.rekommend.emailCount = emailArr.length;

            // update rek list
            //reksidebar.Rek.log(rekStr);
            $('#rekommend-contact-rekto-content stack > vbox').hide();
            $('.contact-rekto-list').empty();
            if (rekStr.length) {
                reksidebar.Rek.appendDOMfromString($('.contact-rekto-list'),rekStr);
                reksidebar.rekommend.bindListActions('.contact-rekto-list');
                $('#rekommend-contact-rekto-content stack > vbox:nth-child(4)').show();
            } else {
                if (this.sentCount) $('#rekommend-contact-rekto-content stack > vbox:nth-child(3)').show();
                else $('.#rekommend-contact-rekto-content stack > vbox:nth-child(2)').show();
            }

            // update email list
            $('.contact-emailto-list').empty();
            reksidebar.Rek.appendDOMfromString($('.contact-emailto-list'),emailStr);
            reksidebar.rekommend.bindListActions('.contact-emailto-list');

            // update text list
            $('#rekommend-contact-textto-content stack > vbox').hide();
            $('.contact-textto-list').empty();
            if (textStr.length) {
                reksidebar.Rek.appendDOMfromString($('.contact-textto-list'),textStr);
                reksidebar.rekommend.bindListActions('.contact-textto-list');
                $('#rekommend-contact-textto-content stack > vbox:nth-child(3)').show();
            } else {
                $('#rekommend-contact-textto-content stack > vbox:nth-child(2)').show();
            }
        },
        updateSentCount: function() {
            var count = 0;
            $.each(reksidebar.Rek.user.friend.sent,function(i,val){
                if (val.st == reksidebar.friend.CONST.CONTACT_STATUS_INVITED) count++;
            });
            this.sentCount = count;
            $('.rek-pending-value').val(count);
            this.updateContacts();
        },
        addEmailTo: function(list) {
            var self = this;
            if (self.emailCount >= 100) {
                reksidebar.modal.open({
                    title: 'Emails Exceeded',
                    icon: 'exclamation.png',
                    text: 'You have more than 100 emails in your list. We limit the number of emails in this list in order to prevent spammers from using our extension.',
                    buttons:[
                    {
                        label:'OK',
                        callback: function(){
                            reksidebar.modal.close(this);
                        }
                    }]
                });
            } else {
                // create inital list
                liststr = '';
                if (list && list.length) {
                    $.each(list,function(i,v){
                        liststr += self.templates.emailInviteRow.join('').format(reksidebar.Rek.xmlEncode(v.name),reksidebar.Rek.xmlEncode(v.email));
                    });
                    reksidebar.Rek.log(liststr);
                    reksidebar.Rek.log(self.templates.emailInvite.join('').format());
                }
                reksidebar.modal.open({
                    id:'dialog2',
                    template:'insert',
                    title:reksidebar.Rek.getProperty('rek.rekommendEmailInvite'),
                    text:[self.templates.emailInvite.join('').format(reksidebar.Rek.getProperty('rek.rekommendEmailHeader'),reksidebar.Rek.getProperty('rek.rekommendNameHeader'),liststr)],
                    buttons:[/*{
                        label:'Import',
                        callback: function(){
                            reksidebar.friend.importContacts(null,null,null,function(list){
                                if (list.length > 100) {
                                    reksidebar.modal.open({
                                        title: 'Import Limit Exceeded',
                                        icon: 'exclamation.png',
                                        text: 'You are trying to import more than 100 emails to your list. We limit the number of emails in this list in order to prevent spammers from using our extension.',
                                        buttons:[
                                        {
                                            label:'OK',
                                            callback: function(){
                                                reksidebar.modal.close(this);
                                            }
                                        }]
                                    });
                                } else {
                                    self.addEmailTo(list);
                                }
                            });
                        }
                    },*/{
                        label:'Add',
                        callback: function() {
                            var arr = [];
                            $.each($('#grid-emailinvite .inputrow'),function(i,val) {
                                var email,name;
                                name = $(val).children('.name').val();
                                email = $(val).children('.email').val();
                                if (reksidebar.Rek.isEmail(email)) {
                                    arr.push({
                                        name:name,
                                        ref:email
                                    });
                                }
                            });
                            if (arr.length) {
                                reksidebar.Rek.log('email invite');
                                $.ajax({
                                    type: 'POST',
                                    async: true,
                                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/addEmailTo.php',
                                    data: {
                                        id:reksidebar.Rek.user.id,
                                        session:reksidebar.Rek.user.session,
                                        arr:JSON.stringify(arr)
                                    },
                                    dataType: 'text',
                                    success: function(json){
                                        reksidebar.Rek.log(json);
                                        reksidebar.Rek.db.fetch(false,[{
                                            id:'friend.friend',
                                            crc: reksidebar.friend.friendCrc
                                        }]);
                                    },
                                    error: function(req,status,error){
                                        // check on system status
                                        reksidebar.Rek.validateStatus(status);
                                    }
                                });
                            }
                            reksidebar.modal.close(this);
                        }
                    },{
                        label:'Cancel',
                        callback: function(){
                            reksidebar.modal.close(this);
                        }
                    }]
                });
            }
        },
        addPostTo: function() {
            /*var rr = this;
            reksidebar.modal.open({
                id:'dialog2',
                template:'insert',
                title:reksidebar.Rek.getProperty('rek.rekommendPostInvite'),
                text:[rr.templates.postInvite.join('').format()],
                beforeOpen: function(){
                    // display loader
                    $('#postto-stack').attr('selectedIndex','0');
                    // get the current list of social networks
                    $.ajax({
                        type: 'POST',
                        async: true,
                        url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/getNetworkList.php',
                        dataType: 'json',
                        success: function(json){
                            //reksidebar.Rek.log(json);
                            $('#postto-list').empty();
                            $.each(json.data,function(i,v){
                                reksidebar.Rek.appendDOMfromString($('#postto-list'),rr.templates.postInviteItem.join('').format(
                                    v.id,v.icon24_fname,v.name
                                ));
                            });
                            reksidebar.rekommend.bindListActions('#postto-list');
                            $('#postto-stack').attr('selectedIndex','1');
                        },
                        error: function(req,status,error){
                            // something happened to the request
                            // display error
                            $('#postto-list').empty();
                            reksidebar.Rek.appendDOMfromString($('#postto-list'),'<description>A system error occurred. Please contact the system administrator.</description>');
                            $('#postto-stack').attr('selectedIndex','1');
                        }
                    });
                },
                buttons:[{
                    label:'Add',
                    callback: function() {
                        var arr = [];
                        $('#postto-list checkbox:checked').parents('.listitem').each(function(i,v){
                            arr.push($(v).attr('recid'));
                        });
                        reksidebar.Rek.log(arr);
                        // add PostTo contact records
                        $.ajax({
                            type: 'POST',
                            async: true,
                            url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/addPostTo.php',
                            data: {
                                id:reksidebar.Rek.user.id,
                                session:reksidebar.Rek.user.session,
                                arr:JSON.stringify(arr)
                            },
                            dataType: 'json',
                            success: function(json){
                                //reksidebar.Rek.log(json);
                                reksidebar.Rek.db.fetch(false,[{
                                    id:'friend.friend',
                                    crc: reksidebar.friend.friendCrc
                                }]);
                            },
                            error: function(req,status,error){
                                // check on system status
                                reksidebar.Rek.validateStatus(status);
                            }
                        });
                        reksidebar.modal.close(this);
                    }
                },{
                    label:'Cancel',
                    callback: function(){
                        reksidebar.modal.close(this);
                    }
                }]
            });*/
        },
        addTextTo: function() {
            reksidebar.modal.open({
                id:'dialog2',
                template:'insert',
                title:reksidebar.Rek.getProperty('rek.rekommendPhoneInvite'),
                text:[this.templates.phoneInvite.join('').format(reksidebar.Rek.getProperty('rek.rekommendPhoneHeader'),reksidebar.Rek.getProperty('rek.rekommendNameHeader'))],
                buttons:[{
                    label:'Add',
                    callback: function() {
                        var arr = [];
                        $.each($('#grid-phoneinvite .inputrow'),function(i,val) {
                            var phone,name;
                            name = $(val).children('.name').val();
                            phone = $(val).children('.phone').val();
                            if (phone.length) {
                                arr.push({
                                    type:'phone',
                                    name:name,
                                    ref:phone
                                });
                            }
                        });
                        if (arr.length) {
                            reksidebar.Rek.log('textto invite');
                            $.ajax({
                                type: 'POST',
                                async: true,
                                url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/inviteFriends.php',
                                data: {
                                    id:reksidebar.Rek.user.id,
                                    session:reksidebar.Rek.user.session,
                                    arr:JSON.stringify(arr)
                                },
                                dataType: 'json',
                                success: function(json){
                                    reksidebar.Rek.log(json);
                                    reksidebar.Rek.db.fetch(false,[{
                                        id:'friend.friend',
                                        crc: reksidebar.friend.friendCrc
                                    }]);
                                },
                                error: function(req,status,error){
                                    // check on system status
                                    reksidebar.Rek.validateStatus(status);
                                }
                            });
                        }
                        reksidebar.modal.close(this);
                    }
                },{
                    label:'Cancel',
                    callback: function(){
                        reksidebar.modal.close(this);
                    }
                }]
            });
        },
        removeSelected: function(list) {
            var sel = $(list+'-list .listitem.selected');
            var arr = [],sel2 = [];
            if (sel.length > 0) {
                $.each(sel,function(i,val){
                    reksidebar.Rek.log(val);
                    reksidebar.Rek.log(list);
                    // dont allow rekmembers to be deleted anywhere but the rek tab
                    if (list == '#rekommend-contact-rekto' || !$(val).hasClass('rekmember')) {
                        sel2.push(val);
                        arr.push($(val).attr('recid'));
                    }
                });
                reksidebar.Rek.log(arr);
                if (arr.length > 0) {
                    reksidebar.modal.open({
                        title:reksidebar.Rek.getProperty('rek.friendRemoveTitle'),
                        icon:'exclamation.png',
                        text:reksidebar.Rek.getProperty('rek.friendRemoveText'),
                        skip:'fr_rm',
                        buttons:[{
                            label:'Remove',
                            callback: function() {
                                reksidebar.modal.close(this);
                                if (reksidebar.Rek.db.setActiveStatus('contact',arr,'false')) {
                                    $(sel2).remove();
                                    if ($(list+'-list .listitem').length == 0) {
                                        $(list+'-content stack > vbox:nth-child(2)').show();
                                    }
                                    reksidebar.Rek.db.fetch(false,[{
                                        id:'friend.friend',
                                        crc: reksidebar.friend.friendCrc
                                    }]);
                                }
                            }
                        },{
                            label:'Cancel',
                            callback: function(){
                                reksidebar.modal.close(this);
                            }
                        }]
                    });
                } else {
                    reksidebar.modal.open({
                        title:reksidebar.Rek.getProperty('rek.rekommendCantRemove'),
                        icon:'exclamation.png',
                        text:reksidebar.Rek.getProperty('rek.rekommendCantRemoveText'),
                        skip:'rekommend_cant_remove',
                        buttons:[
                        {
                            label:'OK',
                            callback: function(){
                                reksidebar.modal.close(this);
                            }
                        }]
                    });
                }
            }
        },
        removeEmailTo: function(list) {
            var sel = $(list+'-list .listitem.selected');
            var arr = [];
            reksidebar.Rek.log('here');
            reksidebar.Rek.log($(list+'-list'));
            if (sel.length > 0) {
                $.each(sel,function(i,val){
                    arr.push($(val).attr('recid'));
                });
                reksidebar.modal.open({
                    title:reksidebar.Rek.getProperty('rek.emailToRemoveTitle'),
                    icon:'exclamation.png',
                    text:reksidebar.Rek.getProperty('rek.emailToRemoveText'),
                    skip:'et_rm',
                    buttons:[{
                        label:'Remove',
                        callback: function() {
                            reksidebar.modal.close(this);
                            reksidebar.Rek.db.setRecordSet('contact','email_to',arr,'false');
                            $(sel).remove();
                        }
                    },{
                        label:'Cancel',
                        callback: function(){
                            reksidebar.modal.close(this);
                        }
                    }]
                });
            }
        },
        rekommend: function() {
            var title = $('#app-rek-description').val();
            var url = $('#app-rek-url').val();
            // generate the array of contacts
            var wrapApp = ['#contact-rekto-wrapper','#contact-emailto-wrapper','#contact-postto-wrapper','#contact-textto-wrapper'];
            var listArr = ['#rekommend-contact-rekto-list','#rekommend-contact-emailto-list','#rekommend-contact-textto-list','#rekommend-contact-postto-list'];
            var typArr = ['rek_user_id','email1','mobile1','social'];
            var arr = [];
            $.each(listArr,function(i,val){
                $.each($(val+' .listitem.selected'),function(j,val) {
                    arr.push({
                        id: $(val).attr('recid'),
                        type:typArr[i]
                    });
                })
            });
            if (!title) {
                this.showResult('error',reksidebar.Rek.getProperty('rek.bmark.noTitle'));
            } else if (!url) {
                this.showResult('error',reksidebar.Rek.getProperty('rek.bmark.noURL'));
            } else if (arr.length == 0) {
                this.showResult('error',reksidebar.Rek.getProperty('rek.rekommend.noRecipients'));
            } else {
                // ajax call
                $('#rek-submit-deck').attr('selectedIndex','1'); // show loader
                reksidebar.Rek.log('rek-addRek');
                //reksidebar.Rek.log(arr);
                $.ajax({
                    type: 'POST',
                    async: true,
                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/addRek.php',
                    data: {
                        id: reksidebar.Rek.user.id,
                        session: reksidebar.Rek.user.session,
                        rekArr: JSON.stringify([{
                            type: 'rek',
                            ref: null,
                            create: true,
                            isPrivate: false,
                            title: $('#app-rek-pagetitle').val(),
                            alt: title,
                            url: url,
                            node: reksidebar.Rek.user.data.rek_top_node_id,
                            tags: [],
                            comment: $('#app-rek-comments').val(),
                            sendTo: arr
                        }])
                    },
                    dataType: 'text',
                    success: function(json){
                        reksidebar.Rek.log(json);
                        $('#rek-submit-deck').attr('selectedIndex','1');
                        $('#app-rek-comments').val('');
                        reksidebar.rekommend.showResult('ok',reksidebar.Rek.getProperty('rek.rekommend.success'));
                        reksidebar.browse.reload(['browse.sent','browse.comments']);
                        // deselect all recipients unless keep is selected
                        $.each(wrapApp,function(i,v){
                            if (!$(v).find('.rek-keep')[0].checked) {
                                $(v).find('checkbox').each(function(j,w){w.checked=false});
                                $(v).find('.selected').removeClass('selected');
                                /*$(v).find('.selected').each(function(j,w){
                                    $(w).children('checkbox')[0].checked = false;
                                    $(w).removeClass('selected');
                                });*/
                            }
                        });
                    },
                    error: function(req,status,error){
                        reksidebar.Rek.log('create rek failed');
                        reksidebar.rekommend.showResult('error',reksidebar.Rek.getProperty('rek.rekommend.fail'));
                        reksidebar.Rek.validateStatus(status);
                    }
                });

            }
        },
        showPopupRekommend: function(rekArr) {
            var str = '',el;
            var template = [
            //'<hbox class="popuprekommend-listitem" ref="{4}">',
            //'<vbox pack="center"><vbox class="popuprekommend-listitem-icon {0}"/></vbox>',

            '<vbox class="popuprekommend-listitem rekgroupbox" ref="{4}">',
            '<description class="popuprekommend-listitem-pagetitle hidden" value="{5}"/>',
            //'<label value="&app.rek.description;"/>',
            '<textbox class="popuprekommend-listitem-title" wrap="off" value="{1}"/>',
            '<description class="popuprekommend-listitem-url small" readonly="true" wrap="off" crop="end" value="{2}" onclick="reksidebar.Rek.openURL(this.value);" ondragstart="event.dataTransfer.setData(\'text/plain\',this.value)"/>',
            '<textbox class="popuprekommend-listitem-comments small" multiline="true" rows="2" height="30" flex="1" value="{3}" emptytext="Comments"/>',
            '</vbox>',

            /*'<vbox class="popuprekommend-listitem-wrapper" flex="1">',
            '<description class="popuprekommend-listitem-pagetitle hidden" value="{5}"/>',
            '<textbox class="popuprekommend-listitem-title" flex="1" wrap="off" value="{1}"/>',
            '<description class="popuprekommend-listitem-url small" flex="1" readonly="true" wrap="off" crop="end" value="{2}" onclick="reksidebar.Rek.openURL(this.value);" ondragstart="event.dataTransfer.setData(\'text/plain\',this.value)"/>',
            '<textbox class="popuprekommend-listitem-comments small" multiline="true" rows="2" height="30" flex="1" value="{3}" onfocus="if (this.value == \'{3}\'){this.style.color=\'#000\';this.value=\'\';}" onblur="if (this.value == \'\'){this.style.color=\'#999\';this.value=\'{3}\';}"/>',
            '</vbox>',*/
            //'</hbox>'
            ];

            $.each(rekArr,function(i,v){
                str += template.join('').format(
                    v.type,
                    reksidebar.Rek.xmlEncode(v.alt),
                    reksidebar.Rek.xmlEncode(v.url),
                    '',
                    v.id?v.id:'',
                    reksidebar.Rek.xmlEncode(v.title)
                );
            });
            // set the pager
            if (rekArr.length == 1) {
                $('#popuprekommend-pager').hide();
            } else {
                $('#popuprekommend-pager').show();
                $('#popuprekommend-pager .hover-button').removeClass('disabled');
                $('#popuprekommend-pager .hover-button').eq(0).addClass('disabled');
                $('#popuprekommend-pager .pager-curpage').val(1);
                $('#popuprekommend-pager .pager-total-pages').val(rekArr.length);
            }
            
            $('#popuprekommend-reklist').empty();
            reksidebar.Rek.appendDOMfromString($('#popuprekommend-reklist'),str);

            reksidebar.modal.open({
                id:'rekItDialog',
                title:'reKommend It!',
                text:'',
                buttons:[{
                    label:'Close',
                    callback: function(){
                        reksidebar.modal.close(this);
                    }
                }]
            });
        },
        popupRekommend: function() {
            reksidebar.Rek.log('do popup rekommend');
            var str,id,alt,url,comments,result = '';
            var arr = [],arr2 = [];
            var listArr = ['#popup-contact-rekto-list','#popup-contact-emailto-list','#popup-contact-textto-list','#popup-contact-postto-list'];
            var typArr = ['rek_user_id','email1','mobile1','social'];
            var showResult = function(typ,txt) {
                var icon;
                var _hideResult = function() {
                    $('#popuprek-submit-deck').attr('selectedIndex','0');
                }
                switch(typ) {
                    case 'error':
                        icon = 'chrome://rekommend/skin/images/cancel16.png';
                        break;
                    case 'ok':
                        icon = 'chrome://rekommend/skin/images/check.png';
                        break;
                }
                $('#popuprek-result-image').attr('src',icon);
                $('#popuprek-result-text').val(txt);
                $('#popuprek-submit-deck').attr('selectedIndex','2');
                setTimeout(_hideResult,2500);
            };
            $.each(listArr,function(i,val){
                $.each($(val+' .listitem.selected'),function(j,val) {
                    arr.push({
                        id: $(val).attr('recid'),
                        type:typArr[i]
                    });
                })
            });
            //reksidebar.Rek.log(arr);
            $.each($('.popuprekommend-listitem'),function(i,v){
                id = $(v).attr('ref');
                alt= $(v).find('.popuprekommend-listitem-title').val();
                url = $(v).find('.popuprekommend-listitem-url').val();
                comments = $(v).find('.popuprekommend-listitem-comments').val();
                if (!alt) {
                    result = reksidebar.Rek.getProperty('rek.bmark.noTitle');
                    return false;
                } else if (!url) {
                    result = reksidebar.Rek.getProperty('rek.bmark.noURL');
                    return false;
                } else if (arr.length == 0) {
                    result = reksidebar.Rek.getProperty('rek.rekommend.noRecipients');
                    return false;
                } else {
                    arr2.push({
                        type: 'rek',
                        ref: id,
                        create: true,
                        isPrivate: false,
                        title: $(v).find('.popuprekommend-listitem-pagetitle').val(),
                        alt: alt,
                        url: url,
                        node: reksidebar.Rek.user.data.rek_top_node_id,
                        tags: [],
                        comment: comments,
                        sendTo: arr
                    });
                    return true;
                }
            });
            if (result) {
                showResult('error',result);
            } else {
                // ajax call
                $('#popuprek-submit-deck').attr('selectedIndex','1'); // show loader
                reksidebar.Rek.log('popuprek-addRek');
                $.ajax({
                    type: 'POST',
                    async: true,
                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/addRek.php',
                    data: {
                        id: reksidebar.Rek.user.id,
                        session: reksidebar.Rek.user.session,
                        rekArr: JSON.stringify(arr2)
                    },
                    dataType: 'text',
                    success: function(json){
                        //reksidebar.Rek.log(json);
                        // update folder count
                        // TODO SEND FOLDER IN BROWSE.FOLDERS
                        $('#popuprek-submit-deck').attr('selectedIndex','1');
                        showResult('ok',reksidebar.Rek.getProperty('rek.rekommend.success'));
                        reksidebar.browse.reload(['browse.sent']);
                    },
                    error: function(req,status,error){
                        reksidebar.Rek.log('create popup rek failed');
                        showResult('error',reksidebar.Rek.getProperty('rek.rekommend.fail'));
                        reksidebar.Rek.validateStatus(status);
                    }
                });
            }
        },
        nextPopupPage: function() {
            reksidebar.Rek.log('next page');
            var page = $('#popuprekommend-pager .pager-curpage').val();
            var max = $('#popuprekommend-pager .pager-total-pages').val();
            page++;
            $('#popuprekommend-reklist').animate({scrollTop:(page-1)*115},600);
            $('#popuprekommend-pager .pager-curpage').val(page);
            if (page == max) $('#popuprekommend-pager .hover-button').eq(1).addClass('disabled');
            if (page == 2) $('#popuprekommend-pager .hover-button').eq(0).removeClass('disabled');
        },
        previousPopupPage: function() {
            var page = $('#popuprekommend-pager .pager-curpage').val();
            var max = $('#popuprekommend-pager .pager-total-pages').val();
            page--;
            $('#popuprekommend-reklist').animate({scrollTop:(page-1)*115},600);
            $('#popuprekommend-pager .pager-curpage').val(page);
            if (page == 1) $('#popuprekommend-pager .hover-button').eq(0).addClass('disabled');
            if (page == max-1) $('#popuprekommend-pager .hover-button').eq(1).removeClass('disabled');
        },
        showResult: function(typ,txt) {
            var icon;
            var _hideResult = function() {
                $('#rek-submit-deck').attr('selectedIndex','0');
            }
            switch(typ) {
                case 'error':
                    icon = 'chrome://rekommend/skin/images/cancel16.png';
                    break;
                case 'ok':
                    icon = 'chrome://rekommend/skin/images/check.png';
                    break;
            }
            $('#rek-result-image').attr('src',icon);
            $('#rek-result-text').val(txt);
            $('#rek-submit-deck').attr('selectedIndex','2');
            setTimeout(_hideResult,2500);
        },
        bindListActions: function(list) {
            $(list+' .listitem').click(function(e){
                var $el = $(this);
                if ($el.find('checkbox').attr('disabled') != 'true') {
                    if ($el.hasClass('selected')) {
                        $el.children('checkbox').each(function(i,v){v.checked=false});
                        $el.removeClass('selected');
                    } else {
                        $el.children('checkbox').each(function(i,v){v.checked=true});
                        $el.addClass('selected');
                    }
                }
                
            });
        }
    }
});
reksidebar.ns(function() {

    reksidebar.bmark = {
        init: function() {
            reksidebar.Rek.log('bmark init');
            var tree =  $('#bmark-folder-tree')[0];
            tree.view = reksidebar.treeMgr.rekView;
            tree.view.selection.select(0);
        },
        bookmark: function() {
            var tags=[],comment;
            var title = $('#app-bmark-description').val();
            var url = $('#app-bmark-url').val();
            var nodeId = reksidebar.treeMgr.rekView.indexMap[$('#bmark-folder-tree')[0].currentIndex].node.id;
            // extract tags
            var str = $('#app-bmark-tags').val();
            if (str == reksidebar.Rek.getProperty('rek.bmark.tagseparate')) str = '';
            if (str) tags = str.toLowerCase().split(',');
            $.each(tags,function(i,v){
                tags[i] = reksidebar.Rek.trim(v);
            });
            // if no folder selected, assume ungrouped and select
            if (!$('#bmark-folder-tree')[0].currentIndex) $('#bmark-folder-tree')[0].view.selection.select(0);
            if (!title) {
                this.showResult('error',reksidebar.Rek.getProperty('rek.bmark.noTitle'));
            } else if (!url) {
                this.showResult('error',reksidebar.Rek.getProperty('rek.bmark.noURL'));
            } else {
                // ajax call
                $('#bmark-submit-deck').attr('selectedIndex','1'); // show loader
                $.ajax({
                    type: 'POST',
                    async: true,
                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/addRek.php',
                    data: {
                        id: reksidebar.Rek.user.id,
                        session: reksidebar.Rek.user.session,
                        rekArr: JSON.stringify([{
                            type: 'bookmark',
                            ref: null,
                            create: true,
                            isPrivate: $('#app-bmark-private').attr('checked') == 'true',
                            title: $('#app-bmark-pagetitle').val(),
                            alt: title,
                            url: url,
                            node: nodeId,
                            tags: tags,
                            comment: $('#app-bmark-comments').val(),
                            sendTo: []
                        }])
                    },
                    dataType: 'json',
                    success: function(json){
                        reksidebar.Rek.log(json);
                        //json = JSON.parse(json);
                        if (json.duplicates > 0) {
                            // there were duplicates - inform
                            reksidebar.modal.open({
                                title:'Duplicate Bookmark',
                                text:'You already have this page bookmarked.',
                                buttons:[{
                                    label:'Close',
                                    callback: function(){
                                        reksidebar.modal.close(this);
                                    }
                                }]
                            });
                        }
                        $('#bmark-submit-deck').attr('selectedIndex','1');
                        reksidebar.bmark.showResult('ok',reksidebar.Rek.getProperty('rek.bmark.success'));
                        // update tag count and add the new tags to popup list
                        $.each(tags,function(i,v){
                            var match = false;
                            $.each(reksidebar.Rek.user.data.tagList,function(j,w){
                                if (v == w.name) {
                                    match = true;
                                    w.count++;
                                    return false;
                                }
                            });
                            if (!match) {
                                reksidebar.Rek.user.data.tagList.push({
                                    name:v,
                                    count:1
                                });
                            }
                        });
                        // update browse.folders
                        reksidebar.browse.folders.incCount(nodeId,1);
                        // force an update of browse.tags
                        reksidebar.browse.updateTagList();
                        $('#app-bmark-private').attr('checked','false');
                        $('#app-bmark-tags').val('');
                        $('#app-bmark-comments').val('');
                        reksidebar.browse.reload(['browse.bmark']);
                    },
                    error: function(req,status,error){
                        reksidebar.Rek.log('create bookmark failed');
                        reksidebar.bmark.showResult('error',reksidebar.Rek.getProperty('rek.bmark.fail'));
                        reksidebar.Rek.validateStatus(status);
                    }
                });
                
            }
        },
        showPopupBmark: function(rekArr) {
            var tree,rekViewArr = [],str = '';
            var template = [
            '<vbox class="popupbmark-listitem">',
            //'<vbox pack="center"><vbox class="popupbmark-listitem-icon {0}"/></vbox>',
            '<description class="popupbmark-listitem-pagetitle hidden" value="{5}"/>',

            '<vbox class="rekgroupbox">',
            '<textbox class="popupbmark-listitem-title" flex="1" wrap="off" value="{1}"/>',
            '<description class="popupbmark-listitem-url small" flex="1" readonly="true" wrap="off" crop="end" value="{2}" onclick="reksidebar.Rek.openURL(this.value);" ondragstart="event.dataTransfer.setData(\'text/plain\',this.value)"/>',
            '</vbox>',

            '<description class="rekgroupbox-title" value="Select folder:"/>',
            '<vbox class="popupbmark-folder-content">',
            '<hbox class="toolbar">',
            '<hbox class="rekbutton" onclick="reksidebar.bmark.popupAddRow(this,true);">',
            '<vbox pack="center">',
            '<description value="New Root Folder"/>',
            '</vbox>',
            '</hbox>',
            '<hbox class="rekbutton" onclick="reksidebar.bmark.popupAddRow(this,false);">',
            '<vbox pack="center">',
            '<description value="New Sub Folder"/>',
            '</vbox>',
            '</hbox>',
            '</hbox>',
            '<tree class="popupbmark-folder-tree rek-dir-tree" hidecolumnpicker="true" seltype="single" editable="true" treelines="false" flex="1">',
            '<treecols>',
            '<treecol primary="true" label="" value="" flex="1"/>',
            '</treecols>',
            '<treechildren ondragstart="reksidebar.treeMgr.rekPopupView.dragStart(event);"/>',
            '</tree>',
            '</vbox>',
            '<vbox class="rekgroupbox" flex="1">',
            '<textbox class="popupbmark-listitem-tags small" multiline="true" rows="2" flex="1" value="{4}" emptytext="Tags (separate with commas)"/>',
            '<textbox class="popupbmark-listitem-comments small" multiline="true" rows="2" flex="1" value="{3}" emptytext="Notes"/>',
            '</vbox>',
            '</vbox>'
            ];
            $.each(rekArr,function(i,v){
                str += template.join('').format(
                    v.type,
                    reksidebar.Rek.xmlEncode(v.alt),
                    reksidebar.Rek.xmlEncode(v.url),
                    '',
                    '',
                    reksidebar.Rek.xmlEncode(v.title)
                    );
                rekViewArr.push(reksidebar.treeMgr.getImbeddedRekView('bmark'));
            });
            // set the pager
            if (rekArr.length == 1) {
                $('#popupbmark-pager').hide();
            } else {
                $('#popupbmark-pager').show();
                $('#popupbmark-pager .hover-button').removeClass('disabled');
                $('#popupbmark-pager .hover-button').eq(0).addClass('disabled');
                $('#popupbmark-pager .pager-curpage').val(1);
                $('#popupbmark-pager .pager-total-pages').val(rekArr.length);
            }
            $('#popupbmark-reklist').empty();
            reksidebar.Rek.appendDOMfromString($('#popupbmark-reklist'),str);
            $.each($('.popuprekommend-listitem-tags'),function(i,v){
                $(v).css('color','#999999');
            });
            $.each($('.popuprekommend-listitem-comments'),function(i,v){
                $(v).css('color','#999999');
            });
            reksidebar.modal.open({
                id:'bmarkItDialog',
                title:'Bookmark It!',
                text:'',
                buttons:[{
                    label:'Close',
                    callback: function(){
                        reksidebar.modal.close(this);
                    }
                }]
            });
            $.each($('.popupbmark-folder-tree'),function(i,v) {
                v.viewObj = rekViewArr[i];
                v.view = rekViewArr[i];
                v.view.selection.select(0);
            });
        },
        popupAddRow: function(el,inRoot) {
            var tree = $(el).parents('.popupbmark-folder-content').find('.popupbmark-folder-tree')[0];
            tree.viewObj.addRow(inRoot,true);
        },
        invalidateTrees: function() {
            $.each($('.popupbmark-folder-tree'),function(i,v) {
                var view = v.viewObj;
                var oldCount = view.getRowCount();
                view.buildIndexMap();
                view.rowCount = view.getRowCount();
                view.treeBox.rowCountChanged(0,view.rowCount-oldCount);
                view.treeBox.invalidate();
            });
        },
        popupBmark: function() {
            reksidebar.Rek.log('do popup bookmark');
            var str,alt,url,node,comments,result = '';
            var tags = [],arr = [];
            var showResult = function(typ,txt) {
                var icon;
                var _hideResult = function() {
                    $('#popupbmark-submit-deck').attr('selectedIndex','0');
                }
                switch(typ) {
                    case 'error':
                        icon = 'chrome://rekommend/skin/images/cancel16.png';
                        break;
                    case 'ok':
                        icon = 'chrome://rekommend/skin/images/check.png';
                        break;
                }
                $('#popupbmark-result-image').attr('src',icon);
                $('#popupbmark-result-text').val(txt);
                $('#popupbmark-submit-deck').attr('selectedIndex','2');
                setTimeout(_hideResult,2500);
            };
            $.each($('.popupbmark-listitem'),function(i,v){
                alt= $(v).find('.popupbmark-listitem-title').val();
                url = $(v).find('.popupbmark-listitem-url').val();
                // folder
                node = $('.popupbmark-folder-tree')[i].viewObj.indexMap[$('.popupbmark-folder-tree')[i].currentIndex].node.id;
                // extract tags
                str = $('.popupbmark-listitem-tags').val();
                if (str == reksidebar.Rek.getProperty('rek.rekommend.popupTags')) str = '';
                tags = str.toLowerCase().split(',');
                comments = $(v).find('.popupbmark-listitem-comments').val();
                comments = (comments == reksidebar.Rek.getProperty('rek.rekommend.popupComments')?'':comments);
                if (!alt) {
                    result = reksidebar.Rek.getProperty('rek.bmark.noTitle');
                    return false;
                } else if (!url) {
                    result = reksidebar.Rek.getProperty('rek.bmark.noURL');
                    return false;
                } else {
                    arr.push({
                        type: 'bookmark',
                        ref: null,
                        create: true,
                        isPrivate: false,
                        title: $(v).find('.popupbmark-listitem-pagetitle').val(),
                        alt: alt,
                        url: url,
                        node: node,
                        tags: tags,
                        comment: comments,
                        sendTo: []
                    });
                    return true;
                }
            });
            if (result) {
                showResult('error',result);
            } else {
                // ajax call
                $('#popupbmark-submit-deck').attr('selectedIndex','1'); // show loader
                reksidebar.Rek.log('popup-bmark-addRek');
                $.ajax({
                    type: 'POST',
                    async: true,
                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/addRek.php',
                    data: {
                        id: reksidebar.Rek.user.id,
                        session: reksidebar.Rek.user.session,
                        rekArr: JSON.stringify(arr)
                    },
                    dataType: 'json',
                    success: function(json){
                        //reksidebar.Rek.log(json);
                        if (json.duplicates > 0) {
                            // there were duplicates - inform
                            reksidebar.modal.open({
                                title:'Duplicate Bookmark(s)',
                                text:'One or more pages you requested to be bookmarked already exist as bookmarks and were skipped.',
                                buttons:[{
                                    label:'Close',
                                    callback: function(){
                                        reksidebar.modal.close(this);
                                    }
                                }]
                            });
                        }
                        // update tag count and add the new tags to popup list
                        $.each(tags,function(i,v){
                            var match = false;
                            $.each(reksidebar.Rek.user.data.tagList,function(j,w){
                                if (v == w.name) {
                                    match = true;
                                    w.count++;
                                    return false;
                                }
                            });
                            if (!match) {
                                reksidebar.Rek.user.data.tagList.push({
                                    name:v,
                                    count:1
                                });
                            }
                        });
                        // update browse.folders count
                        $.each(arr,function(i,v){
                            reksidebar.browse.folders.incCount(v.node,1);
                        });
                        
                        $('#popupbmark-submit-deck').attr('selectedIndex','1');
                        showResult('ok',reksidebar.Rek.getProperty('rek.bmark.success'));
                        reksidebar.browse.reload(['browse.bmark']);
                        // force an update of browse.tags
                        reksidebar.browse.updateTagList();
                    },
                    error: function(req,status,error){
                        reksidebar.Rek.log('create popup bmark failed');
                        showResult('error',reksidebar.Rek.getProperty('rek.bmark.fail'));
                        reksidebar.Rek.validateStatus(status);
                    }
                });
            }
        },
        nextPopupPage: function() {
            reksidebar.Rek.log('next page');
            var page = $('#popupbmark-pager .pager-curpage').val();
            var max = $('#popupbmark-pager .pager-total-pages').val();
            page++;
            $('#popupbmark-reklist').animate({
                scrollTop:(page-1)*315
                },800,function(){
                $('#popupbmark-reklist .popupbmark-listitem').eq(page-1).find('.popupbmark-folder-tree').focus();
            });
            $('#popupbmark-pager .pager-curpage').val(page);
            if (page == max) $('#popupbmark-pager .hover-button').eq(1).addClass('disabled');
            if (page == 2) $('#popupbmark-pager .hover-button').eq(0).removeClass('disabled');
        },
        previousPopupPage: function() {
            var page = $('#popupbmark-pager .pager-curpage').val();
            var max = $('#popupbmark-pager .pager-total-pages').val();
            page--;
            $('#popupbmark-reklist').animate({
                scrollTop:(page-1)*315
                },800,function(){
                $('#popupbmark-reklist .popupbmark-listitem').eq(page-1).find('.popupbmark-folder-tree').focus();
            });
            $('#popupbmark-pager .pager-curpage').val(page);
            if (page == 1) $('#popupbmark-pager .hover-button').eq(0).addClass('disabled');
            if (page == max-1) $('#popupbmark-pager .hover-button').eq(1).removeClass('disabled');
        },
        showResult: function(typ,txt) {
            var icon;
            var _hideResult = function() {
                $('#bmark-submit-deck').attr('selectedIndex','0');
            }
            switch(typ) {
                case 'error':
                    icon = 'chrome://rekommend/skin/images/cancel16.png';
                    break;
                case 'ok':
                    icon = 'chrome://rekommend/skin/images/check.png';
                    break;
            }
            $('#bmark-result-image').attr('src',icon);
            $('#bmark-result-text').val(txt);
            $('#bmark-submit-deck').attr('selectedIndex','2');
            setTimeout(_hideResult,2500);
        },
        ontagdragstart: function(event,tag) {
            event.dataTransfer.setData('application/x-tag',tag);
        },
        ontagdragover: function(event) {
            if (event.dataTransfer.types.contains('application/x-tag')) {
                $('#app-bmark-tags').focus();
                event.preventDefault();
            }
        },
        ontagdragleave: function(event) {
            if (event.dataTransfer.types.contains('application/x-tag')) {
                $('#app-bmark-tags').blur();
            }
        },
        ontagdragdrop: function(event) {
            //reksidebar.Rek.log('ondrag');
            this.addTag(event.dataTransfer.getData('application/x-tag'));
        },
        addTag: function(tag) {
            $('#app-bmark-tags').focus();
            var val = $('#app-bmark-tags').val();
            if (val.length) tag = ','+tag;
            val += tag;
            $('#app-bmark-tags').val(val);
        }
    }
});
reksidebar.ns(function() {

    reksidebar.search = {
        CONST: {
        },
        templates: {
            mine: [
            '<hbox class="search-listitem listitem{0}{18}{24}" recid="{1}" rekid="{14}" nodeid="{11}" url="{8}" tiny="{23}" type="{12}">',
            '<grid flex="1">',
            '<columns><column flex="1"/></columns>',
            '<rows>',
            '<row class="browse-listitem-item">',
            '<hbox class="collapse">',
            '<vbox><checkbox class="browse-checkbox" checked="{10}" onclick="event.stopPropagation();"/></vbox>',
            '<vbox flex="1">',

            '<hbox class="collapse" flex="1" onclick="reksidebar.browse.read(\'search.mine\',$(this).parents(\'.search-listitem\'));" tooltiptext="{21}">',
            '<hbox class="browse-listitem-privateicon">',
            '<vbox pack="center">',
            '<image class="" src="chrome://rekommend/skin/images/lock8.png"/>',
            '</vbox>',
            '</hbox>',

            '<description class="browse-pagetitle hidden" value="{21}"/>',
            '<description class="browse-title-static hidden" value="{21}"/>',
            '<hbox class="browse-title-static-html-wrapper overx-hidden" flex="1" crop="end"><html:span class="browse-title-static-html over-ellipsis nowrap">{3}</html:span></hbox>',
            '</hbox>',
            '<spacer height="3"/>',

            '<hbox>',
            '<spacer width="4"/>',
            '{4}',
            
            '<hbox class="{9}">',
            //'<hbox class="separator"/>',
            '<vbox pack="start">',
            '<hbox class="hover-button" onclick="event.stopPropagation();reksidebar.browse.showComments(\'search.mine\',$(this).parents(\'.search-listitem\').find(\'.browse-listitem-row.comments\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/{19}"/>',
            '</vbox>',
            '<description class="browse-sub-description comment small {6}" value="{7}" total="{25}"/>',
            '</hbox>',
            '</vbox>',
            '<hbox class="{15}">',
            //'<hbox class="separator"/>',
            '<vbox pack="start">',
            '<hbox class="hover-button" onclick="event.stopPropagation();reksidebar.browse.showTags(\'search.mine\',$(this).parents(\'.search-listitem\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/tag_orange12.png"/>',
            '</vbox>',
            '<description class="browse-sub-description comment small" value="{16}"/>',
            '</hbox>',
            '</vbox>',
            '</hbox>',
            '<vbox pack="start">',
            '<hbox class="hover-button" onclick="event.stopPropagation();reksidebar.browse.nodeClick(\'search.mine\',$(this).parents(\'.search-listitem\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/folder_page12.png"/>',
            '</vbox>',
            '<description class="browse-sub-description node small" nodeid="{11}" value="{5}" crop="end" />',
            '</hbox>',
            '</vbox>',
            '</hbox>',
            '</hbox>',
            '</vbox>',
            '<vbox pack="start">',
            '<hbox class="popup-hover-button" popup="popup-browse1" onclick="event.stopPropagation();">',
            '<vbox pack="center">',
            '<image src="chrome://rekommend/skin/images/browse_popup2.png"/>',
            '</vbox>',
            '</hbox>',
            '</vbox>',
            '</hbox>',
            '</row>',

            // edit row
            '<row class="browse-listitem-row edit">',
            '<vbox flex="1">',

            '<textbox class="browse-edit-title"/>',

            '<hbox class="browse-edit-folder" flex="1">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/folder_page12.png"/>',
            '</vbox>',
            '<menulist class="small" oncommand="" flex="1">',
            '<menupopup class="browse-edit-folderpopup"></menupopup>',
            '</menulist>',
            '</hbox>',

            '<vbox class="browse-edit-tags">',
            '<hbox class="browse-tags-list center"></hbox>',
            '<hbox>',
            '<vbox pack="center"><label class="" value="Add tag:"/></vbox>',
            '<textbox class="browse-edit-addtag" type="autocomplete" autocompletesearch="simple-autocomplete" showcommentcolumn="false" autocompletesearchparam=\'\' flex="1" ontextentered="reksidebar.browse.addTag($(this).parents(\'.browse-listitem-row.edit\'));"/>',
            '<vbox pack="center">',
            '<vbox class="rekbutton" tooltiptext="Add Tag" onclick="reksidebar.browse.addTag($(this).parents(\'.browse-listitem-row.edit\'));">',
            '<image class="collapse" src="chrome://rekommend/skin/images/tag_orange_add12.png"/>',
            '</vbox>',
            '</vbox>',
            '</hbox>',
            '</vbox>',

            '<hbox class="browse-edit-private"><checkbox class="browse-edit-private-checkbox small" label="Private"/></hbox>',

            '<hbox class="browse-edit-submit" pack="center">',
            '<hbox class="rekbutton" width="50" pack="center" onclick="reksidebar.browse.closeEdit(\'search.mine\',$(this).parents(\'.search-listitem\'),\'save\');"><description class="small" value="Save"/></hbox>',
            '<spacer width="5"/>',
            '<hbox class="rekbutton" width="50" pack="center" onclick="reksidebar.browse.closeEdit(\'search.mine\',$(this).parents(\'.search-listitem\'),\'cancel\');"><description class="small" value="Cancel"/></hbox>',
            '</hbox>',
            '</vbox>',
            '</row>',

            // comments row
            '<row class="browse-listitem-row comments {13}">',
            '<vbox flex="1">',
            '<vbox class="browse-comments-list">',
            '</vbox>',
            '<vbox class="browse-comments-submit">',
            '<textbox class="browse-comments-textbox" multiline="true" rows="2" height="36" value="" onfocus="reksidebar.Rek.skipPulse();" onblur="reksidebar.Rek.resumePulse();"/>',
            '<hbox pack="center"><button class="small" label="Add {20}" onclick="reksidebar.browse.addComment(\'search.mine\',$(this).parents(\'.search-listitem\'));"/></hbox>',
            '</vbox>',
            '</vbox>',
            '</row>',

            // tags row
            '<row class="browse-listitem-row tags {17}">',
            '<vbox flex="1">',
            '<hbox class="browse-tags-list center">',
            '{22}',
            '</hbox>',
            '</vbox>',
            '</row>',

            '</rows>',
            '</grid>',
            '</hbox>'
            ],
            all: [
            '<hbox class="search-listitem listitem{0}{7}" url="{2}" tiny="{6}">',
            '<grid flex="1">',
            '<columns><column flex="1"/></columns>',
            '<rows>',
            '<row class="browse-listitem-item">',
            '<hbox class="collapse">',
            '<spacer width="5"/>',
            '<vbox flex="1">',

            '<hbox class="collapse" flex="1">',
            '<description class="browse-title-static hidden" value="{1}"/>',
            '<hbox class="over-hidden" flex="1" crop="end" tooltiptext="{1}" onclick="reksidebar.Rek.openURLKey($(this).parents(\'.search-listitem\').attr(\'tiny\'));"><html:span class="browse-title-static-html over-ellipsis">{3}</html:span></hbox>',
            '</hbox>',
            '<spacer height="3"/>',

            '<hbox>',
            '<spacer width="10"/>',
            '<vbox pack="center"><image src="chrome://rekommend/skin/images/rek_12.png"/></vbox><description class="browse-sub-description from small" value=" x {4}"/><hbox class="separator"/>',
            '<vbox pack="center"><image src="chrome://rekommend/skin/images/bmark_12.png"/></vbox><description class="browse-sub-description from small" value=" x {5}"/>',
            '<hbox class="hidden">',
            '<hbox class="separator"/>',
            '<hbox class="hover-button" onclick="event.stopPropagation();reksidebar.browse.showComments(\'search.mine\',$(this).parents(\'.search-listitem\').find(\'.browse-listitem-row.comments\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src=""/>',
            '</vbox>',
            '<description class="browse-sub-description comment small" value=""/>',
            '</hbox>',
            '<hbox class="hidden">',
            '<hbox class="separator"/>',
            '<hbox class="hover-button" onclick="event.stopPropagation();reksidebar.browse.showTags(\'search.mine\',$(this).parents(\'.search-listitem\'));">',
            '<vbox pack="center">',
            '<image class="browse-sub-image" src="chrome://rekommend/skin/images/tag_orange12.png"/>',
            '</vbox>',
            '<description class="browse-sub-description comment small" value=""/>',
            '</hbox>',
            '</hbox>',
            '</hbox>',
            '</hbox>',
            '</vbox>',
            /*'<vbox pack="center">',
            '<hbox class="popup-hover-button" popup="popup-browse1" onclick="event.stopPropagation();">',
            '<vbox pack="center">',
            '<image src="chrome://rekommend/skin/images/browse_popup2.png"/>',
            '</vbox>',
            '</hbox>',
            '</vbox>',*/
            '</hbox>',
            '</row>',

            // comments row
            /*'<row class="browse-listitem-row comments hidden">',
            '<vbox flex="1">',
            '<vbox class="browse-comments-list">',
            '</vbox>',
            '<vbox class="browse-comments-submit">',
            '<textbox class="browse-comments-textbox" multiline="true" rows="2" height="36" value="" onfocus="reksidebar.Rek.skipPulse();" onblur="reksidebar.Rek.resumePulse();"/>',
            '<hbox pack="center"><button class="small" label="Add {20}" onclick="reksidebar.browse.addComment(\'search.mine\',$(this).parents(\'.search-listitem\'));"/></hbox>',
            '</vbox>',
            '</vbox>',
            '</row>',

            // tags row
            '<row class="browse-listitem-row tags hidden">',
            '<vbox flex="1">',
            '<hbox class="browse-tags-list center">',
            '{22}',
            '</hbox>',
            '</vbox>',
            '</row>',*/

            '</rows>',
            '</grid>',
            '</hbox>'
            ]
        },

        // member variables
        curView: '',
        lastSearch: '',
        result: [],
        crc: null,
        start: 0,
        total: 0,
        pageSize: 15,
        delay: null,
        
        inlineCommentStart: 0,

        init: function() {
            reksidebar.Rek.log('search init');

            if ($('#search-top-tabbox .tabbox-tab.active').attr('tab') == 0) this.curView = 'mine';
            else this.curView = 'all';
            
        },
        update: function(view,searchStr,pageAction) {
            var arr,exEl,exRecId;
            if (!view) view = this.curView;
            searchStr = $.trim(searchStr);
            reksidebar.Rek.log('search update '+view+' :'+$.trim(searchStr));
            if (searchStr) {
                if (true) {
                    this.lastSearch = searchStr;
                    // save last search in preference
                    //reksidebar.Rek.user.data.preferences['se_'+view.slice(0,2)] = searchStr;
                    //reksidebar.Rek.log(reksidebar.Rek.user.data.preferences);
                    // show loader
                    //$('#search-'+view+'-content stack > vbox').hide();
                    //$('#search-'+view+'-content stack > vbox:nth-child(1)').show();
                    // get the current selected recids (mine only)
                    $.each($('#search-mine-list .search-listitem checkbox.browse-checkbox:checked').parents('.browse-inbox-listitem'),function(i,v) {
                        arr.push(parseInt($(v).attr('recid')));
                    });

                   if (!pageAction) reksidebar.search.start = 0;
                    // ajax call
                    $.ajax({
                        type: 'POST',
                        async: true,
                        url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/fetch.php',
                        data: {
                            id: reksidebar.Rek.user.id,
                            session: reksidebar.Rek.user.session,
                            refresh: false, // no session validation
                            request: JSON.stringify([{
                                id:'search.'+view,
                                str: searchStr.toLowerCase(),
                                crc: reksidebar.search.crc,
                                limit: reksidebar.search.pageSize,
                                start: reksidebar.search.start
                            }])
                        },
                        dataType: 'json',
                        success: function(json){
                            reksidebar.Rek.log(json);
                            var str = '';
                            reksidebar.search.result = json.resultset[0];
                            reksidebar.search.total = reksidebar.search.result.rowcount;
                            if (json.result == 0) {
                                $.each(reksidebar.search.result.data,function(i,r){
                                    var name,title,typeStr;

                                    var j,checked='false';
                                    for (j in arr) {
                                        if (r.id == arr[j]) {
                                            checked='true';
                                            break;
                                        }
                                    }

                                    switch (view) {
                                        case 'mine':
                                            str += reksidebar.search.parseMine(i,r,checked);
                                            break;
                                        case 'all':
                                            str += reksidebar.search.parseAll(i,r,checked);
                                            break;
                                    }
                                });
                                // build DOM string if new one
                                //if (result.crc != reksidebar.search.crc) {
                                $('#search-'+view+'-list').empty();
                                //reksidebar.Rek.log(str);
                                reksidebar.Rek.appendDOMfromString($('#search-'+view+'-list'),str);
                                exEl = $('#search-mine-list .search-listitem .browse-listitem-row.expanded');
                                if (exEl.hasClass('comments')) reksidebar.browse.updateComments('search.mine',exEl,reksidebar.search.inlineCommentStart);
                                //}
                                // update crc
                                reksidebar.search.crc = reksidebar.search.result.crc;
                                // show
                                if (reksidebar.search.total > 0) {
                                    $('#search-'+view+'-content stack > vbox:not(:nth-child(3))').hide();
                                    $('#search-'+view+'-content stack > vbox:nth-child(3)').show();
                                }
                                else {
                                    $('#search-'+view+'-list').empty();
                                    $('#search-'+view+'-content stack > vbox:not(:nth-child(4))').hide();
                                    $('#search-'+view+'-content stack > vbox:nth-child(4)').show();
                                }
                            } else { // query failed
                                reksidebar.Rek.log('fetch search failed');
                            }
                            reksidebar.browse.updatePager('search.'+view);
                        },
                        error: function(req,status,error){
                            // check on system status
                            reksidebar.Rek.validateStatus(status);
                        }
                    });
                }
            } else {
                this.lastSearch = '';
                this.crc = null;
                $('#search-'+view+'-content stack > vbox:not(:nth-child(2))').hide();
                $('#search-'+view+'-content stack > vbox:nth-child(2)').show();
            }
        },
        parseMine: function(idx,rec,checked) {
            var str,str2 = '',typeStr,title,pattern,idx2;

            var exEl = $('.search-listitem .browse-listitem-row.expanded');
            var exRecId = $(exEl).parents('.search-listitem').attr('recid');

            // place tags
            $.each(rec.tags,function(i,name) {
                str2 += reksidebar.browse.templates.tag.join('').format(
                    reksidebar.Rek.xmlEncode(name),
                    (i==rec.tags.length-1?' last':''),
                    ' orig'
                    );
            });

            if (rec.nodeid==reksidebar.Rek.user.data.rek_top_node_id) rec.nodename = 'Inbox';
            else if (rec.nodeid==reksidebar.Rek.user.data.sent_node_id) rec.nodename = 'Sent';

            title = rec.alt_title?rec.alt_title:rec.title;
            pattern = new RegExp(this.lastSearch,'i');
            idx2 = title.search(pattern);

            switch (rec.type) {
                case 'rek':
                    //typeStr = '<description class="browse-sub-description from small" crop="end" value="From: '+rec.uid+'"/><hbox class="separator"/>';
                    typeStr = '<description class="browse-sub-description from small" flex="1">From: '+rec.uid+'</description>';
                    break;
                case 'bookmark':
                    //typeStr = '<vbox pack="center"><image src="chrome://rekommend/skin/images/bmark_12.png"/></vbox><hbox class="separator"/>';
                    typeStr = '<hbox flex="1"><vbox pack="center"><image src="chrome://rekommend/skin/images/bmark_12.png"/></vbox></hbox>';
                    break;
                case 'sent':
                    //typeStr = '<description class="browse-sub-description from small" crop="end" value="To: '+rec.sent+'"/><hbox class="separator"/>';
                    typeStr = '<description class="browse-sub-description from small" flex="1">To: '+rec.sent+'</description>';
                    break;
            }
            
            str = reksidebar.search.templates.mine.join('').format(
                idx%2?' odd':' even',
                rec.id,
                rec.date_read===null?'unread':'',
                idx2 == -1?reksidebar.Rek.htmlEncode(title):''.concat(reksidebar.Rek.htmlEncode(title.substring(0,idx2)),'<html:span class="search-highlight">',reksidebar.Rek.htmlEncode(title.substring(idx2,idx2+this.lastSearch.length)),'</html:span>',reksidebar.Rek.htmlEncode(title.substring(idx2+this.lastSearch.length))),
                //rec.alt_title?reksidebar.Rek.xmlEncode(rec.alt_title):reksidebar.Rek.xmlEncode(rec.title),
                typeStr,
                rec.nodeid==reksidebar.Rek.user.data.rek_top_node_id?(rec.type == 'bookmark'?'Ungrouped':'Inbox'):reksidebar.Rek.xmlEncode(rec.nodename),
                rec.newcom=='0'?'':'red bold',
                rec.newcom=='0'?(rec.com=='0'?'Add':rec.com):rec.newcom+' New',
                reksidebar.Rek.xmlEncode(rec.url),
                rec.com == '0'?'':'',
                checked,
                rec.nodeid,
                rec.type,
                (exEl.hasClass('comments') && rec.id == exRecId)?'expanded':'',
                rec.rekid,
                rec.tags.length == '0'?'hidden':'',
                rec.tags.length,
                (exEl.hasClass('tags') && rec.id == exRecId)?'expanded':'',
                rec.priv == '0'?' public':'',
                rec.type == 'bookmark'?'note12.png':'comments12.png',
                rec.type == 'bookmark'?'Note':'Comment',
                reksidebar.Rek.xmlEncode(rec.title),
                str2,
                rec.tiny,
                idx == 0?' first':'',
                rec.com
                );

            return str;
        },
        parseAll: function(idx,rec,checked) {
            var str,str2 = '',pattern,idx2;

            var exEl = $('.search-listitem .browse-listitem-row.expanded');
            var exRecId = $(exEl).parents('.search-listitem').attr('recid');

            pattern = new RegExp(this.lastSearch,'i');
            idx2 = rec.title.search(pattern);

            str = reksidebar.search.templates.all.join('').format(
                idx%2?' odd':' even',
                reksidebar.Rek.xmlEncode(rec.title),
                reksidebar.Rek.xmlEncode(rec.url),
                idx2 == -1?reksidebar.Rek.htmlEncode(rec.title):''.concat(reksidebar.Rek.htmlEncode(rec.title.substring(0,idx2)),'<html:span class="search-highlight">',reksidebar.Rek.htmlEncode(rec.title.substring(idx2,idx2+this.lastSearch.length)),'</html:span>',reksidebar.Rek.htmlEncode(rec.title.substring(idx2+this.lastSearch.length))),
                rec.rekcount,
                rec.bmarkcount,
                rec.tiny,
                idx == 0?' first':''
                );

            return str;
        },
        reload: function() {
            // function is called from reksidebar.browse
            // multiple calls can happen in a short period of time
            // wrap this in a delay to minimize ajax chatter
            reksidebar.Rek.log('search reload');
            var _do_update = function() {
                reksidebar.search.delay = null;
                //reksidebar.search.start = 0;
                reksidebar.search.update(reksidebar.search.curView,reksidebar.search.lastSearch,true);
            };
            if (this.delay) clearTimeout(this.delay);
            this.delay = setTimeout(_do_update,500);
        },
        tabclick: function(el) {
            var oldView = this.curView;
            switch ($(el).find('.tabbox-tab.active').attr('tab')) {
                case '0': // my account
                    this.curView = 'mine';
                    break;
                case '1': // all
                    this.curView = 'all';
                    break;
            }
            if (oldView != this.curView) {
                this.start = 0;
                this.update(this.curView,$('#search-search-textbox').val(),true);
            }
        }
    }
});
reksidebar.ns(function() {

    reksidebar.friend = {
        CONST: {
            CONTACT_STATUS_INVITED:0,
            CONTACT_STATUS_REJECTED:1,
            CONTACT_STATUS_ACCEPTED:2,
            CONTACT_STATUS_FRIEND:3
        },
        templates: {
            friends: ['<hbox class="reklistbox1 listitem{2}" recid="{1}"><checkbox/><vbox><description value="{0}" crop="end"/></vbox></hbox>'],
            invite:[
            '<description class="large bold" value="{0}"/>',
            '<description class="italic" value="{1}"/>',
            '<textbox id="textbox-friend-invite" multiline="true" rows="5" value="{2}"/>',
            '<hbox pack="end">',
            '<hbox class="rekbutton" onclick="reksidebar.friend.inviteImporter();">',
            '<vbox pack="center">',
            '<description value="Email Importer..."/>',
            '</vbox>',
            '</hbox>',
            '</hbox>'
            ],
            inbox:['<hbox class="reklistbox1 listitem" recid="{0}">',
            '<vbox><description value="{1}" crop="end"/></vbox>',
            '<spacer flex="1"/>',
            '<vbox><description class="invite-date small" value="{2}"/></vbox>',
            '<hbox class="rekbutton"><vbox pack="center"><image src="chrome://rekommend/skin/images/check12.png" tooltiptext="{3}" onclick="reksidebar.friend.acceptReject(\'accept\',{0});"/></vbox></hbox>',
            '<spacer width="3"/>',
            '<hbox class="rekbutton"><vbox pack="center"><image src="chrome://rekommend/skin/images/cancel12.png" tooltiptext="{4}" onclick="reksidebar.friend.acceptReject(\'reject\',{0});"/></vbox></hbox>',
            '</hbox>'],
            sent:['<hbox class="reklistbox1 listitem">',
            '<vbox><description value="{0}" crop="end"/></vbox>',
            '<spacer flex="1"/>',
            '<vbox><description class="invite-date small" value="{1}"/></vbox>',
            '<vbox><image class="invite-status-icon" src="chrome://rekommend/skin/images/{2}" tooltiptext="{3}"/></vbox>',
            '</hbox>'],
            plaxo:['<hbox class="reklistbox2 listitem" name="{0}" tooltiptext="{1}"><checkbox/><vbox flex="1"><description value="{0}&lt;{1}&gt;" crop="end"/></vbox></hbox>']
        },

        // member variables
        friendCrc: null,
        sentCrc:null,
        inboxCrc:null,
        socialCrc:null,

        // member functions
        init: function() {
            reksidebar.Rek.log('friend init');
            this.friendCrc = null;
            this.sentCrc = null;
            this.inboxCrc = null;
            this.socialCrc = null;
            //$('#broadcastFriendFriend').attr('crc','');
            //$('#broadcastFriendSent').attr('crc','');
            //$('#broadcastFriendInbox').attr('crc','');
            // init postto
            //$('.postto-facebook deck').attr('selectedIndex','0');
            $('.contact-postto-list .listitem').unbind();
            reksidebar.rekommend.bindListActions('.contact-postto-list');
            
            reksidebar.showTabboxTab('friend-invite-tabbox',0);
        },
        updateFriendList: function() {
            var friends = reksidebar.Rek.user.friend.friends;
            var name,str = '';
            $('#friend-friend-content stack > vbox:nth-child(1)').hide();
            if (friends.length == 0) {
                $('#friend-friend-content stack > vbox:nth-child(3)').hide();
                $('#friend-friend-content stack > vbox:nth-child(2)').show();
            } else {
                $('#friend-list').empty();
                $.each(friends,function(i,val){
                    //reksidebar.Rek.log(val);
                    if (val.st == reksidebar.friend.CONST.CONTACT_STATUS_ACCEPTED || val.st == reksidebar.friend.CONST.CONTACT_STATUS_FRIEND) {
                        name='&lt;undefined&gt;';
                        if (val.rn) name = val.rn
                        else if (val.nd) name = val.nd
                        else if (val.e1) name = val.e1
                        else if (val.m1) name = val.m1
                        else if (val.nf) name = val.nf+' '+val.nl
                        str += reksidebar.friend.templates.friends.join('').format(reksidebar.Rek.xmlEncode(name),val.id,' rekmember');
                    }
                });
                reksidebar.Rek.appendDOMfromString($('#friend-list'),str);
                $('#friend-list .listitem').click(function(e){
                    if ($(this).hasClass('selected')) {
                        $(this).children('checkbox').attr('checked','false');
                        $(this).removeClass('selected');
                    } else {
                        $(this).children('checkbox').attr('checked','true');
                        $(this).addClass('selected');
                    }
                });
                $('#friend-friend-content stack > vbox:nth-child(2)').hide();
                $('#friend-friend-content stack > vbox:nth-child(3)').show();
            }
        },
        onFriendListUpdate: function() {
            $('#broadcastFriendFriend').attr('crc',this.friendCrc);
        },
        updateInbox: function() {
            var inbox = reksidebar.Rek.user.friend.inbox;
            var str = '';
            if (inbox.length > 0) {
                $('#friend-inbox-tab-title').val(reksidebar.Rek.getProperty('inbox.label')+' ('+inbox.length+')');
                $('#app-friend-tab-value').val(inbox.length);
                $('#app-browse-friend-value-box').css('display','-moz-box');
            } else {
                $('#friend-inbox-tab-title').val(reksidebar.Rek.getProperty('inbox.label'));
                $('#app-browse-friend-value-box').css('display','none');
            }

            $('#friend-inbox-list').empty();
            $.each(inbox,function(i,val){
                str += reksidebar.friend.templates.inbox.join('').format(val.id,reksidebar.Rek.xmlEncode(val.rn),val.dt,reksidebar.Rek.getProperty('rek.accept'),reksidebar.Rek.getProperty('rek.reject'));
            });
            reksidebar.Rek.appendDOMfromString($('#friend-inbox-list'),str);
            //$('#friend-inbox-content stack > vbox:nth-child(2)').show();
        },
        onInboxListUpdate: function() {
            $('#broadcastFriendInbox').attr('crc',this.inboxCrc);
        },
        updateSentList: function() {
            var sent = reksidebar.Rek.user.friend.sent;
            var name,icon,tooltip,str = '';
            $('#friend-sent-list').empty();
            $.each(sent,function(i,val){
                name = '&lt;undefined&gt;';
                if (val.rn) name = val.rn
                else if (val.nd) name = val.nd
                else if (val.e1) name = val.e1
                else if (val.nf) name = val.nf+' '+val.nl;
                switch (parseInt(val.st)) {
                    case reksidebar.friend.CONST.CONTACT_STATUS_INVITED:
                        icon = 's.gif';
                        tooltip = '';
                        break;
                    case reksidebar.friend.CONST.CONTACT_STATUS_ACCEPTED:
                        icon = 'user_accept_16.png';
                        tooltip = 'Accepted';
                        break;
                    case reksidebar.friend.CONST.CONTACT_STATUS_REJECTED:
                        icon = 'user_reject_16.png';
                        tooltip = 'Rejected';
                        break;
                }
                str += reksidebar.friend.templates.sent.join('').format(reksidebar.Rek.xmlEncode(name),val.dt,icon,tooltip);
            });
            reksidebar.Rek.appendDOMfromString($('#friend-sent-list'),str);
            //$('#friend-sent-content stack > vbox:nth-child(2)').show();
        },
        onSentListUpdate: function() {
            $('#broadcastFriendSent').attr('crc',this.sentCrc);
        },
        onSocialListUpdate: function() {
            $('#broadcastFriendSocial').attr('crc',this.socialCrc);
        },
        updateSocialList: function() {
            reksidebar.Rek.log('friend: updateSocialList');
            var fb,tw,counter,
            _fbwait = function(w) {
                counter++;
                if (!w.closed && counter < 240) {
                    setTimeout(function(){_fbwait(w);},500);
                    if (w.document.readyState == 'complete') {
                        //reksidebar.Rek.log('complete');
                    }
                } else {
                    $('.postto-facebook.listitem stack > hbox:nth-child(3)').css('display','none');
                    reksidebar.Rek.db.fetch(false,[{
                        id:'friend.social',
                        crc: reksidebar.friend.socialCrc
                    }]);
                }
            },
            _twwait = function(w) {
                counter++;
                if (!w.closed && counter < 240) setTimeout(function(){_twwait(w);},500);
                else {
                    $('.postto-twitter.listitem stack > hbox:nth-child(3)').css('display','none');
                    reksidebar.Rek.db.fetch(false,[{
                        id:'friend.social',
                        crc: reksidebar.friend.socialCrc
                    }]);
                }
            };
            // facebook
            fb = reksidebar.Rek.user.friend.social.facebook;
            //reksidebar.Rek.log(fb);
            if (fb.fb) {
                // have a valid session
                $('.postto-facebook-logout').unbind('click');
                $('.postto-facebook-logout').click(function(e){
                    $('.postto-facebook.listitem stack > hbox:nth-child(3)').css('display','-moz-box');
                    e.stopPropagation();
                    /*$.ajax({
                        async: true,
                        url: fb.fbURL,
                        dataType: 'text',
                        success: function(text){
                            reksidebar.Rek.log(text);
                            $('.postto-facebook.listitem stack > hbox:nth-child(3)').css('display','none');
                            reksidebar.Rek.db.fetch(false,[{
                                id:'friend.social',
                                crc: reksidebar.friend.socialCrc
                            }]);
                        },
                        error: function(req,status,error){
                            $('.postto-facebook.listitem stack > hbox:nth-child(3)').css('display','none');
                        }
                    });*/
                    w = window.open(fb.fbURL,'facebook logout','width=100,height=100,top=10000,left=0,chrome=yes,alwaysLowered=yes,titlebar=no,scrollbars=no,menubar=no,toolbar=no,location=no,personalbar=no,resizable=no,status=no');
                    counter = 0;
                    _fbwait(w);
                });
                $('.postto-facebook checkbox').attr('disabled','false').blur();
                $('.postto-facebook.listitem stack > hbox:nth-child(1)').css('display','none');
                $('.postto-facebook.listitem stack > hbox:nth-child(2)').css('display','-moz-box');
                //$('.postto-facebook.listitem stack > hbox:nth-child(3)').css('display','none');
                if (!reksidebar.Rek.user.data.session['fbnotify'] && !reksidebar.Rek.user.data.preferences['skip_fbnotify'] && reksidebar.Rek.user.loginby == 'rek') {
                    /*reksidebar.modal.open({
                        title:'Link to Facebook?',
                        icon:'information.png',
                        text:'We noticed that you have an active Facebook session. If you want to link your reKommend account to your Facebook account, you can do so in the Account tab of the sidebar.',
                        skip:'skip_fbnotify',
                        buttons:[{
                            label:'Show me',
                            callback: function() {
                                reksidebar.modal.close(this);
                                reksidebar.showAppTab(reksidebar.Rek.CONST.SIDEBARTAB_ACCOUNT);
                            }
                        },{
                            label:'Close',
                            callback: function(){
                                reksidebar.modal.close(this);
                            }
                        }]
                    });*/
                    reksidebar.Rek.user.data.session['fbnotify'] = true;
                }
            } else {
                // don't have a valid session
                $('.postto-facebook-login').unbind('click');
                $('.postto-facebook-login').click(function(e){
                    var w,t=null;
                    $('.postto-facebook.listitem stack > hbox:nth-child(3)').css('display','-moz-box');
                    e.stopPropagation();
                    w = window.open(fb.fbURL,'facebook logout','width=650,height=400,chrome=yes,centerscreen,alwaysRaised=yes,scrollbars=no,menubar=no,toolbar=no,location=no,personalbar=no,resizable=no,status=no');
                    //reksidebar.Rek.log(w.document);
                    counter = 0;
                    _fbwait(w);
                    /*w.addEventListener('unload',function(){
                        if (t) clearTimeout(t);
                        t = setTimeout(function(){
                            reksidebar.Rek.log('on unload fetch');
                            reksidebar.Rek.db.fetch(false,[{
                                id:'friend.social',
                                crc: reksidebar.friend.socialCrc
                            }],function(result){
                                if (w.document === null) $('.postto-facebook.listitem stack > hbox:nth-child(3)').css('display','none');
                                if (result.resultset[0].status == 0) {
                                    //reksidebar.Rek.log(result.resultset[0].data.facebook.fb);
                                    if (!result.resultset[0].data.facebook.fb === null) {
                                        $('.postto-facebook checkbox').attr('disabled','false').blur();
                                        $('.postto-facebook.listitem stack > hbox:nth-child(1)').css('display','none');
                                        $('.postto-facebook.listitem stack > hbox:nth-child(2)').css('display','-moz-box');
                                    }
                                }
                            });
                            t = null;
                        },1000);
                    },false);*/
                });
                $('.postto-facebook checkbox').removeAttr('checked');
                $('.postto-facebook').removeClass('selected');
                $('.postto-facebook checkbox').attr('disabled','true').blur();
                $('.postto-facebook.listitem stack > hbox:nth-child(1)').css('display','-moz-box');
                $('.postto-facebook.listitem stack > hbox:nth-child(2)').css('display','none');
                //$('.postto-facebook.listitem stack > hbox:nth-child(3)').css('display','none');
            }
            
            // twitter
            tw = reksidebar.Rek.user.friend.social.twitter;
            //reksidebar.Rek.log(tw);
            if (tw.tw) {
                // have a valid session
                /*$('.postto-twitter-logout').unbind('click');
                $('.postto-twitter-logout').click(function(e){
                    $('.postto-twitter.listitem stack > hbox:nth-child(3)').css('display','-moz-box');
                    e.stopPropagation();
                    $.ajax({
                        async: true,
                        url: tw.twURL,
                        dataType: 'text',
                        success: function(text){
                            $('.postto-facebook.listitem stack > hbox:nth-child(3)').css('display','none');
                            reksidebar.Rek.db.fetch(false,[{
                                id:'friend.social',
                                crc: reksidebar.friend.socialCrc
                            }]);
                        },
                        error: function(req,status,error){
                            $('.postto-facebook.listitem stack > hbox:nth-child(3)').css('display','none');
                        }
                    });
                });*/
                $('.postto-twitter checkbox').attr('disabled','false').blur();
                $('.postto-twitter.listitem stack > hbox:nth-child(1)').css('display','none');
                $('.postto-twitter.listitem stack > hbox:nth-child(2)').css('display','-moz-box');
                //$('.postto-facebook.listitem stack > hbox:nth-child(3)').css('display','none');
            } else {
                // don't have a valid session
                $('.postto-twitter-login').unbind('click');
                $('.postto-twitter-login').click(function(e){
                    var w,t=null;
                    $('.postto-twitter.listitem stack > hbox:nth-child(3)').css('display','-moz-box');
                    e.stopPropagation();
                    w = window.open(tw.twURL,'twitter login','width=650,height=500,chrome=yes,centerscreen,scrollbars=no,menubar=no,toolbar=no,location=no,personalbar=no,resizable=no,status=no,alwaysRaised=yes');
                    counter = 0;
                    _twwait(w);
                });
                $('.postto-twitter checkbox').removeAttr('checked');
                $('.postto-twitter').removeClass('selected');
                $('.postto-twitter checkbox').attr('disabled','true').blur();
                $('.postto-twitter.listitem stack > hbox:nth-child(1)').css('display','-moz-box');
                $('.postto-twitter.listitem stack > hbox:nth-child(2)').css('display','none');
                //$('.postto-facebook.listitem stack > hbox:nth-child(3)').css('display','none');
            }
        },
        inviteFriend: function(list) {
            var self = this;
            liststr = '';
            if (list && list.length) {
                arr = [];
                $.each(list,function(i,v){
                    arr.push(v.email);
                });
                liststr = arr.join(',');
                $el = $('#textbox-friend-invite');
                old = $el.val();
                if (old.length && old.substr(-1,1) != ',') liststr = old+','+liststr;
                else liststr = old+liststr;
            }
            reksidebar.modal.open({
                id:'dialog2',
                template:'insert',
                title:reksidebar.Rek.getProperty('rek.friendInviteTitle'),
                text:[this.templates.invite.join('').format(reksidebar.Rek.getProperty('rek.friendInviteText1'),reksidebar.Rek.getProperty('rek.friendInviteText2'),liststr)],
                buttons:[/*{
                        label:'Import Contacts...',
                        callback: function(){
                            reksidebar.friend.importContacts(null, null, null, function(list){
                                if (list.length > 100) {
                                    reksidebar.modal.open({
                                        title: 'Import Limit Exceeded',
                                        icon: 'exclamation.png',
                                        text: 'You are trying to import more than 100 emails to your list. We limit the number of emails in this list in order to prevent spammers from using our extension.',
                                        buttons:[
                                        {
                                            label:'OK',
                                            callback: function(){
                                                reksidebar.modal.close(this);
                                            }
                                        }]
                                    });
                                } else {
                                    self.inviteFriend(list);
                                }
                            });
                        }
                    },*/{
                    label:'Invite',
                    callback: function() {
                        var str = $('#textbox-friend-invite').val();
                        var arr1 = [],arr2 = [];
                        if (str.length) {
                            arr1 = str.split(',');
                            $.each(arr1,function(i,val){
                                arr2.push({
                                    type:'',
                                    name:'',
                                    ref:$.trim(val)
                                });
                            });
                            reksidebar.Rek.log('invite friend');
                            $.ajax({
                                type: 'POST',
                                async: true,
                                url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/inviteFriends.php',
                                data: {
                                    id:reksidebar.Rek.user.id,
                                    session:reksidebar.Rek.user.session,
                                    arr:JSON.stringify(arr2)
                                },
                                dataType: 'json',
                                success: function(json){
                                    reksidebar.Rek.log(json);
                                    //json = JSON.parse(json);
                                    //reksidebar.friend.fetchSentList();
                                    reksidebar.Rek.db.fetch(false,[{
                                        id:'friend.friend',
                                        crc: reksidebar.friend.friendCrc
                                    },{
                                        id:'friend.sent',
                                        crc: reksidebar.friend.sentCrc
                                    }]);

                                    reksidebar.modal.open({
                                        title:'Invites Sent',
                                        icon:'information.png',
                                        text:'Your invites were successfully delivered.',
                                        buttons:[{
                                            label:'OK',
                                            callback: function(){
                                                reksidebar.modal.close(this);
                                            }
                                        }]
                                    });

                                    reksidebar.showTabboxTab('friend-invite-tabbox',1);
                                },
                                error: function(req,status,error){
                                    // check on system status
                                    reksidebar.Rek.validateStatus(status);
                                }
                            });
                        }
                        reksidebar.modal.close(this);
                    }
                },{
                    label:'Cancel',
                    callback: function(){
                        reksidebar.modal.close(this);
                    }
                }]
            });
        },
        inviteImporter: function() {
            var self = this;
            reksidebar.friend.importContacts(null, null, null, function(list){
                if (list.length > 100) {
                    reksidebar.modal.open({
                        title: 'Import Limit Exceeded',
                        icon: 'exclamation.png',
                        text: 'You are trying to import more than 100 emails to your list. We limit the number of emails in this list in order to prevent spammers from using our extension.',
                        buttons:[
                        {
                            label:'OK',
                            callback: function(){
                                reksidebar.modal.close(this);
                            }
                        }]
                    });
                } else {
                    self.inviteFriend(list);
                }
            });
        },
        acceptReject:function(action,id) {
            var arr = [];
            if (id == -1) {
                // accept/reject all chosen
                $('#friend-inbox-content .listitem').each(function(i,val){
                    arr.push($(val).attr('recid'));
                });
            } else {
                // one id
                arr.push(id);
            }
            if (arr.length) {
                reksidebar.Rek.log('friend accept/reject');
                $.ajax({
                    type: 'POST',
                    async: true,
                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/acceptReject.php',
                    data: {
                        id:reksidebar.Rek.user.id,
                        session:reksidebar.Rek.user.session,
                        action:action,
                        arr:JSON.stringify(arr)
                    },
                    dataType: 'json',
                    success: function(json){
                        reksidebar.Rek.log(json);
                        //json = JSON.parse(text);
                        var arr = [{
                            id:'friend.inbox',
                            crc: reksidebar.friend.inboxCrc
                        }];
                        if (action == 'accept') arr.push({
                            id:'friend.friend',
                            crc: reksidebar.friend.friendCrc
                        });
                        reksidebar.Rek.db.fetch(false,arr);
                    },
                    error: function(req,status,error){
                        // check on system status
                        reksidebar.Rek.validateStatus(status);
                    }
                });
            }
        },
        importContacts: function(uid,domain,pass,cb) {
            var self = this,
            arr = [],
            _contactLogin = function() {
                reksidebar.modal.open({
                    id:'contact-login-dialog',
                    title:'Import Login',
                    text:'',
                    buttons:[{
                        label:'Import',
                        callback: function() {
                            uid = $('#contact-login-userid').val();
                            domain = $('#contact-login-domain').val();
                            pass = $('#contact-login-password').val();
                            reksidebar.Rek.log(uid);
                            reksidebar.Rek.log(domain);
                            reksidebar.Rek.log(pass);
                            if (uid && domain && pass) {
                                reksidebar.modal.close(this);
                                self.importContacts(uid,domain,pass,cb);
                            }
                        }
                    },{
                        label:'Cancel',
                        callback: function(){
                            reksidebar.modal.close(this);
                            if (typeof cb == 'function') cb([]);
                        }
                    }]
                });
            };
            if (uid && domain && pass) {
                $('#plaxo-list-dialog deck').attr('selectedIndex','0');
                reksidebar.modal.open({
                    id:'plaxo-list-dialog',
                    title:'Your Contacts',
                    text:'',
                    buttons:[{
                        label:'Import',
                        callback: function() {
                            $('#plaxo-list-items .listitem.selected').each(function(i,v){
                                arr.push({
                                    name:$(v).attr('name'),
                                    email:$(v).attr('tooltiptext')
                                });
                            });
                            reksidebar.modal.close(this);
                            if (typeof cb == 'function') cb(arr);
                        }
                    },{
                        label:'Cancel',
                        callback: function(){
                            reksidebar.modal.close(this);
                            if (typeof cb == 'function') cb([]);
                        }
                    }]
                });
                // get the contact list
                $.ajax({
                    type: 'POST',
                    async: true,
                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/importContacts.php',
                    data: {
                        uid: uid,
                        domain:domain,
                        pass:pass
                    },
                    dataType: 'json',
                    success: function(json){
                        reksidebar.Rek.log(json);
                        if (json.result == 0) {
                            if (json.contacts.length) {
                                $('#plaxo-list-items').empty();
                                str = '';
                                $.each(json.contacts,function(i,v){
                                    str += self.templates.plaxo.join('').format(v.name?reksidebar.Rek.xmlEncode(v.name)+' ':'',reksidebar.Rek.xmlEncode(v.email));
                                });
                                reksidebar.Rek.appendDOMfromString($('#plaxo-list-items'),str);
                                // bind click
                                $('#plaxo-list-items .listitem').click(function(e){
                                    if ($(this).hasClass('selected')) {
                                        $(this).children('checkbox').attr('checked','false');
                                        $(this).removeClass('selected');
                                    } else {
                                        $(this).children('checkbox').attr('checked','true');
                                        $(this).addClass('selected');
                                    }
                                });
                                $('#plaxo-list-dialog deck').attr('selectedIndex','4');
                            } else {
                                $('#plaxo-list-dialog deck').attr('selectedIndex','3');
                            }
                        } else {
                            $('#plaxo-list-dialog deck').attr('selectedIndex','2');
                        }
                    },
                    error: function(req,status,error){
                        $('#plaxo-list-dialog deck').attr('selectedIndex','1');
                        // check on system status
                        reksidebar.Rek.validateStatus(status);
                    }
                });
            } else {
                _contactLogin();
            }
        },
        importPlaxo: function(uid,pass,cb) {
            var self = this;
            var _plaxoLogin = function() {
                // display plaxo login dialog
                reksidebar.modal.open({
                    id:'plaxo-login-dialog',
                    title:'Plaxo Login',
                    text:'',
                    buttons:[{
                        label:'Login',
                        callback: function() {
                            uid = $('#plaxo-login-userid').val();
                            pass = $('#plaxo-login-password').val();
                            if (uid && pass) {
                                reksidebar.modal.close(this);
                                self.importPlaxo(uid,pass,cb);
                            }
                        }
                    },{
                        label:'Cancel',
                        callback: function(){
                            reksidebar.modal.close(this);
                            if (typeof cb == 'function') cb([]);
                        }
                    }]
                });
            };
            if (uid && pass) {
                arr = [];
                // try and fetch a list of contacts
                $('#plaxo-list-dialog deck').attr('selectedIndex','0');
                reksidebar.modal.open({
                    id:'plaxo-list-dialog',
                    title:'Plaxo Contacts',
                    text:'',
                    buttons:[{
                        label:'Import',
                        callback: function() {
                            $('#plaxo-list-items .listitem.selected').each(function(i,v){
                                arr.push({
                                    name:$(v).attr('name'),
                                    email:$(v).attr('tooltiptext')
                                });
                            });
                            reksidebar.modal.close(this);
                            if (typeof cb == 'function') cb(arr);
                        }
                    },{
                        label:'Cancel',
                        callback: function(){
                            reksidebar.modal.close(this);
                            if (typeof cb == 'function') cb([]);
                        }
                    }]
                });
                // get the contact list
                $.ajax({
                    type: 'POST',
                    async: true,
                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/importPlaxo.php',
                    data: {
                        email:uid,
                        pass:pass
                    },
                    dataType: 'json',
                    success: function(json){
                        reksidebar.Rek.log(json);
                        if (json.result == 0) {
                            if (json.contacts.length) {
                                $('#plaxo-list-items').empty();
                                str = '';
                                $.each(json.contacts,function(i,v){
                                    str += self.templates.plaxo.join('').format(reksidebar.Rek.xmlEncode(v.name),reksidebar.Rek.xmlEncode(v.email));
                                });
                                reksidebar.Rek.appendDOMfromString($('#plaxo-list-items'),str);
                                // bind click
                                $('#plaxo-list-items .listitem').click(function(e){
                                    if ($(this).hasClass('selected')) {
                                        $(this).children('checkbox').attr('checked','false');
                                        $(this).removeClass('selected');
                                    } else {
                                        $(this).children('checkbox').attr('checked','true');
                                        $(this).addClass('selected');
                                    }
                                });
                                $('#plaxo-list-dialog deck').attr('selectedIndex','4');
                            } else {
                                $('#plaxo-list-dialog deck').attr('selectedIndex','3');
                            }
                        } else {
                            $('#plaxo-list-dialog deck').attr('selectedIndex','2');
                        }
                    },
                    error: function(req,status,error){
                        $('#plaxo-list-dialog deck').attr('selectedIndex','1');
                        // check on system status
                        reksidebar.Rek.validateStatus(status);
                    }
                });
            } else {
                // try and get the login and password from preferences
                
                // get plaxo credentials
                _plaxoLogin();
            }
        },
        removeSelected: function() {
            var sel = $('#friend-list .listitem.selected');
            var arr = [];
            if (sel.length > 0) {
                $.each(sel,function(i,val){
                    arr.push($(val).attr('recid'));
                });
                reksidebar.modal.open({
                    title:reksidebar.Rek.getProperty('rek.friendRemoveTitle'),
                    icon:'exclamation.png',
                    text:reksidebar.Rek.getProperty('rek.friendRemoveText'),
                    skip:'fr_rm',
                    buttons:[{
                        label:'Remove',
                        callback: function() {
                            reksidebar.modal.close(this);
                            $.ajax({
                                type: 'POST',
                                async: true,
                                url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/removeContact.php',
                                data: {
                                    id:reksidebar.Rek.user.id,
                                    session:reksidebar.Rek.user.session,
                                    arr:JSON.stringify(arr)
                                },
                                dataType: 'json',
                                success: function(json){
                                    //reksidebar.Rek.log(json);
                                    reksidebar.Rek.db.fetch(false,[{
                                        id:'friend.friend',
                                        crc: reksidebar.friend.friendCrc
                                    }]);
                                },
                                error: function(req,status,error){
                                    // check on system status
                                    reksidebar.Rek.validateStatus(status);
                                }
                            });
                        }
                    },{
                        label:'Cancel',
                        callback: function(){
                            reksidebar.modal.close(this);
                        }
                    }]
                });
            }
        }
    }
});
reksidebar.ns(function() {

    reksidebar.account = {
        CONST: {
        },
        templates: {
        },

        // member variables
        valid: {
            userid: true,
            email: true,
            password: false
        },

        // member functions
        init: function() {
            reksidebar.Rek.log('account init');
            reksidebar.Rek.log(reksidebar.Rek.user);

            // set account values
            var u = reksidebar.Rek.user.data,arr;
            $('.app-account-userid').val(u.userid);
            $('.app-account-email').val(u.email_pri);
            $('#app-account-country')[0].selectedItem = $("#app-account-country menuitem[value='"+u.country_id+"']")[0];
            $('#app-account-zip').val(u.zip);
            /*$('#account-gender')[0].selectedIndex = u.gender=='male'?0:1;
            arr = u.dob.split('-');
            $('#account-dob-mm').val(arr[1]);
            $('#account-dob-dd').val(arr[2]);
            $('#account-dob-yyyy').val(arr[0]);*/
            //$('#account-fblink').attr('label',reksidebar.Rek.user.loginby == 'rek'?'Establish link':'Unlink');
            
            reksidebar.showTabboxTab('app-account',0);
            if (reksidebar.Rek.user.loginby == 'rek') {
                //$('#account-fblink').attr('label','Establish link');
                //$('#app-account [tab="0"]').removeClass('hidden');
                //$('#app-account-profile').removeClass('novis');
                $('#app-account-profile-deck').attr('selectedIndex','0');
                $('#app-account [tab="1"]').removeClass('hidden');
                $('#app-account-password').removeClass('novis');
            } else {
                //$('#account-fblink').attr('label','Unlink');
                //$('#app-account [tab="0"]').addClass('hidden');
                //$('#app-account-profile').addClass('novis');
                $('#app-account-profile-deck').attr('selectedIndex','1');
                $('#app-account [tab="1"]').addClass('hidden');
                $('#app-account-password').addClass('novis');
            }
        },

        validateUserID: function(el) {
            reksidebar.account.valid.userid = false;
            var _doUpdate = function() {
                if (el.value.length >= 6) {
                    $.ajax({
                        type: 'POST',
                        async: true,
                        url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/validateUserKey.php',
                        data: {
                            key:'userid',
                            value: el.value
                        },
                        dataType: 'json',
                        success: function(json){
                            reksidebar.Rek.log(json);
                            if (json.result == 0 || el.value == reksidebar.Rek.user.data.userid) {
                                $('#account-userid-status').attr('src','chrome://rekommend/skin/images/check.png');
                                reksidebar.account.valid.userid = true;
                            } else {
                                $('#account-userid-status').attr('src','chrome://rekommend/skin/images/cancel16.png');
                                reksidebar.account.valid.userid = false;
                            }
                            reksidebar.account.validateProfile();
                        },
                        error: function(req,status,error){
                            // check on system status
                            reksidebar.Rek.validateStatus(error);
                        }
                    });
                } else {
                    $('#account-userid-status').attr('src','chrome://rekommend/skin/images/cancel16.png');
                    reksidebar.account.valid.userid = false;
                    reksidebar.account.validateProfile();
                }
            }
            if (el.delay) clearTimeout(el.delay);
            if (el.value.length == 0) {
                $('#account-userid-status').attr('src','s.gif');
                this.valid.userid = false;
            } else
                el.delay = setTimeout(_doUpdate,1500);
            this.validateProfile();
        },

        validateEmail: function(el) {
            reksidebar.account.valid.email = false;
            var _doUpdate = function() {
                if (reksidebar.Rek.isEmail(el.value)){
                    // email is a valid one...check it it already exists
                    $.ajax({
                        type: 'POST',
                        async: true,
                        url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/validateUserKey.php',
                        data: {
                            key: 'email_pri',
                            value: el.value
                        },
                        dataType: 'json',
                        success: function(json){
                            //reksidebar.Rek.log(text);
                            //json = JSON.parse(text);
                            if (json.result == 0) {
                                $('#account-email-status').attr('src','chrome://rekommend/skin/images/check.png');
                                reksidebar.account.valid.email = true;
                            } else {
                                $('#account-email-status').attr('src','chrome://rekommend/skin/images/cancel16.png');
                                reksidebar.account.valid.email = false;
                            }
                            reksidebar.account.validateProfile();
                        },
                        error: function(req,status,error){
                            // check on system status
                            reksidebar.Rek.validateStatus(error);
                        }
                    });
                }
                else {
                    $('#account-email-status').attr('src','chrome://rekommend/skin/images/cancel16.png');
                    reksidebar.account.valid.email = false;
                    reksidebar.account.validateProfile();
                }
                
            }
            if (el.delay) clearTimeout(el.delay);
            if (el.value.length == 0) {
                $('#account-email-status').attr('src','chrome://rekommend/skin/images/s.gif');
                this.valid.email = false;
            }
            else
                el.delay = setTimeout(_doUpdate,1500);
            this.validateProfile();
        },

        validatePassword: function() {
            var el=$('#app-account-pass1');
            var pass1 = $(el).val();
            var el2=$('#app-account-pass2');
            var pass2 = $(el2).val();
            var _doUpdate = function() {
                var exp = /^.*(?=.{6,})(?=.*\d).*$/;
                if (pass1 == pass2) {
                    if (exp.test(pass1)) {
                        $('.account-pass-status').attr('src','chrome://rekommend/skin/images/check.png');
                        reksidebar.account.valid.password = true;
                    } else {
                        $('.account-pass-status').attr('src','chrome://rekommend/skin/images/cancel16.png');
                        reksidebar.account.valid.password = false;
                    }
                } else {
                    //passwords do not match
                    $('.account-pass-status').attr('src','chrome://rekommend/skin/images/cancel16.png');
                    reksidebar.account.valid.password = false;
                }
                reksidebar.account.validatePassPage();
            }
            if (el[0].delay) clearTimeout(el[0].delay);
            if (pass1.length == 0 || pass2.length == 0) {
                $('.account-pass-status').attr('src','s.gif');
                this.valid.password = false;
            } else
                el[0].delay = setTimeout(_doUpdate,1500);
            this.validatePassPage();
        },

        validateProfile: function() {
            var el;
            var valid = true;
            
            if (!this.valid.userid) valid = false;
            else if (!this.valid.email) valid = false;
            // check dob as valid
            else {
                if (!$('#app-account-zip').val()) valid = false;
            /*var m,d,y;
                m = $('#account-dob-mm').val();
                d = $('#account-dob-dd').val();
                y = $('#account-dob-yyyy').val();
                if (m < 1 || m > 12 || d < 1 || d >31) valid = false
                else {
                    var date = new Date(m+'/'+d+'/'+y);
                    if (isNaN(date)) valid = false;
                }*/
            }
            el = $('#account-profile-submit button')[0];
            if (valid) {
                $(el).removeAttr('disabled');
            } else {
                if (!el.disabled) el.setAttribute('disabled','true');
            }
        },

        updateProfile: function() {
            //var dob = new Date($('#account-dob-mm').val()+'/'+$('#account-dob-dd').val()+'/'+$('#account-dob-yyyy').val());
            $('#account-profile-submit').attr('selectedIndex','1');
            reksidebar.Rek.db.updateRecord('user',reksidebar.Rek.user.data.id,{
                //userid:$('.app-account-userid').val(),
                email_pri:$('.app-account-email').val(),
                country_id:$('#app-account-country')[0].selectedItem.value,
                zip:$('#app-account-zip').val()
            //gender:$('#account-gender')[0].selectedItem.value,
            //dob:dob.getFullYear()+'-'+(dob.getMonth()+1)+'-'+dob.getDate()
            },function(){
                $('#app-account-profile .status-icon').attr('src','check12.png');
                $('#account-profile-submit').attr('selectedIndex','2');
                setTimeout(function(){
                    $('#account-profile-submit button').attr('disabled','true');
                    $('#account-profile-submit').attr('selectedIndex','0');
                },3000)
            });
        },

        validatePassPage: function() {
            var el = $('#account-pass-submit button')[0];
            if (this.valid.password && $('#app-account-passold').val().length >= 6) {
                $(el).removeAttr('disabled');
            } else {
                $(el).attr('disabled','true');
            }
        },

        updatePass: function() {
            reksidebar.Rek.log(reksidebar.Rek.user);
            
            $('#account-pass-submit').attr('selectedIndex','1');
            $.ajax({
                type: 'POST',
                async: true,
                url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/updatePassword.php',
                data: {
                    id:reksidebar.Rek.user.id,
                    session:reksidebar.Rek.user.session,
                    oldpass:$('#app-account-passold').val(),
                    newpass:$('#app-account-pass1').val()
                },
                dataType: 'json',
                success: function(json){
                    reksidebar.Rek.log(json);
                    if (json.result == 0) {
                        $('#account-pass-image').attr('src','chrome://rekommend/skin/images/check.png');
                        $('#account-pass-result').val('Password Updated');
                        $('#app-account-passold').val('');
                        $('#app-account-pass1').val('');
                        $('#app-account-pass2').val('');
                        $('.account-pass-status').attr('src','s.gif');
                        $('#account-pass-submit').attr('selectedIndex','2');
                        setTimeout(function(){
                            $('#account-pass-submit').attr('selectedIndex','0');
                        },2000);
                    } else {
                        $('#account-pass-image').attr('src','chrome://rekommend/skin/images/cancel16.png');
                        $('#account-pass-result').val('Current password incorrect');
                        $('#account-pass-submit').attr('selectedIndex','2');
                        setTimeout(function(){
                            $('#account-pass-submit').attr('selectedIndex','0');
                        },2000);
                    }
                },
                error: function(req,status,error){
                    $('.account-pass-status').attr('src','s.gif');
                    $('#account-pass-submit').attr('selectedIndex','0');
                    // check on system status
                    reksidebar.Rek.validateStatus(error);
                }
            });
            
        /*if (reksidebar.Rek.user.data.password == $('#app-account-passold').val()) {
                $('#account-pass-submit').attr('selectedIndex','1');
                reksidebar.Rek.db.updateRecord('user',reksidebar.Rek.user.data.id,{
                    password:$('#app-account-pass1').val()
                },function(){
                    reksidebar.Rek.user.data.password = $('#app-account-pass1').val();
                    $('#account-pass-image').attr('src','chrome://rekommend/skin/images/check.png');
                    $('#account-pass-result').val('Password Updated');
                    $('#app-account-passold').val('');
                    $('#app-account-pass1').val('');
                    $('#app-account-pass2').val('');
                    $('.account-pass-status').attr('src','s.gif');
                    $('#account-pass-submit').attr('selectedIndex','2');
                    setTimeout(function(){
                        $('#account-pass-submit').attr('selectedIndex','0');
                    },2000)
                });
            } else {
                $('#account-pass-image').attr('src','chrome://rekommend/skin/images/cancel16.png');
                $('#account-pass-result').val('Current password incorrect');
                $('#account-pass-submit').attr('selectedIndex','2');
                setTimeout(function(){
                    $('#account-pass-submit').attr('selectedIndex','0');
                },2000)
            }*/
        },

        browserSelect: function() {
            var v = $('#account-browser').val(),
            str,
            idx;
            switch (v) {
                case 'mozilla':
                    str = 'Firefox Bookmarks';
                    idx = 0;
                    break;
                case 'ie':
                    str = 'IE Bookmarks';
                    idx = 1;
                    break;
                case 'chrome':
                    str = 'Chrome Bookmarks';
                    idx = 1;
                    break;
                case 'safari':
                    str = 'Safari Bookmarks';
                    idx = 1;
                    break;
                case 'delicious':
                    str = 'delicious Bookmarks';
                    idx = 1;
                    break;
            }
            $('#account-folder').attr('checked','false');
            $('#import-foldername').val(str);
            $('#import-foldername').attr('disabled','true');
            $('#account-import').attr('selectedIndex',idx.toString());
        },

        toggleFolder: function() {
            var $el;
            if ($('#account-folder').attr('checked') == 'true') {
                $el = $('#import-foldername');
                $el.removeAttr('disabled').focus();
                $el[0].setSelectionRange(0,$el.val().length);

            } else {
                $('#import-foldername').attr('disabled','true');
            }
        },

        ffBmarkImport: function() {
            var fname,result,bmarks,
            _doImport = function() {
                $('.account-import-submit').attr('selectedIndex','1');
                reksidebar.data.uploadBmarks(reksidebar.Rek.user.id,reksidebar.Rek.user.session,result.bmarks,function(){
                    reksidebar.treeMgr.rekView.reload('rekView',function(){
                        reksidebar.browse.reload(['browse.bmark']);
                        $('.account-import-submit').attr('selectedIndex','0');
                        reksidebar.modal.open({
                            title:'Bookmark Import',
                            icon:'check.png',
                            text:'Your Bookmarks were successfully imported.',
                            buttons:[{
                                label:'Close',
                                callback: function(){
                                    reksidebar.modal.close(this);
                                }
                            }]
                        });
                    });
                });
            };
            fname = $('#account-folder:checked').length?$('#import-foldername').val():null;
            if (!fname) fname = 'Firefox Bookmarks';
            result = reksidebar.data.ffBmarkImport(fname);
            if (result.count > 500) {
                reksidebar.modal.open({
                    title:'Bookmark Import',
                    icon:'exclamation.png',
                    text:'We have detected a large number of bookmarks to import. The import process could take several minutes to complete...',
                    buttons:[{
                        label:'Cancel',
                        callback: function(){
                            reksidebar.modal.close(this);
                        }
                    },{
                        label:'Continue',
                        callback: function(){
                            reksidebar.modal.close(this);
                            _doImport();
                        }
                    }]
                });
            } else {
                _doImport();
            }
        },

        bmarkImport: function() {
            var browse,fname,bmarks,
            _doImport = function() {
                $('.account-import-submit').attr('selectedIndex','1');
                reksidebar.data.bmarkImport($('#account-browser').val(),browse.files[0],fname,function(bmarks){
                    reksidebar.data.uploadBmarks(reksidebar.Rek.user.id,reksidebar.Rek.user.session,bmarks,function(){
                        reksidebar.treeMgr.rekView.reload('rekView',function(){
                            reksidebar.browse.reload(['browse.bmark']);
                            $('.account-import-submit').attr('selectedIndex','0');
                            reksidebar.modal.open({
                                title:'Bookmark Import',
                                icon:'check.png',
                                text:'Your Bookmarks were successfully imported.',
                                buttons:[{
                                    label:'Close',
                                    callback: function(){
                                        reksidebar.modal.close(this);
                                    }
                                }]
                            });
                        });
                    });
                });
            };

            fname = $('#account-folder:checked').length?$('#import-foldername').val():null;
            browse = $('#import-browse')[0];
            if (!fname) fname = 'Bookmark Import';

            if (browse.files.length) {
                if (browse.files[0].size > 100000) {
                    reksidebar.modal.open({
                        title:'Bookmark Import',
                        icon:'exclamation.png',
                        text:'We have detected a large number of bookmarks to import. The import process could take several minutes to complete...',
                        buttons:[{
                            label:'Cancel',
                            callback: function(){
                                reksidebar.modal.close(this);
                            }
                        },{
                            label:'Continue',
                            callback: function(){
                                reksidebar.modal.close(this);
                                _doImport();
                            }
                        }]
                    });
                } else {
                    _doImport();
                }
            } else {
                $('.account-import-submit').attr('selectedIndex','0');
                reksidebar.modal.open({
                    title:'No Valid File',
                    icon:'exclamation.png',
                    text:'You must enter a valid path to a file that contains your bookmarks. Click on help below for instructions specific to your browser.',
                    buttons:[{
                        label:'Help',
                        callback: function(){
                            reksidebar.modal.close(this);
                            reksidebar.Rek.openURL('http://www.rekommend.com');
                        }
                    },{
                        label:'Close',
                        callback: function(){
                            reksidebar.modal.close(this);
                        }
                    }]
                });
            }
        },
        
        fblink: function() {
            var self = this;
            //$('#account-fblink').attr('disabled','true');
            //$('#account-fblink + .loader').removeClass('novis');
            if (reksidebar.Rek.user.loginby == 'rek') {
                // link
                // try to get a fb session
                self.fbfetch(function(fb){
                    if (fb) {
                        reksidebar.Rek.log(fb.id);
                        // found a valid fb session - establish link
                        reksidebar.Rek.db.updateRecord('user',reksidebar.Rek.user.data.id,{
                            fb_id:fb.id
                        });
                        // remove credentials from login manager
                        reksidebar.Rek.purgeLoginCredentials(reksidebar.Rek.user.data.id);
                         reksidebar.Rek.user.loginby = 'facebook';
                        
                        //$('#app-account [tab="0"]').addClass('hidden');
                        //$('#app-account-profile').addClass('novis');
                        $('#app-account-profile-deck').attr('selectedIndex','1');
                        $('#app-account [tab="1"]').addClass('hidden');
                        $('#app-account-password').addClass('novis');
                        reksidebar.showTabboxTab('app-account',0);
                        //$('#account-fblink').attr('label','Unlink');
                    } else {
                        //$('#account-fblink').attr('label','Establish link');
                    }
                    //$('#account-fblink + .loader').addClass('novis');
                    //$('#account-fblink').removeAttr('disabled');
                },true);
            } else {
                // unlink
                // need to make sure we have all the profile stuff
                // need to make sure we have passsword
                $.ajax({
                    type: 'POST',
                    async: true,
                    url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/passwordExist.php',
                    data: {
                        id:reksidebar.Rek.user.id,
                        session:reksidebar.Rek.user.session
                    },
                    dataType: 'json',
                    success: function(json){
                        reksidebar.Rek.log(json);
                        if (json.result == 0) {
                            // no password - get one
                            reksidebar.modal.open({
                                title:'Enter an account password',
                                icon:'exclamation.png',
                                text:'Your reKommend account has been successfully unlinked from Facebook. We have sent you a temporary password that you will need to use next time you log into reKommend.',
                                buttons:[{
                                    label:'OK',
                                    callback: function() {
                                        reksidebar.modal.close(this);
                                    }
                                }]
                            });
                        }
                        $.ajax({
                            type: 'POST',
                            async: true,
                            url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/fbunlink.php',
                            data: {
                                id:reksidebar.Rek.user.id,
                                session:reksidebar.Rek.user.session
                            },
                            dataType: 'text',
                            success: function(json){
                                reksidebar.Rek.log(json);
                                //$('#app-account [tab="0"]').removeClass('hidden');
                                //$('#app-account-profile').removeClass('novis');
                                $('#app-account-profile-deck').attr('selectedIndex','0');
                                $('#app-account [tab="1"]').removeClass('hidden');
                                $('#app-account-password').removeClass('novis');
                                reksidebar.showTabboxTab('app-account',0);
                
                                //$('#account-fblink + .loader').addClass('novis');
                                //$('#account-fblink').removeAttr('disabled');
                                //$('#account-fblink').attr('label','Establish link');
                                
                                reksidebar.Rek.user.loginby = 'rek';
                            },
                            error: function(req,status,error){
                                //$('#account-fblink + .loader').addClass('novis');
                                // check on system status
                                reksidebar.Rek.validateStatus(error);
                            }
                        });
                    },
                    error: function(req,status,error){
                        //$('#account-fblink + .loader').addClass('novis');
                        // check on system status
                        reksidebar.Rek.validateStatus(error);
                    }
                });
            }
        },
        
        fbconnect: function() {
            var self = this;
            $('.fb-connect .loader').removeClass('novis');
            self.fbfetch(function(fb){
                reksidebar.Rek.log(fb);
                if (fb) {
                    $.ajax({
                        type: 'POST',
                        async: true,
                        url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/fbconnect.php',
                        data: {
                            id: fb.id
                        },
                        dataType: 'json',
                        success: function(json){
                            reksidebar.Rek.log(json);
                            $('.fb-connect .loader').addClass('novis');
                            switch (json.result) {
                                case 0:
                                    break;
                                case -1:
                                    // duplicate email address
                                    reksidebar.modal.open({
                                        title:'Duplicate Email Address',
                                        icon:'exclamation.png',
                                        text:'The email address associated with your Facebook account is listed as an active reKommend member. If you want to link your account to Facebook, first login with your reKommend credentials and then \'Link\' in the account tab.',
                                        buttons:[{
                                            label:'OK',
                                            callback: function() {
                                                reksidebar.modal.close(this);
                                            }
                                        }]
                                    });
                                    break;
                                case -2:
                                    // duplicate / non-existent userid
                                    text = fb.username ? 'Your Facebook username <html:b>'+fb.username+'</html:b> is in use by another reKommend user.<html:br/><html:br/>Please chose a reK username so that other users can find you easily.' : '';
                                    reksidebar.modal.open({
                                        id:'fbUsernameDialog',
                                        title:'reKommend Username',
                                        icon:'exclamation.png',
                                        text:text,
                                        buttons:[{
                                            label:'OK',
                                            callback: function() {
                                                reksidebar.modal.close(this);
                                            }
                                        }]
                                    });
                                    break;
                                default:
                                    // success
                                    // login
                                    alert('fblogin');
                                    reksidebar.Rek.fblogin(fb);
                            }
                            
                        },
                        error: function(req,status,error){
                            $('.fb-connect .loader').addClass('novis');
                            // check on system status
                            reksidebar.Rek.validateStatus(reksidebar.Rek.CONST.STATUS_LOGGED_OUT);
                        }
                    });
                } else {
                    // no connect option
                    reksidebar.modal.open({
                        title:'Cannot connect to Facebook',
                        icon:'exclamation.png',
                        text:'No conection to Facebook could be established. Please try again later or sign-up via reKommend.',
                        buttons:[{
                            label:'OK',
                            callback: function() {
                                reksidebar.modal.close(this);
                                $('.fb-connect .loader').addClass('novis');
                            }
                        }]
                    });
                }
            },true);
        },
        
        fbfetch: function(cb,retry) {
            var self = this;
            _fbwait = function(w) {
                counter++;
                if (!w.closed && counter < 240) {
                    setTimeout(function(){
                        _fbwait(w);
                    },500);
                    if (w.document.readyState == 'complete') {
                    //reksidebar.Rek.log('complete');
                    }
                } else {
                    if (retry) self.fbfetch.call(self,cb,false);
                    else cb.call(self,null);
                }
            },
            $.ajax({
                type: 'POST',
                async: true,
                url: reksidebar.Rek.getProperty('httpRequestRoot')+'xhr/fbsession.php',
                dataType: 'json',
                success: function(json){
                    if (json.fb) {
                        // found a facebook session
                        cb.call(self,json.fb);
                    } else {
                        // no facebook session - pop a login window
                        if (retry) {
                            w = window.open(json.fbURL,'facebook login','width=650,height=400,chrome=yes,centerscreen,alwaysRaised=yes,scrollbars=no,menubar=no,toolbar=no,location=no,personalbar=no,resizable=no,status=no');
                            counter = 0;
                            _fbwait(w);
                        } else {
                            cb.call(self,null);
                        }
                    }
                },
                error: function(req,status,error){
                    // check on system status
                    reksidebar.Rek.validateStatus(reksidebar.Rek.CONST.STATUS_LOGGED_OUT);
                    cb.call(null);
                }
            });
        },

        deleteAccount: function() {
            reksidebar.modal.open({
                title:reksidebar.Rek.getProperty('rek.account.deleteTitle'),
                icon:'exclamation.png',
                text:reksidebar.Rek.getProperty('rek.account.deleteText'),
                buttons:[{
                    label:'Delete',
                    callback: function() {
                        reksidebar.Rek.db.updateRecord('user',reksidebar.Rek.user.data.id,{
                            active:0
                        },function(){
                            reksidebar.modal.close(this);
                            reksidebar.modal.open({
                                title:'Account Deleted',
                                icon:'exclamation.png',
                                text:'Your account has been deleted. You will now be logged out of the service.',
                                buttons:[{
                                    label:'OK',
                                    callback: function() {
                                        reksidebar.Rek.logout();
                                        reksidebar.modal.close(this);
                                    }
                                },{
                                    label:'Cancel',
                                    callback: function(){
                                        reksidebar.modal.close(this);
                                    }
                                }]
                            });
                        });
                    }
                },{
                    label:'Cancel',
                    callback: function(){
                        reksidebar.modal.close(this);
                    }
                }]
            });
        }
    }
});
